Unit Controls;

Interface

Uses TypeText,ProtMenu,Objects,GrIP,INI,HexWrite;

Const
  JoyPort          = $201;
  MaxChannelLength = 256;

  { Define interface functions }

  ifPaddle1Left    = $00000001;  { LongInt 1 }
  ifPaddle1Right   = $00000002;
  ifPaddle2Left    = $00000004;
  ifPaddle2Right   = $00000008;
  ifPaddle3Left    = $00000010;
  ifPaddle3Right   = $00000020;
  ifPaddle4Left    = $00000040;
  ifPaddle4Right   = $00000080;
  ifPaddle1Btn     = $00000100;
  ifPaddle2Btn     = $00000200;
  ifPaddle3Btn     = $00000400;
  ifPaddle4Btn     = $00000800;

  ifJoy1Left       = $00001000;
  ifJoy1Right      = $00002000;
  ifJoy1Up         = $00004000;
  ifJoy1Down       = $00008000;
  ifJoy1Btn        = $00010000;

  ifJoy2Left       = $00020000;
  ifJoy2Right      = $00040000;
  ifJoy2Up         = $00080000;
  ifJoy2Down       = $00100000;
  ifJoy2Btn        = $00200000;

  ifCBSBtn1        = $00400000;
  ifCBSBtn2        = $00800000;

  ifDriving1Left   = $01000000;
  ifDriving1Right  = $02000000;
  ifDriving2Left   = $04000000;
  ifDriving2Right  = $08000000;

  ifDriving1Btn    = $10000000;
  ifDriving2Btn    = $20000000;

  ifKB1_1          = $00000001;  { LongInt 2 }
  ifKB1_2          = $00000002;
  ifKB1_3          = $00000004;
  ifKB1_4          = $00000008;
  ifKB1_5          = $00000010;
  ifKB1_6          = $00000020;
  ifKB1_7          = $00000040;
  ifKB1_8          = $00000080;
  ifKB1_9          = $00000100;
  ifKB1_Star       = $00000200;
  ifKB1_0          = $00000400;
  ifKB1_Pound      = $00000800;

  ifKB2_1          = $00001000;
  ifKB2_2          = $00002000;
  ifKB2_3          = $00004000;
  ifKB2_4          = $00008000;
  ifKB2_5          = $00010000;
  ifKB2_6          = $00020000;
  ifKB2_7          = $00040000;
  ifKB2_8          = $00080000;
  ifKB2_9          = $00100000;
  ifKB2_Star       = $00200000;
  ifKB2_0          = $00400000;
  ifKB2_Pound      = $00800000;

  ifReset          = $01000000;
  ifSelect         = $02000000;
  ifDiff1          = $04000000;
  ifDiff2          = $08000000;
  ifColorBW        = $10000000;
  ifPower          = $20000000;

  { Define interface masks }

  imPaddle1Axis    = ifPaddle1Left + ifPaddle1Right;
  imPaddle2Axis    = ifPaddle2Left + ifPaddle2Right;
  imPaddle3Axis    = ifPaddle3Left + ifPaddle3Right;
  imPaddle4Axis    = ifPaddle4Left + ifPaddle4Right;
  imPaddle1        = imPaddle1Axis + ifPaddle1Btn;
  imPaddle2        = imPaddle2Axis + ifPaddle2Btn;
  imPaddle3        = imPaddle3Axis + ifPaddle3Btn;
  imPaddle4        = imPaddle4Axis + ifPaddle4Btn;
  imPaddleAxis     = imPaddle1Axis + imPaddle2Axis + imPaddle3Axis + imPaddle4Axis;
  imPaddleBtn      = ifPaddle1Btn + ifPaddle2Btn + ifPaddle3Btn + ifPaddle4Btn;
  imPaddles        = imPaddleAxis + imPaddleBtn;
  imJoy1X          = ifJoy1Left + ifJoy1Right;
  imJoy1Y          = ifJoy1Up + ifJoy1Down;
  imJoy2X          = ifJoy2Left + ifJoy2Right;
  imJoy2Y          = ifJoy2Up + ifJoy2Down;
  imJoy1           = imJoy1X + imJoy1Y + ifJoy1Btn;
  imJoy2           = imJoy2X + imJoy2Y + ifJoy2Btn;
  imJoyBtn         = ifJoy1Btn + ifJoy2Btn;
  imJoysticks      = imJoy1 + imJoy2;
  imCBS            = ifCBSBtn1 + ifCBSBtn2;
  imDriving1Axis   = ifDriving1Left + ifDriving1Right;
  imDriving2Axis   = ifDriving2Left + ifDriving2Right;
  imDriving1       = imDriving1Axis + ifDriving1Btn;
  imDriving2       = imDriving2Axis + ifDriving2Btn;
  imDrivingAxis    = imDriving1Axis + imDriving2Axis;
  imDrivingBtn     = ifDriving1Btn + ifDriving2Btn;
  imDriving        = imDriving1 + imDriving2;
  imKB1            = ifKB1_1 + ifKB1_2 + ifKB1_3 + ifKB1_4 + ifKB1_5    + ifKB1_6 +
                     ifKB1_7 + ifKB1_8 + ifKB1_9 + ifKB1_0 + ifKB1_Star + ifKB1_Pound;
  imKB2            = ifKB2_1 + ifKB2_2 + ifKB2_3 + ifKB2_4 + ifKB2_5    + ifKB2_6 +
                     ifKB2_7 + ifKB2_8 + ifKB2_9 + ifKB2_0 + ifKB2_Star + ifKB2_Pound;
  imKeyboard       = imKB1 + imKB2;
  imConsole        = ifReset + ifSelect + ifDiff1 + ifDiff2 + ifColorBW + ifPower;
  imAllACaps       = imPaddles + imJoysticks + imCBS + imDriving;
  imAllBCaps       = imKeyboard + imConsole;

  imNoPaddle1Axis  = Not imPaddle1Axis;
  imNoPaddle2Axis  = Not imPaddle2Axis;
  imNoPaddle3Axis  = Not imPaddle3Axis;
  imNoPaddle4Axis  = Not imPaddle4Axis;
  imNoPaddle1      = Not imPaddle1;
  imNoPaddle2      = Not imPaddle2;
  imNoPaddle3      = Not imPaddle3;
  imNoPaddle4      = Not imPaddle4;
  imNoPaddleAxis   = Not imPaddleAxis;
  imNoPaddleBtn    = Not imPaddleBtn;
  imNoPaddles      = Not imPaddles;
  imNoJoy1X        = Not imJoy1X;
  imNoJoy1Y        = Not imJoy1Y;
  imNoJoy2X        = Not imJoy2X;
  imNoJoy2Y        = Not imJoy2Y;
  imNoJoy1         = Not imJoy1;
  imNoJoy2         = Not imJoy2;
  imNoJoyBtn       = Not imJoyBtn;
  imNoJoysticks    = Not imJoysticks;
  imNoCBS          = Not imCBS;
  imNoDriving1Axis = Not imDriving1Axis;
  imNoDriving2Axis = Not imDriving2Axis;
  imNoDriving1     = Not imDriving1;
  imNoDriving2     = Not imDriving2;
  imNoDrivingAxis  = Not imDrivingAxis;
  imNoDrivingBtn   = Not imDrivingBtn;
  imNoDriving      = Not imDriving;
  imNoKB1          = Not imKB1;
  imNoKB2          = Not imKB2;
  imNoKeyboard     = Not imKeyboard;
  imNoConsole      = Not imConsole;

  { Define controller masks }

  cmPaddle1       = imPaddle1Axis + ifPaddle1Btn;
  cmPaddle2       = imPaddle2Axis + ifPaddle2Btn;
  cmPaddle3       = imPaddle3Axis + ifPaddle3Btn;
  cmPaddle4       = imPaddle4Axis + ifPaddle4Btn;
  cmJoy1          = imJoy1;
  cmJoy2          = imJoy2;
  cmBoosterGrip   = imCBS + imJoy1;
  cmDriving1      = imDriving1Axis + ifDriving1Btn;
  cmDriving2      = imDriving2Axis + ifDriving2Btn;
  cmKB1           = imKB1;
  cmKB2           = imKB2;

  { Console flags }

  cfPower   = $01;
  cfReset   = $02;
  cfSelect  = $04;
  cfColorBW = $08;
  cfDiff1   = $10;
  cfDiff2   = $20;

  { Other constants }

  Max_Digital_Con  = 4;
  Max_Digital_Btn  = 25;
  Max_Digital_Axis = 4;
  Max_Digital_Hat  = 4;
  Max_Digital_Thr  = 10;
  Max_Digital_Ana  = 6;

  Max_Joy_Btn   = 8;
  Max_Joy_Axis  = 6;

  Indy500Trans1 : Array[0..3] Of Byte = ($EF,$FF,$DF,$CF);
  Indy500Trans2 : Array[0..3] Of Byte = ($FE,$FF,$FD,$FC);

  { Define analog joystick extensions (Thanks to Vojtech Pavlik, author }
  { of the Linux joystick driver)                                       }

  JS_AN_BUTTONS_CHF    = $01;
  JS_AN_HAT1_CHF       = $02;
  JS_AN_HAT2_CHF       = $04;
  JS_AN_ANY_CHF        = $07;
  JS_AN_HAT_FCS        = $08;
  JS_AN_HATS_ALL       = $0e;
  JS_AN_BUTTON_PXY_X   = $10;
  JS_AN_BUTTON_PXY_Y   = $20;
  JS_AN_BUTTON_PXY_U   = $40;
  JS_AN_BUTTON_PXY_V   = $80;
  JS_AN_BUTTONS_PXY_XY = $30;
  JS_AN_BUTTONS_PXY_UV = $c0;
  JS_AN_BUTTONS_PXY    = $f0;

Type
  TInterfaceName  = String[20];

  TAtariControls  = Record
    PortA   : Byte;
    Console : Byte;
    Pad     : Array[1..4] Of LongInt;
    Input4  : Boolean;
    Input5  : Boolean;
    Driv    : Array[1..2] Of Word;
    CBS1    : Boolean;
    CBS2    : Boolean;
    KB      : LongInt;
  End;

  TCapability = Object
    A: LongInt;
    B: LongInt;
  End; { TCapability }

  { Analog axis record }

  TAxis = Record
    Cap : TCapability;
    Min : LongInt;
    Mid : LongInt;
    Max : LongInt;
  End;

  { Record defining capabilities of standard PC joystick, including     }
  { extended versions such as the Thrustmaster FCS, CH FlightStick Pro, }
  { and other assorted gamepads.                                        }

  TJoystickRec    = Record
    Axis : Array[1..Max_Joy_Axis] Of TAxis;      { Allow for 2 hats      }
    Btn  : Array[1..Max_Joy_Btn] Of TCapability; { Allow up to 8 buttons }
  End;

  { Record defining digital controller capabilities }

  TDigitalRec = Record
    Loaded   : Boolean;
    ClassMap : LongInt;
    NumBtns  : Integer;
    NumAxes  : Integer;
    NumHats  : Integer;
    NumThrs  : Integer;
    NumAnas  : Integer;
    Btn  : Array[1..Max_Digital_Btn]  Of TCapability;
    Axis : Array[1..Max_Digital_Axis] Of TCapability;
    Hat  : Array[1..Max_Digital_Hat]  Of TCapability;
    Thr  : Array[1..Max_Digital_Thr]  Of TAxis;
    Ana  : Array[1..Max_Digital_Ana]  Of TAxis;
  End;

  TDigitalInfoRec = Record
    Buttons  : GRIP_BITFIELD;
    Axis     : Array[1..Max_Digital_Axis] Of Word;
    Hat      : Array[1..Max_Digital_Hat]  Of Word;
    Throttle : Array[1..Max_Digital_Thr]  Of Word;
    Analog   : Array[1..Max_Digital_Ana]  Of Word;
  End;

  { Digital packet types }

  TDigitalPacket = Array[0..MaxChannelLength - 1] Of Byte;
  PDigitalPacketDef = ^TDigitalPacketDef;
  TDigitalPacketDef = Object(TObject)
    Len : Integer;
    Nam : String;          { Name of controller         }
    Def : TDigitalPacket;  { Bit definition (B,X,H,T,A) }
    Num : TDigitalPacket;  { Item number                }
    Bit : TDigitalPacket;  { Bit number                 }
    Flp : TDigitalPacket;  { Bits to reverse polarity   }
    Constructor Init(_Nam: String; Var _Def,_Num,_Bit,_Flp: TDigitalPacket);
  End;

  { TInterface abstract class: VERY emulator-specific }

  PInterface = ^TInterface;
  TInterface = Object(TObject)
    Name     : TInterfaceName;
    Enabled  : Boolean;
    Active   : Boolean;
    Pad      : Array[1..4] Of LongInt;
    ReadMask : Byte;
    Constructor Init(St: String);
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
    Procedure   Activate;                                         Virtual;
    Procedure   Deactivate;                                       Virtual;
    Procedure   SelectAny(X1,X2: Integer; Const Caption: String; Var Cap: TCapability);
    Procedure   SelectAxis(Const Caption: String; Var Cap: TCapability);
    Procedure   GetDigitalAny(On: Boolean;
                              Var Cap: TCapability;
                              Var CapMask: TCapability;
                              Var Controllers: TCapability;
                              Var Info: TAtariControls);          Virtual;
    Procedure   GetAnalog(Min,Mid,Max,Value,XM: LongInt;
                          Var Cap: TCapability;
                          Var CapMask: TCapability;
                          Var Controllers: TCapability;
                          Var Info: TAtariControls);              Virtual;
    Procedure   WriteToPort(B: Byte);                             Virtual;

    { Capability routines }

    Function    UsedCapability(Var Cap: TCapability): Boolean;
    Procedure   ReadCapability(F: PINIFile; Const Section,Ident: String; Var Cap: TCapability);
    Procedure   WriteCapability(F: PINIFile; Const Section,Ident: String; Var Cap: TCapability);
    Procedure   SetAllCapability(Var Cap: TCapability);
    Procedure   AndCapabilities(Var Src,Dest: TCapability);
  End; { TInterface }

  { Interface handler class: emulator non-specific }

  PInterfaceHandler = ^TInterfaceHandler;
  TInterfaceHandler = Object(TObject)
    Stack : PCollection;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);
    Procedure   SaveConfiguration(F: PINIFile);
    Procedure   Configure;
    Procedure   GetControllerInfo(Controllers: TCapability;
                                  Var Info: TAtariControls);
    Procedure   AddInterface(Int: PInterface);
    Procedure   ActivateInterfaces;
    Procedure   DeactivateInterfaces;
    Procedure   SetReadMask(Mask: Byte);
    Procedure   WriteToPort(B: Byte);
  End; { TInterfaceHandler }

  { Subclasses of TInterface: partially emulator-specific }

  PMouseInterface = ^TMouseInterface;
  TMouseInterface = Object(TInterface)
    MouseX    : TAxis;
    MouseY    : TAxis;
    MouseBtn  : Array[1..3] Of TCapability;
    DrivX     : Integer;
    DrivCount : Word;
    DrivAdd   : Integer;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
    Procedure   GetAnalog(Min,Mid,Max,Value,XM: LongInt;
                          Var Cap: TCapability;
                          Var CapMask: TCapability;
                          Var Controllers: TCapability;
                          Var Info: TAtariControls);              Virtual;
  End; { TMouseInterface }

  PKeyboardInterface = ^TKeyboardInterface;
  TKeyboardInterface = Object(TInterface)
    KeyCap : Array[0..$FF] Of TCapability;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
  End; { TKeyboardInterface }

  PJoystickInterface = ^TJoystickInterface;
  TJoystickInterface = Object(TInterface)
  Private
    Procedure   SetupCapabilities;
  Public
    JoyCap    : Array[1..2] Of TJoystickRec;
    Extension : Byte;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
  End; { TJoystickInterface }

  PExternalInterface = ^TExternalInterface;
  TExternalInterface = Object(TInterface)
    LPTCap : Array[0..2] Of TCapability;
    JoyCap : TAxis;
    Wrote  : Byte;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
    Procedure   WriteToPort(B: Byte);                             Virtual;
    Procedure   Deactivate;                                       Virtual;
  End; { TExternalInterface }

  { TDigitalInterface abstract class }

  PDigitalInterface = ^TDigitalInterface;
  TDigitalInterface = Object(TInterface)
    Cap       : Array[1..Max_Digital_Con] Of TDigitalRec;
    ContInfo  : TDigitalInfoRec;
    ConInfo   : TDigitalInfoRec;
    NumDefs   : Integer;
    PacketDef : PCollection;
    Procedure   BtnCallback;                                      Virtual;
    Procedure   AxisCallback;                                     Virtual;
    Procedure   HatCallback;                                      Virtual;
    Procedure   ThrCallback;                                      Virtual;
    Procedure   AnaCallback;                                      Virtual;
    Constructor Init(St: String);
    Destructor  Done;                                             Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
    Procedure   GetControllerInfo(Var Controllers: TCapability;
                                  Var Info: TAtariControls);      Virtual;
    Procedure   RefreshControllers;                               Virtual;
    Function    GetVendorName(Slot: Integer): String;             Virtual;
    Function    GetProductName(Slot: Integer): String;            Virtual;
    Function    GetSlotMap: GRIP_BITFIELD;                        Virtual;
    Function    GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;         Virtual;
    Function    GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX; Virtual;
    Function    GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE; Virtual;
    Function    GetPackedValues(S: GRIP_SLOT; C: GRIP_CLASS; IStart: GRIP_INDEX;
                                IEnd: GRIP_INDEX): GRIP_BITFIELD; Virtual;
    Function    GetValue(S: GRIP_SLOT; C: GRIP_CLASS;
                         I: GRIP_INDEX): GRIP_VALUE;              Virtual;
  End; { TDigitalInterface }

  { Subclasses of TDigitalInterface for digital controllers: }
  { emulator non-specific                                    }

  PGrIPInterface = ^TGrIPInterface;
  TGrIPInterface = Object(TDigitalInterface)
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   Activate;                                         Virtual;
    Procedure   Deactivate;                                       Virtual;
    Procedure   RefreshControllers;                               Virtual;
    Function    GetVendorName(Slot: Integer): String;             Virtual;
    Function    GetProductName(Slot: Integer): String;            Virtual;
    Function    GetSlotMap: GRIP_BITFIELD;                        Virtual;
    Function    GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;         Virtual;
    Function    GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX; Virtual;
    Function    GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE; Virtual;
    Function    GetPackedValues(S: GRIP_SLOT; C: GRIP_CLASS; IStart: GRIP_INDEX;
                                IEnd: GRIP_INDEX): GRIP_BITFIELD; Virtual;
    Function    GetValue(S: GRIP_SLOT; C: GRIP_CLASS;
                         I: GRIP_INDEX): GRIP_VALUE;              Virtual;
  End; { TGrIPInterface }

  PSideWinderInterface = ^TSideWinderInterface;
  TSideWinderInterface = Object(TDigitalInterface)
    PacketLen   : Integer;
    ProdName    : String;
    CMap        : GRIP_BITFIELD;
    Max_Btn     : Integer;
    Max_Axis    : Integer;
    Max_Hat     : Integer;
    Max_Thr     : Integer;
    Max_Ana     : Integer;
    Max_Thr_Val : Integer;
    Max_Ana_Val : Integer;
    ReadTime    : LongInt;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   RefreshControllers;                               Virtual;
    Function    GetVendorName(Slot: Integer): String;             Virtual;
    Function    GetProductName(Slot: Integer): String;            Virtual;
    Function    GetSlotMap: GRIP_BITFIELD;                        Virtual;
    Function    GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;         Virtual;
    Function    GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX; Virtual;
    Function    GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE; Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
    Procedure   Configure;                                        Virtual;
  End; { TSideWinderInterface }

  PLogitechInterface = ^TLogitechInterface;
  TLogitechInterface = Object(TDigitalInterface)
  Private
    Procedure   ReadPacket(Var Packet: TDigitalPacket; Var ChBase1,ChBase2: Word);
  Public
    PacketLen : Array[1..2] Of Integer;
    Constructor Init;
    Destructor  Done;                                             Virtual;
    Procedure   Activate;                                         Virtual;
    Procedure   RefreshControllers;                               Virtual;
    Function    GetVendorName(Slot: Integer): String;             Virtual;
    Function    GetProductName(Slot: Integer): String;            Virtual;
    Function    GetSlotMap: GRIP_BITFIELD;                        Virtual;
    Function    GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;         Virtual;
    Function    GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX; Virtual;
    Function    GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE; Virtual;
    Procedure   LoadConfiguration(F: PINIFile);                   Virtual;
    Procedure   SaveConfiguration(F: PINIFile);                   Virtual;
  End;

  TCallbackType = (cbButton,cbAxis,cbHat,cbThrottle,cbAnalog);
  TCallbackRec = Record
    Menu  : PMenu;
    Slot  : GRIP_SLOT;
    Intf  : PDigitalInterface;
    CType : TCallbackType;
  End; { TCallbackRec }

Var InterfaceHandler: PInterfaceHandler;

Implementation

Uses Crt,MouseX,Keyboard,Strings,Time,AtariDbg;

Type
  TXYPoint = Record
    X,Y: Integer;
  End;
  TJoystickDir = (jdLeft,jdRight,jdUp,jdDown);

Const
  _32BIT_OPERAND = $66;
  JoySamples     = 10;

  PadMask   : Array[1..4] Of LongInt = (imPaddle1,imPaddle2,imPaddle3,imPaddle4);
  PadMaskL  : Array[1..4] Of LongInt = (ifPaddle1Left,ifPaddle2Left,ifPaddle3Left,ifPaddle4Left);
  PadMaskR  : Array[1..4] Of LongInt = (ifPaddle1Right,ifPaddle2Right,ifPaddle3Right,ifPaddle4Right);
  PadMaskA  : Array[1..4] Of LongInt = (imPaddle1Axis,imPaddle2Axis,imPaddle3Axis,imPaddle4Axis);
  PadMaskNA : Array[1..4] Of LongInt = (imNoPaddle1Axis,imNoPaddle2Axis,imNoPaddle3Axis,imNoPaddle4Axis);
  PadMaskB  : Array[1..4] Of LongInt = (ifPaddle1Btn,ifPaddle2Btn,ifPaddle3Btn,ifPaddle4Btn);
  PadBtnOn  : Array[1..4] Of Byte = ($7F,$BF,$F7,$FB);

  JoyMask   : Array[1..2] Of LongInt = (imJoy1,imJoy2);
  JoyMaskL  : Array[1..2] Of LongInt = (ifJoy1Left,ifJoy2Left);
  JoyMaskR  : Array[1..2] Of LongInt = (ifJoy1Right,ifJoy2Right);
  JoyMaskU  : Array[1..2] Of LongInt = (ifJoy1Up,ifJoy2Up);
  JoyMaskD  : Array[1..2] Of LongInt = (ifJoy1Down,ifJoy2Down);
  JoyMaskB  : Array[1..2] Of LongInt = (ifJoy1Btn,ifJoy2Btn);
  JoyMaskX  : Array[1..2] Of LongInt = (imJoy1X,imJoy2X);
  JoyMaskY  : Array[1..2] Of LongInt = (imJoy1Y,imJoy2Y);
  JoyMaskNX : Array[1..2] Of LongInt = (imNoJoy1X,imNoJoy2X);
  JoyMaskNY : Array[1..2] Of LongInt = (imNoJoy1Y,imNoJoy2Y);
  JoyDirOn  : Array[1..2,TJoystickDir] Of Byte = (($BF,$7F,$EF,$DF),($FB,$F7,$FE,$FD));

  DrvMask   : Array[1..2] Of LongInt = (imDriving1,imDriving2);
  DrvMaskA  : Array[1..2] Of LongInt = (imDriving1Axis,imDriving2Axis);
  DrvMaskL  : Array[1..2] Of LongInt = (ifDriving1Left,ifDriving2Left);
  DrvMaskR  : Array[1..2] Of LongInt = (ifDriving1Right,ifDriving2Right);
  DrvMaskB  : Array[1..2] Of LongInt = (ifDriving1Btn,ifDriving2Btn);

Var
  OldExitProc  : Pointer;
  _Win         : PWindow;
  Callback     : TCallbackRec;
  MaxJoyCount  : LongInt;

{$F+}
Procedure CallbackProc;
Begin
  If Callback.Intf <> Nil Then
  Begin
    Case CallBack.CType Of
    cbButton: Callback.Intf^.BtnCallback;
      cbAxis: Callback.Intf^.AxisCallback;
       cbHat: Callback.Intf^.HatCallback;
  cbThrottle: Callback.Intf^.ThrCallback;
    cbAnalog: Callback.Intf^.AnaCallback;
    End; { Case }
  End;
End; { CallbackProc }
{$F-}

Procedure StayPopup(Const St: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St);
  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 2,
            Black,LightGray,Black,LightGray,Black,LightGray,
            DoubleBorder,'','',True));
  _Win^.Display;
  Screen.GotoXY(2,2);
  Screen.Write(St);
End; { StayPopup }

Procedure StayPopup4(St1,St2,St3,St4: String);
Var I,J,X,Y : Integer;
Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St1);
  If Length(St2) > I Then I := Length(St2);
  If Length(St3) > I Then I := Length(St3);
  If Length(St4) > I Then I := Length(St4);
  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  _Win := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 3,
            Black,LightGray,Black,LightGray,Black,LightGray,
            DoubleBorder,'','',True));
  _Win^.Display;
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 1,Screen.TextAttr,St1);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 2,Screen.TextAttr,St2);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 3,Screen.TextAttr,St3);
  Screen.FastWrite(Lo(Screen.WindMin) + 2,Hi(Screen.WindMin) + 4,Screen.TextAttr,St4);
End; { StayPopup4 }

Procedure Popup(St: String);
Var
  W       : PWindow;
  I,J,X,Y : Integer;

Begin
  Screen.TextColor(Black);
  Screen.TextBackground(LightGray);
  I := Length(St);
  X := (MaxX Div 2) - ((I + 4) Div 2);
  Y := MaxY Div 2;
  W := New(PWindow,Init(X,Y - 2,X + I + 3,Y + 3,
         Black,LightGray,Black,LightGray,Black,LightGray,
         DoubleBorder,'','',True));
  W^.Display;
  Screen.GotoXY(2,2);
  Screen.Write(St);
  Sound(880);
  Delay(10);
  NoSound;
  Delay(1000);
  Dispose(W,Done);
End; { Popup }

Procedure JoyStatus(Joy: Integer; Var B: Byte; Var X,Y: LongInt);
{ ------------------------------------------------------------------------- }
{ Returns:                                                                  }
{    BL - JoyStatus                                                         }
{    CX - X1  SI - X2                                                       }
{    DX - Y1  DI - Y2                                                       }
{ ------------------------------------------------------------------------- }
Var
  _B       : Byte;
  _X,_Y    : LongInt;
  MaxCount : LongInt;

Begin
  MaxCount := MaxJoyCount;
  Asm
    DB     _32BIT_OPERAND
    SUB    BX,BX
    DB     _32BIT_OPERAND
    SUB    CX,CX

    MOV    DX,JoyPort
{    CLI}
    SUB    AH,AH

    { Reset delays }

  @L2:
    INC    BX
    CMP    BX,8000
    JE     @L2A
    IN     AL,DX
    TEST   AL,0Fh
    JNZ    @L2
  @L2A:
    DB     _32BIT_OPERAND
    SUB    BX,BX
    DB     _32BIT_OPERAND
    SUB    CX,CX
    DB     _32BIT_OPERAND
    SUB    SI,SI
    DB     _32BIT_OPERAND
    SUB    DI,DI

    SUB    AL,AL
    OUT    DX,AL
    JMP    @L1
  @L1:
    AAA

    { Choose joystick }

    MOV    AH,0Ch
    CMP    WORD PTR Joy,2
    JE     @Use2
    MOV    AH,3
  @Use2:

    { Get coordinates }

  @L3:
    IN     AL,DX
    TEST   AL,1            { Player 1 X coordinate }
    JZ     @L4
    DB     _32BIT_OPERAND
    INC    BX
    JZ     @L6
    DB     _32BIT_OPERAND
    CMP    BX,WORD PTR MaxCount
    JA     @L6
{    CMP    BX,1000h
    JA     @L6}
  @L4:
    TEST   AL,2            { Player 1 Y coordinate }
    JZ     @L5
    DB     _32BIT_OPERAND
    INC    CX
    JZ     @L6
    DB     _32BIT_OPERAND
    CMP    CX,WORD PTR MaxCount
    JA     @L6
{    JC     @L6}
{    CMP    CX,1000h
    JA     @L6}
  @L5:
    IN     AL,DX
    TEST   AL,4            { Player 2 X coordinate }
    JZ     @L4A
    DB     _32BIT_OPERAND
    INC    SI
    JZ     @L6
    DB     _32BIT_OPERAND
    CMP    SI,WORD PTR MaxCount
    JA     @L6
{    CMP    SI,1000h
    JA     @L6}
  @L4A:
    TEST   AL,8            { Player 2 Y coordinate }
    JZ     @L5A
    DB     _32BIT_OPERAND
    INC    DI
    JZ     @L6
    DB     _32BIT_OPERAND
    CMP    DI,WORD PTR MaxCount
    JA     @L6
{    JC     @L6}
{    CMP    DI,1000h
    JA     @L6}
  @L5A:
    TEST   AL,AH
    JNZ    @L3

    { Copy information }

  @L6:
{    STI}

    SHR    AL,4
    XOR    AL,0Fh
    MOV    BYTE PTR _B,AL

    CMP    WORD PTR Joy,2
    JE     @Use2A
    DB     _32BIT_OPERAND
    MOV    WORD PTR _X,BX
    DB     _32BIT_OPERAND
    MOV    WORD PTR _Y,CX
    JMP    @GetOut
@Use2A:
    DB     _32BIT_OPERAND
    MOV    WORD PTR _X,SI
    DB     _32BIT_OPERAND
    MOV    WORD PTR _Y,DI
@GetOut:
  End;
  B := _B;
  X := _X;
  Y := _Y;
End; { JoyStatus }

Procedure JoyStatusButtons(Var B: Byte);
{ ------------------------------------------------------------------------- }
{ Returns:                                                                  }
{    BL - JoyStatus (buttons only)                                          }
{ ------------------------------------------------------------------------- }
Var _B: Byte;
Begin
  Asm
    MOV    DX,JoyPort
    SUB    AH,AH

    { Reset delays }

    SUB    AL,AL
    OUT    DX,AL
    JMP    @L1
  @L1:
    AAA

    { Get buttons }

    IN     AL,DX

    { Copy information }

    SHR    AL,4
    XOR    AL,0Fh
    MOV    BYTE PTR _B,AL
  End;
  B := _B;
End; { JoyStatusButtons }

{ ----------------- }
{ TDigitalPacketDef }
{ ----------------- }

Constructor TDigitalPacketDef.Init(_Nam: String; Var _Def,_Num,_Bit,_Flp: TDigitalPacket);
Begin
  Inherited Init;
  Nam := _Nam;
  Move(_Def,Def,SizeOf(Def));
  Move(_Num,Num,SizeOf(Num));
  Move(_Bit,Bit,SizeOf(Bit));
  Move(_Flp,Flp,SizeOf(Flp));
  Len := 0;
  While _Def[Len] > 32 Do Inc(Len);
End; { TDigitalPacketDef.Init }

{ ----------------- }
{ TInterfaceHandler }
{ ----------------- }

Constructor TInterfaceHandler.Init;
Begin
  Inherited Init;
  Stack := New(PCollection,Init(10,10));
End; { TInterfaceHandler.Init }

Destructor TInterfaceHandler.Done;
Begin
  Dispose(Stack,Done);
  Inherited Done;
End; { TInterfaceHandler.Done }

Procedure TInterfaceHandler.LoadConfiguration(F: PINIFile);
Var I: Integer;
Begin
  I := 0;
  While I < Stack^.Count Do
  Begin
    PInterface(Stack^.At(I))^.LoadConfiguration(F);
    Inc(I);
  End; { While }
End; { TInterfaceHandler.LoadConfiguration }

Procedure TInterfaceHandler.SaveConfiguration(F: PINIFile);
Var I: Integer;
Begin
  I := 0;
  While I < Stack^.Count Do
  Begin
    PInterface(Stack^.At(I))^.SaveConfiguration(F);
    Inc(I);
  End; { While }
End; { TInterfaceHandler.SaveConfiguration }

Procedure TInterfaceHandler.Configure;
Var
  I    : Integer;
  Menu : PMenu;
  P    : PInterface;

Begin
  If Stack^.Count > 0 Then
  Begin
    Menu := New(PMenu,InitWH(34,Stack^.Count + 2,
                Black,LightGray,Black,LightGray,Blue,LightGray,
                Red,LightGray,Black,Green,Red,Green,
                DarkGray,LightGray,DarkGray,Green,
                SingleBorder,' Choose Controller ',
                ' <Enter> selects, <Esc> exits ',True));
    I := 0;
    While I < Stack^.Count Do
    Begin
      P := PInterface(Stack^.At(I));
      Menu^.AddSelection(1,I + 1,32,1,False,False,P^.Name);
      Inc(I);
    End; { While }
    Repeat
      Menu^.Execute;
      If (Menu^.CurSel >= 1) And (Menu^.CurSel <= Stack^.Count) Then
      Begin
        P := PInterface(Stack^.At(Menu^.CurSel - 1));
        P^.Activate;
        If P^.Active Then P^.Configure;
        P^.Deactivate;
      End;
    Until Menu^.CurSel = 0;
    Dispose(Menu,Done);
  End;
End; { TInterfaceHandler.Configure }

Procedure TInterfaceHandler.GetControllerInfo(Controllers: TCapability;
                                              Var Info: TAtariControls);
Var
  I    : Integer;
  Intf : PInterface;

Begin
  I := Stack^.Count - 1;
  While I >= 0 Do
  Begin
    Intf := PInterface(Stack^.At(I));
    If Intf^.Enabled And Intf^.Active Then
     Intf^.GetControllerInfo(Controllers,Info);
    Dec(I);
  End; { While }
End; { TInterfaceHandler.GetControllerInfo }

Procedure TInterfaceHandler.AddInterface(Int: PInterface);
Begin
  Stack^.Insert(Int);
End; { TInterfaceHandler.AddInterface }

Procedure TInterfaceHandler.ActivateInterfaces;
Var
  I    : Integer;
  Intf : PInterface;

Begin
  I := Stack^.Count - 1;
  While I >= 0 Do
  Begin
    Intf := PInterface(Stack^.At(I));
    If Intf^.Enabled Then Intf^.Activate;
    Dec(I);
  End; { While }
End; { TInterfaceHandler.ActivateInterfaces }

Procedure TInterfaceHandler.DeactivateInterfaces;
Var
  I    : Integer;
  Intf : PInterface;

Begin
  I := Stack^.Count - 1;
  While I >= 0 Do
  Begin
    Intf := PInterface(Stack^.At(I));
    If Intf^.Enabled Then Intf^.Deactivate;
    Dec(I);
  End; { While }
End; { TInterfaceHandler.DeactivateInterfaces }

Procedure TInterfaceHandler.SetReadMask(Mask: Byte);
Var
  I    : Integer;
  Intf : PInterface;

Begin
  I := Stack^.Count - 1;
  While I >= 0 Do
  Begin
    Intf := PInterface(Stack^.At(I));
    Intf^.ReadMask := Mask;
    Dec(I);
  End; { While }
End; { TInterfaceHandler.SetReadMask }

Procedure TInterfaceHandler.WriteToPort(B: Byte);
Var
  I    : Integer;
  Intf : PInterface;

Begin
  I := Stack^.Count - 1;
  While I >= 0 Do
  Begin
    Intf := PInterface(Stack^.At(I));
    Intf^.WriteToPort(B);
    Dec(I);
  End; { While }
End; { TInterfaceHandler.WriteToPort }

{ ---------- }
{ TInterface }
{ ---------- }

Constructor TInterface.Init(St: String);
Begin
  Inherited Init;
  Name     := St;
  Enabled  := False;
  Active   := False;
  FillChar(Pad,SizeOf(Pad),#0);
  ReadMask := $FF;  { All bits readable }
End; { TInterface.Init }

Destructor TInterface.Done;
Begin
  Inherited Done;
End; { TInterface.Done }

Function TInterface.UsedCapability(Var Cap: TCapability): Boolean;
Begin
  UsedCapability := (Cap.A <> 0) Or (Cap.B <> 0);
End; { TInterface.UsedCapability }

Procedure TInterface.ReadCapability(F: PINIFile; Const Section,Ident: String; Var Cap: TCapability);
Begin
  Cap.A := F^.ReadInteger(Section,Ident + 'A',0);
  Cap.B := F^.ReadInteger(Section,Ident + 'B',0);
End; { TInterface.ReadCapability }

Procedure TInterface.WriteCapability(F: PINIFile; Const Section,Ident: String; Var Cap: TCapability);
Begin
  F^.WriteInteger(Section,Ident + 'A',Cap.A);
  F^.WriteInteger(Section,Ident + 'B',Cap.B);
End; { TInterface.WriteCapability }

Procedure TInterface.SetAllCapability(Var Cap: TCapability);
Begin
  Cap.A := imAllACaps;
  Cap.B := imAllBCaps;
End; { TInterface.SetAllCapability }

Procedure TInterface.AndCapabilities(Var Src,Dest: TCapability);
Begin
  Dest.A := Dest.A And Src.A;
  Dest.B := Dest.B And Src.B;
End; { TInterface.AndCapabilities }

Procedure TInterface.GetControllerInfo(Var Controllers: TCapability;
                                       Var Info: TAtariControls);
Begin
End; { TInterface.GetControllerInfo }

Procedure TInterface.Configure;
Begin
End; { TInterface.Configure }

Procedure TInterface.LoadConfiguration(F: PINIFile);
Begin
  Enabled := F^.ReadBool(Name,'ENABLED',False);
End; { TInterface.LoadConfiguration }

Procedure TInterface.SaveConfiguration(F: PINIFile);
Begin
  F^.WriteBool(Name,'ENABLED',Enabled);
End; { TInterface.SaveConfiguration }

Procedure TInterface.Activate;
Begin
  Active := True;
End; { TInterface.Activate }

Procedure TInterface.Deactivate;
Begin
  Active := False;
End; { TInterface.Deactivate }

Procedure TInterface.SelectAny(X1,X2: Integer; Const Caption: String; Var Cap: TCapability);
Var
  Menu    : PMenu;
  PadMenu : PMenu;
  JoyMenu : PMenu;
  CBSMenu : PMenu;
  DrvMenu : PMenu;
  KeyMenu : PMenu;
  ConMenu : PMenu;

  Procedure SelPaddle(Pad: Byte);
  Begin
    Repeat
      PadMenu^.GetSelection(1)^.Checked := ((Cap.A And PadMaskL[Pad]) <> 0);
      PadMenu^.GetSelection(2)^.Checked := ((Cap.A And PadMaskR[Pad]) <> 0);
      PadMenu^.GetSelection(3)^.Checked := ((Cap.A And PadMaskB[Pad]) <> 0);
      PadMenu^.Execute;
      If (PadMenu^.CurSel >= 1) And (PadMenu^.CurSel <= 3) Then
      Begin
        Case PadMenu^.CurSel Of
          1: Cap.A := (Cap.A And imNoPaddles) Or PadMaskL[Pad];
          2: Cap.A := (Cap.A And imNoPaddles) Or PadMaskR[Pad];
          3: Cap.A := (Cap.A And imNoPaddles) Or PadMaskB[Pad];
        End; { Case }
      End;
    Until PadMenu^.CurSel = 0;
  End; { SelPaddle }

  Procedure SelJoystick(Joy: Byte);
  Begin
    Repeat
      JoyMenu^.GetSelection(1)^.Checked := ((Cap.A And JoyMaskL[Joy]) <> 0);
      JoyMenu^.GetSelection(2)^.Checked := ((Cap.A And JoyMaskR[Joy]) <> 0);
      JoyMenu^.GetSelection(3)^.Checked := ((Cap.A And JoyMaskU[Joy]) <> 0);
      JoyMenu^.GetSelection(4)^.Checked := ((Cap.A And JoyMaskD[Joy]) <> 0);
      JoyMenu^.GetSelection(5)^.Checked := ((Cap.A And JoyMaskB[Joy]) <> 0);
      JoyMenu^.Execute;
      If (JoyMenu^.CurSel >= 1) And (JoyMenu^.CurSel <= 5) Then
      Begin
        Case JoyMenu^.CurSel Of
          1: Cap.A := (Cap.A And imNoJoysticks) Or JoyMaskL[Joy];
          2: Cap.A := (Cap.A And imNoJoysticks) Or JoyMaskR[Joy];
          3: Cap.A := (Cap.A And imNoJoysticks) Or JoyMaskU[Joy];
          4: Cap.A := (Cap.A And imNoJoysticks) Or JoyMaskD[Joy];
          5: Cap.A := (Cap.A And imNoJoysticks) Or JoyMaskB[Joy];
        End; { Case }
      End;
    Until JoyMenu^.CurSel = 0;
  End; { SelJoystick }

  Procedure SelCBS;
  Begin
    Repeat
      CBSMenu^.GetSelection(1)^.Checked := ((Cap.A And ifCBSBtn1) <> 0);
      CBSMenu^.GetSelection(2)^.Checked := ((Cap.A And ifCBSBtn2) <> 0);
      CBSMenu^.Execute;
      If (CBSMenu^.CurSel >= 1) And (CBSMenu^.CurSel <= 2) Then
      Begin
        Case CBSMenu^.CurSel Of
          1: Cap.A := (Cap.A And imNoCBS) Or ifCBSBtn1;
          2: Cap.A := (Cap.A And imNoCBS) Or ifCBSBtn2;
        End; { Case }
      End;
    Until CBSMenu^.CurSel = 0;
  End; { SelCBS }

  Procedure SelDriving(Drv: Byte);
  Begin
    Repeat
      DrvMenu^.GetSelection(1)^.Checked := ((Cap.A And DrvMaskL[Drv]) <> 0);
      DrvMenu^.GetSelection(2)^.Checked := ((Cap.A And DrvMaskR[Drv]) <> 0);
      DrvMenu^.GetSelection(3)^.Checked := ((Cap.A And DrvMaskB[Drv]) <> 0);
      DrvMenu^.Execute;
      If (DrvMenu^.CurSel >= 1) And (DrvMenu^.CurSel <= 3) Then
      Begin
        Case DrvMenu^.CurSel Of
          1: Cap.A := (Cap.A And imNoDriving) Or DrvMaskL[Drv];
          2: Cap.A := (Cap.A And imNoDriving) Or DrvMaskR[Drv];
          3: Cap.A := (Cap.A And imNoDriving) Or DrvMaskB[Drv];
        End; { Case }
      End;
    Until DrvMenu^.CurSel = 0;
  End; { SelDriving }

  Procedure SelKB(KB: Byte);
  Begin
    Repeat
      Case KB Of
        1: Begin
             KeyMenu^.GetSelection(1)^.Checked  := ((Cap.B And ifKB1_1)     <> 0);
             KeyMenu^.GetSelection(2)^.Checked  := ((Cap.B And ifKB1_4)     <> 0);
             KeyMenu^.GetSelection(3)^.Checked  := ((Cap.B And ifKB1_7)     <> 0);
             KeyMenu^.GetSelection(4)^.Checked  := ((Cap.B And ifKB1_Star)  <> 0);
             KeyMenu^.GetSelection(5)^.Checked  := ((Cap.B And ifKB1_2)     <> 0);
             KeyMenu^.GetSelection(6)^.Checked  := ((Cap.B And ifKB1_5)     <> 0);
             KeyMenu^.GetSelection(7)^.Checked  := ((Cap.B And ifKB1_8)     <> 0);
             KeyMenu^.GetSelection(8)^.Checked  := ((Cap.B And ifKB1_0)     <> 0);
             KeyMenu^.GetSelection(9)^.Checked  := ((Cap.B And ifKB1_3)     <> 0);
             KeyMenu^.GetSelection(10)^.Checked := ((Cap.B And ifKB1_6)     <> 0);
             KeyMenu^.GetSelection(11)^.Checked := ((Cap.B And ifKB1_9)     <> 0);
             KeyMenu^.GetSelection(12)^.Checked := ((Cap.B And ifKB1_Pound) <> 0);
           End;
        2: Begin
             KeyMenu^.GetSelection(1)^.Checked  := ((Cap.B And ifKB2_1)     <> 0);
             KeyMenu^.GetSelection(2)^.Checked  := ((Cap.B And ifKB2_4)     <> 0);
             KeyMenu^.GetSelection(3)^.Checked  := ((Cap.B And ifKB2_7)     <> 0);
             KeyMenu^.GetSelection(4)^.Checked  := ((Cap.B And ifKB2_Star)  <> 0);
             KeyMenu^.GetSelection(5)^.Checked  := ((Cap.B And ifKB2_2)     <> 0);
             KeyMenu^.GetSelection(6)^.Checked  := ((Cap.B And ifKB2_5)     <> 0);
             KeyMenu^.GetSelection(7)^.Checked  := ((Cap.B And ifKB2_8)     <> 0);
             KeyMenu^.GetSelection(8)^.Checked  := ((Cap.B And ifKB2_0)     <> 0);
             KeyMenu^.GetSelection(9)^.Checked  := ((Cap.B And ifKB2_3)     <> 0);
             KeyMenu^.GetSelection(10)^.Checked := ((Cap.B And ifKB2_6)     <> 0);
             KeyMenu^.GetSelection(11)^.Checked := ((Cap.B And ifKB2_9)     <> 0);
             KeyMenu^.GetSelection(12)^.Checked := ((Cap.B And ifKB2_Pound) <> 0);
           End;
      End; { Case }
      KeyMenu^.Execute;
      If (KeyMenu^.CurSel >= 1) And (KeyMenu^.CurSel <= 12) Then
      Begin
        Case KB Of
          1: Begin
               Case KeyMenu^.CurSel Of
                 1: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_1;
                 2: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_4;
                 3: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_7;
                 4: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_Star;
                 5: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_2;
                 6: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_5;
                 7: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_8;
                 8: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_0;
                 9: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_3;
                10: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_6;
                11: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_9;
                12: Cap.B := (Cap.B And imNoKeyboard) Or ifKB1_Pound;
               End; { Case }
             End;
          2: Begin
               Case KeyMenu^.CurSel Of
                 1: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_1;
                 2: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_4;
                 3: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_7;
                 4: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_Star;
                 5: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_2;
                 6: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_5;
                 7: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_8;
                 8: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_0;
                 9: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_3;
                10: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_6;
                11: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_9;
                12: Cap.B := (Cap.B And imNoKeyboard) Or ifKB2_Pound;
               End; { Case }
             End;
        End; { Case }
      End;
    Until KeyMenu^.CurSel = 0;
  End; { SelKB }

  Procedure SelConsole;
  Begin
    Repeat
      ConMenu^.GetSelection(1)^.Checked := ((Cap.B And ifPower)   <> 0);
      ConMenu^.GetSelection(2)^.Checked := ((Cap.B And ifReset)   <> 0);
      ConMenu^.GetSelection(3)^.Checked := ((Cap.B And ifSelect)  <> 0);
      ConMenu^.GetSelection(4)^.Checked := ((Cap.B And ifColorBW) <> 0);
      ConMenu^.GetSelection(5)^.Checked := ((Cap.B And ifDiff1)   <> 0);
      ConMenu^.GetSelection(6)^.Checked := ((Cap.B And ifDiff2)   <> 0);

      ConMenu^.Execute;
      If (ConMenu^.CurSel >= 1) And (ConMenu^.CurSel <= 6) Then
      Begin
        Case ConMenu^.CurSel Of
          1: Cap.B := (Cap.B And imNoConsole) Or ifPower;
          2: Cap.B := (Cap.B And imNoConsole) Or ifReset;
          3: Cap.B := (Cap.B And imNoConsole) Or ifSelect;
          4: Cap.B := (Cap.B And imNoConsole) Or ifColorBW;
          5: Cap.B := (Cap.B And imNoConsole) Or ifDiff1;
          6: Cap.B := (Cap.B And imNoConsole) Or ifDiff2;
        End; { Case }
      End;
    Until ConMenu^.CurSel = 0;
  End; { SelConsole }

  Procedure SelNone;
  Begin
    FillChar(Cap,SizeOf(Cap),#0);
  End; { SelNone }

Begin

  { Controller menu }

  Menu := New(PMenu,InitWH(34,15,
            Black,LightGray,Black,LightGray,Blue,LightGray,
            Red,LightGray,Black,Green,Red,Green,
            DarkGray,LightGray,DarkGray,Green,
            SingleBorder,Caption,
            ' <Enter> selects, <Esc> exits ',True));
  Menu^.AddSelection(1, 1,32,1,False,False,'  Paddle 1');
  Menu^.AddSelection(1, 2,32,1,False,False,'  Paddle 2');
  Menu^.AddSelection(1, 3,32,1,False,False,'  Paddle 3');
  Menu^.AddSelection(1, 4,32,1,False,False,'  Paddle 4');
  Menu^.AddSelection(1, 5,32,1,False,False,'  Joystick 1');
  Menu^.AddSelection(1, 6,32,1,False,False,'  Joystick 2');
  Menu^.AddSelection(1, 7,32,1,False,False,'  CBS Booster-Grip');
  Menu^.AddSelection(1, 8,32,1,False,False,'  Driving 1');
  Menu^.AddSelection(1, 9,32,1,False,False,'  Driving 2');
  Menu^.AddSelection(1,10,32,1,False,False,'  Keyboard 1');
  Menu^.AddSelection(1,11,32,1,False,False,'  Keyboard 2/Video Touch Pad');
  Menu^.AddSelection(1,12,32,1,False,False,'  Console switches');
  Menu^.AddSelection(1,13,32,1,False,False,'  None');

  { Paddle menu }

  PadMenu := New(PMenu,InitWH(34,5,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Paddle ',
                 ' <Enter> selects, <Esc> exits ',True));
  PadMenu^.AddSelection(1,1,32,1,False,False,'  Left');
  PadMenu^.AddSelection(1,2,32,1,False,False,'  Right');
  PadMenu^.AddSelection(1,3,32,1,False,False,'  Button');

  { Joystick menu }

  JoyMenu := New(PMenu,InitWH(34,7,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Joystick ',
                 ' <Enter> selects, <Esc> exits ',True));
  JoyMenu^.AddSelection(1,1,32,1,False,False,'  Left');
  JoyMenu^.AddSelection(1,2,32,1,False,False,'  Right');
  JoyMenu^.AddSelection(1,3,32,1,False,False,'  Up');
  JoyMenu^.AddSelection(1,4,32,1,False,False,'  Down');
  JoyMenu^.AddSelection(1,5,32,1,False,False,'  Button');

  { CBS Booster-Grip menu }

  CBSMenu := New(PMenu,InitWH(34,4,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' CBS Booster-Grip ',
                 ' <Enter> selects, <Esc> exits ',True));
  CBSMenu^.AddSelection(1,1,32,1,False,False,'  Button 1');
  CBSMenu^.AddSelection(1,2,32,1,False,False,'  Button 2');

  { Driving controller menu }

  DrvMenu := New(PMenu,InitWH(34,5,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Driving Controller ',
                 ' <Enter> selects, <Esc> exits ',True));
  DrvMenu^.AddSelection(1,1,32,1,False,False,'  Left');
  DrvMenu^.AddSelection(1,2,32,1,False,False,'  Right');
  DrvMenu^.AddSelection(1,3,32,1,False,False,'  Button');

  { Keyboard controller menu }

  KeyMenu := New(PMenu,InitWH(35,6,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Keyboard Controller ',
                 ' <Enter> selects, <Esc> exits ',True));
  KeyMenu^.AddSelection(1, 1,3,1,False,False,'  (1)');
  KeyMenu^.AddSelection(1, 2,3,1,False,False,'  (4)');
  KeyMenu^.AddSelection(1, 3,3,1,False,False,'  (7)');
  KeyMenu^.AddSelection(1, 4,3,1,False,False,'  (*)');
  KeyMenu^.AddSelection(14,1,3,1,False,False,'  (2)');
  KeyMenu^.AddSelection(14,2,3,1,False,False,'  (5)');
  KeyMenu^.AddSelection(14,3,3,1,False,False,'  (8)');
  KeyMenu^.AddSelection(14,4,3,1,False,False,'  (0)');
  KeyMenu^.AddSelection(29,1,3,1,False,False,'  (3)');
  KeyMenu^.AddSelection(29,2,3,1,False,False,'  (6)');
  KeyMenu^.AddSelection(29,3,3,1,False,False,'  (9)');
  KeyMenu^.AddSelection(29,4,3,1,False,False,'  (#)');

  { Console switches menu }

  ConMenu := New(PMenu,InitWH(34,8,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Console switches ',
                 ' <Enter> selects, <Esc> exits ',True));
  ConMenu^.AddSelection(1,1,32,1,False,False,'  Power');
  ConMenu^.AddSelection(1,2,32,1,False,False,'  Reset');
  ConMenu^.AddSelection(1,3,32,1,False,False,'  Select');
  ConMenu^.AddSelection(1,4,32,1,False,False,'  Color/BW');
  ConMenu^.AddSelection(1,5,32,1,False,False,'  Player 1 Difficulty');
  ConMenu^.AddSelection(1,6,32,1,False,False,'  Player 2 Difficulty');

  If X1 > 0 Then Menu^.X1 := X1;
  If X2 > 0 Then Menu^.X2 := X2;
  Repeat
    Menu^.GetSelection(1)^.Checked  := ((Cap.A And cmPaddle1)  <> 0);
    Menu^.GetSelection(2)^.Checked  := ((Cap.A And cmPaddle2)  <> 0);
    Menu^.GetSelection(3)^.Checked  := ((Cap.A And cmPaddle3)  <> 0);
    Menu^.GetSelection(4)^.Checked  := ((Cap.A And cmPaddle4)  <> 0);
    Menu^.GetSelection(5)^.Checked  := ((Cap.A And cmJoy1)     <> 0);
    Menu^.GetSelection(6)^.Checked  := ((Cap.A And cmJoy2)     <> 0);
    Menu^.GetSelection(7)^.Checked  := ((Cap.A And imCBS)      <> 0);
    Menu^.GetSelection(8)^.Checked  := ((Cap.A And cmDriving1) <> 0);
    Menu^.GetSelection(9)^.Checked  := ((Cap.A And cmDriving2) <> 0);
    Menu^.GetSelection(10)^.Checked := ((Cap.B And cmKB1)      <> 0);
    Menu^.GetSelection(11)^.Checked := ((Cap.B And cmKB2)      <> 0);
    Menu^.GetSelection(12)^.Checked := ((Cap.B And imConsole)  <> 0);
    Menu^.GetSelection(13)^.Checked := ((Cap.A = 0) And (Cap.B = 0));
    Menu^.Execute;
    If (Menu^.CurSel >= 1) And (Menu^.CurSel <= 13) Then
    Begin
      Case Menu^.CurSel Of
     1..4: SelPaddle(Menu^.CurSel);
        5: SelJoystick(1);
        6: SelJoystick(2);
        7: SelCBS;
        8: SelDriving(1);
        9: SelDriving(2);
       10: SelKB(1);
       11: SelKB(2);
       12: SelConsole;
       13: SelNone;
      End; { Case }
    End;
  Until Menu^.CurSel = 0;
  Dispose(ConMenu,Done);
  Dispose(KeyMenu,Done);
  Dispose(DrvMenu,Done);
  Dispose(CBSMenu,Done);
  Dispose(JoyMenu,Done);
  Dispose(PadMenu,Done);
  Dispose(Menu,Done);
End; { TInterface.SelectAny }

Procedure TInterface.SelectAxis(Const Caption: String; Var Cap: TCapability);
Var ConMenu: PMenu;

  Procedure SelectController(Var Cap: TCapability);
  Begin
    Repeat
      ConMenu^.GetSelection(1)^.Checked  := ((Cap.A And imPaddle1Axis) <> 0);
      ConMenu^.GetSelection(2)^.Checked  := ((Cap.A And imPaddle2Axis) <> 0);
      ConMenu^.GetSelection(3)^.Checked  := ((Cap.A And imPaddle3Axis) <> 0);
      ConMenu^.GetSelection(4)^.Checked  := ((Cap.A And imPaddle4Axis) <> 0);
      ConMenu^.GetSelection(5)^.Checked  := ((Cap.A And imJoy1X)       <> 0);
      ConMenu^.GetSelection(6)^.Checked  := ((Cap.A And imJoy1Y)       <> 0);
      ConMenu^.GetSelection(7)^.Checked  := ((Cap.A And imJoy2X)       <> 0);
      ConMenu^.GetSelection(8)^.Checked  := ((Cap.A And imJoy2Y)       <> 0);
      ConMenu^.GetSelection(9)^.Checked  := ((Cap.A And imDriving1)    <> 0);
      ConMenu^.GetSelection(10)^.Checked := ((Cap.A And imDriving2)    <> 0);
      ConMenu^.GetSelection(11)^.Checked := (Cap.A = 0);
      ConMenu^.Execute;
      If ConMenu^.CurSel > 0 Then
      Begin
        Case ConMenu^.CurSel Of
       1..4: Cap.A := (Cap.A And imNoPaddles) Or
                     ((Cap.A And PadMaskA[ConMenu^.CurSel]) Xor PadMaskA[ConMenu^.CurSel]);
          5: Cap.A := (Cap.A And imNoJoysticks) Or
                     ((Cap.A And imJoy1X) Xor imJoy1X);
          6: Cap.A := (Cap.A And imNoJoysticks) Or
                     ((Cap.A And imJoy1Y) Xor imJoy1Y);
          7: Cap.A := (Cap.A And imNoJoysticks) Or
                     ((Cap.A And imJoy2X) Xor imJoy2X);
          8: Cap.A := (Cap.A And imNoJoysticks) Or
                     ((Cap.A And imJoy2Y) Xor imJoy2Y);
          9: Cap.A := (Cap.A And imNoDriving) Or
                     ((Cap.A And imDriving1) Xor imDriving1);
         10: Cap.A := (Cap.A And imNoDriving) Or
                     ((Cap.A And imDriving2) Xor imDriving2);
         11: Cap.A := 0;
        End; { Case }
      End;
    Until ConMenu^.CurSel = 0;
  End; { SelectController }

Begin
  ConMenu := New(PMenu,InitWH(34,13,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,Caption,
                 ' <Enter> selects, <Esc> exits ',True));
  ConMenu^.AddSelection(1, 1,32,1,False,False,'  Paddle 1');
  ConMenu^.AddSelection(1, 2,32,1,False,False,'  Paddle 2');
  ConMenu^.AddSelection(1, 3,32,1,False,False,'  Paddle 3');
  ConMenu^.AddSelection(1, 4,32,1,False,False,'  Paddle 4');
  ConMenu^.AddSelection(1, 5,32,1,False,False,'  Joystick 1 X Axis');
  ConMenu^.AddSelection(1, 6,32,1,False,False,'  Joystick 1 Y Axis');
  ConMenu^.AddSelection(1, 7,32,1,False,False,'  Joystick 2 X Axis');
  ConMenu^.AddSelection(1, 8,32,1,False,False,'  Joystick 2 Y Axis');
  ConMenu^.AddSelection(1, 9,32,1,False,False,'  Driving 1');
  ConMenu^.AddSelection(1,10,32,1,False,False,'  Driving 2');
  ConMenu^.AddSelection(1,11,32,1,False,False,'  None');
  SelectController(Cap);
  Dispose(ConMenu,Done);
End; { TInterface.SelectAxis }

Procedure TInterface.GetDigitalAny(On: Boolean;
                                   Var Cap: TCapability;
                                   Var CapMask: TCapability;
                                   Var Controllers: TCapability;
                                   Var Info: TAtariControls);
Const
  PadInc = 100;
  PadMax = Trunc(3.1 * 6.4 * 800);

Var I: Integer;
Begin

  { Paddles }

  For I := 1 To 4 Do
  Begin
    If ((Cap.A          And PadMask[I]) <> 0) And
       ((Controllers.A  And PadMask[I]) <> 0) Then
    Begin
      If ((Cap.A         And PadMaskL[I]) <> 0) And
         ((Controllers.A And PadMask[I]) <> 0) Then
      Begin
        If On Then
        Begin
          Info.Pad[I] := Pad[I] + PadInc;
          If Info.Pad[I] >= PadMax Then Info.Pad[I] := 0;
          Pad[I] := Info.Pad[I];
        End
        Else Info.Pad[I] := Pad[I];
        CapMask.A := CapMask.A And (Not PadMaskL[I]);
      End;
      If ((Cap.A         And PadMaskR[I]) <> 0) And
         ((Controllers.A And PadMaskR[I]) <> 0) Then
      Begin
        If On Then
        Begin
          Info.Pad[I] := Pad[I] - PadInc;
          If Info.Pad[I] < 0 Then Info.Pad[I] := PadMax;
          Pad[I] := Info.Pad[I];
        End
        Else Info.Pad[I] := Pad[I];
        CapMask.A := CapMask.A And (Not PadMaskR[I]);
      End;
      If ((Cap.A         And PadMaskB[I]) <> 0) And
         ((Controllers.A And PadMaskB[I]) <> 0) Then
      Begin
        If On Then Info.PortA := Info.PortA And PadBtnOn[I];
        CapMask.A := CapMask.A And (Not PadMaskB[I]);
      End;
    End;
  End; { For I }

  { Joysticks }

  For I := 1 To 2 Do
  Begin
    If ((Cap.A         And JoyMask[I]) <> 0) And
       ((Controllers.A And JoyMask[I]) <> 0) Then
    Begin
      If ((Cap.A         And JoyMaskL[I]) <> 0) And
         ((Controllers.A And JoyMaskL[I]) <> 0) Then
      Begin
        If On Then Info.PortA := Info.PortA And JoyDirOn[I,jdLeft];
        CapMask.A := CapMask.A And (Not JoyMaskL[I]);
      End;
      If ((Cap.A         And JoyMaskR[I]) <> 0) And
         ((Controllers.A And JoyMaskR[I]) <> 0) Then
      Begin
        If On Then Info.PortA := Info.PortA And JoyDirOn[I,jdRight];
        CapMask.A := CapMask.A And (Not JoyMaskR[I]);
      End;
      If ((Cap.A         And JoyMaskU[I]) <> 0) And
         ((Controllers.A And JoyMaskU[I]) <> 0) Then
      Begin
        If On Then Info.PortA := Info.PortA And JoyDirOn[I,jdUp];
        CapMask.A := CapMask.A And (Not JoyMaskU[I]);
      End;
      If ((Cap.A         And JoyMaskD[I]) <> 0) And
         ((Controllers.A And JoyMaskD[I]) <> 0) Then
      Begin
        If On Then Info.PortA := Info.PortA And JoyDirOn[I,jdDown];
        CapMask.A := CapMask.A And (Not JoyMaskD[I]);
      End;
      If ((Cap.A         And JoyMaskB[I]) <> 0) And
         ((Controllers.A And JoyMaskB[I]) <> 0) Then
      Begin
        If On Then
        Begin
          If I = 1 Then Info.Input4 := True Else Info.Input5 := True;
        End;
        CapMask.A := CapMask.A And (Not JoyMaskB[I]);
      End;
    End;
  End; { For I }

  { CBS Booster-Grip }

  If ((Cap.A         And imCBS) <> 0) And
     ((Controllers.A And imCBS) <> 0) Then
  Begin
    If ((Cap.A         And ifCBSBtn1) <> 0) And
       ((Controllers.A And ifCBSBtn1) <> 0) Then
    Begin
      If On Then Info.CBS1 := True;
      CapMask.A := CapMask.A And (Not ifCBSBtn1);
    End;
    If ((Cap.A         And ifCBSBtn2) <> 0) And
       ((Controllers.A And ifCBSBtn2) <> 0) Then
    Begin
      If On Then Info.CBS2 := True;
      CapMask.A := CapMask.A And (Not ifCBSBtn2);
    End;
  End;

  { Driving controllers }

  For I := 1 To 2 Do
  Begin
    If ((Cap.A         And DrvMask[I]) <> 0) And
       ((Controllers.A And DrvMask[I]) <> 0) Then
    Begin
      If ((Cap.A         And DrvMaskL[I]) <> 0) And
         ((Controllers.A And DrvMaskL[I]) <> 0) Then
      Begin
        If On Then Dec(Info.Driv[I],3);
        CapMask.A := CapMask.A And (Not DrvMaskL[I]);
      End;
      If ((Cap.A         And DrvMaskR[I]) <> 0) And
         ((Controllers.A And DrvMaskR[I]) <> 0) Then
      Begin
        If On Then Inc(Info.Driv[I],3);
        CapMask.A := CapMask.A And (Not DrvMaskR[I]);
      End;
      If ((Cap.A         And DrvMaskB[I]) <> 0) And
         ((Controllers.A And DrvMaskB[I]) <> 0) Then
      Begin
        If On Then
        Begin
          If I = 1 Then Info.Input4 := True Else Info.Input5 := True;
        End;
        CapMask.A := CapMask.A And (Not DrvMaskB[I]);
      End;
    End;
  End; { For I }

  { Keyboard controller 1 }

  If ((Cap.B         And imKB1) <> 0) And
     ((Controllers.B And imKB1) <> 0) Then
  Begin
    If ((Cap.B         And ifKB1_1) <> 0) And
       ((Controllers.B And ifKB1_1) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000010;
      CapMask.B := CapMask.B And (Not ifKB1_1);
    End;
    If ((Cap.B         And ifKB1_4) <> 0) And
       ((Controllers.B And ifKB1_4) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000020;
      CapMask.B := CapMask.B And (Not ifKB1_4);
    End;
    If ((Cap.B         And ifKB1_7) <> 0) And
       ((Controllers.B And ifKB1_7) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000040;
      CapMask.B := CapMask.B And (Not ifKB1_7);
    End;
    If ((Cap.B         And ifKB1_Star) <> 0) And
       ((Controllers.B And ifKB1_Star) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000080;
      CapMask.B := CapMask.B And (Not ifKB1_Star);
    End;
    If ((Cap.B         And ifKB1_2) <> 0) And
       ((Controllers.B And ifKB1_2) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00001000;
      CapMask.B := CapMask.B And (Not ifKB1_2);
    End;
    If ((Cap.B         And ifKB1_5) <> 0) And
       ((Controllers.B And ifKB1_5) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00002000;
      CapMask.B := CapMask.B And (Not ifKB1_5);
    End;
    If ((Cap.B         And ifKB1_8) <> 0) And
       ((Controllers.B And ifKB1_8) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00004000;
      CapMask.B := CapMask.B And (Not ifKB1_8);
    End;
    If ((Cap.B         And ifKB1_0) <> 0) And
       ((Controllers.B And ifKB1_0) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00008000;
      CapMask.B := CapMask.B And (Not ifKB1_0);
    End;
    If ((Cap.B         And ifKB1_3) <> 0) And
       ((Controllers.B And ifKB1_3) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00100000;
      CapMask.B := CapMask.B And (Not ifKB1_3);
    End;
    If ((Cap.B         And ifKB1_6) <> 0) And
       ((Controllers.B And ifKB1_6) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00200000;
      CapMask.B := CapMask.B And (Not ifKB1_6);
    End;
    If ((Cap.B         And ifKB1_9) <> 0) And
       ((Controllers.B And ifKB1_9) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00400000;
      CapMask.B := CapMask.B And (Not ifKB1_9);
    End;
    If ((Cap.B         And ifKB1_Pound) <> 0) And
       ((Controllers.B And ifKB1_Pound) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00800000;
      CapMask.B := CapMask.B And (Not ifKB1_Pound);
    End;
  End;

  { Keyboard controller 2 }

  If ((Cap.B         And imKB2) <> 0) And
     ((Controllers.B And imKB2) <> 0) Then
  Begin
    If ((Cap.B         And ifKB2_1) <> 0) And
       ((Controllers.B And ifKB2_1) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000001;
      CapMask.B := CapMask.B And (Not ifKB2_1);
    End;
    If ((Cap.B         And ifKB2_4) <> 0) And
       ((Controllers.B And ifKB2_4) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000002;
      CapMask.B := CapMask.B And (Not ifKB2_4);
    End;
    If ((Cap.B         And ifKB2_7) <> 0) And
       ((Controllers.B And ifKB2_7) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000004;
      CapMask.B := CapMask.B And (Not ifKB2_7);
    End;
    If ((Cap.B         And ifKB2_Star) <> 0) And
       ((Controllers.B And ifKB2_Star) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000008;
      CapMask.B := CapMask.B And (Not ifKB2_Star);
    End;
    If ((Cap.B         And ifKB2_2) <> 0) And
       ((Controllers.B And ifKB2_2) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000100;
      CapMask.B := CapMask.B And (Not ifKB2_2);
    End;
    If ((Cap.B         And ifKB2_5) <> 0) And
       ((Controllers.B And ifKB2_5) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000200;
      CapMask.B := CapMask.B And (Not ifKB2_5);
    End;
    If ((Cap.B         And ifKB2_8) <> 0) And
       ((Controllers.B And ifKB2_8) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000400;
      CapMask.B := CapMask.B And (Not ifKB2_8);
    End;
    If ((Cap.B         And ifKB2_0) <> 0) And
       ((Controllers.B And ifKB2_0) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00000800;
      CapMask.B := CapMask.B And (Not ifKB2_0);
    End;
    If ((Cap.B         And ifKB2_3) <> 0) And
       ((Controllers.B And ifKB2_3) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00010000;
      CapMask.B := CapMask.B And (Not ifKB2_3);
    End;
    If ((Cap.B         And ifKB2_6) <> 0) And
       ((Controllers.B And ifKB2_6) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00020000;
      CapMask.B := CapMask.B And (Not ifKB2_6);
    End;
    If ((Cap.B         And ifKB2_9) <> 0) And
       ((Controllers.B And ifKB2_9) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00040000;
      CapMask.B := CapMask.B And (Not ifKB2_9);
    End;
    If ((Cap.B         And ifKB2_Pound) <> 0) And
       ((Controllers.B And ifKB2_Pound) <> 0) Then
    Begin
      If On Then Info.KB := Info.KB Or  $00080000;
      CapMask.B := CapMask.B And (Not ifKB2_Pound);
    End;
  End;

  { Console switches }

  If ((Cap.B         And imConsole) <> 0) And
     ((Controllers.B And imConsole) <> 0) Then
  Begin
    If ((Cap.B         And ifPower) <> 0) And
       ((Controllers.B And ifPower) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfPower;
      CapMask.B := CapMask.B And (Not ifPower);
    End;
    If ((Cap.B         And ifReset) <> 0) And
       ((Controllers.B And ifReset) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfReset;
      CapMask.B := CapMask.B And (Not ifReset);
    End;
    If ((Cap.B         And ifSelect) <> 0) And
       ((Controllers.B And ifSelect) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfSelect;
      CapMask.B := CapMask.B And (Not ifSelect);
    End;
    If ((Cap.B         And ifColorBW) <> 0) And
       ((Controllers.B And ifColorBW) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfColorBW;
      CapMask.B := CapMask.B And (Not ifColorBW);
    End;
    If ((Cap.B         And ifDiff1) <> 0) And
       ((Controllers.B And ifDiff1) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfDiff1;
      CapMask.B := CapMask.B And (Not ifDiff1);
    End;
    If ((Cap.B         And ifDiff2) <> 0) And
       ((Controllers.B And ifDiff2) <> 0) Then
    Begin
      If On Then Info.Console := Info.Console Or cfDiff2;
      CapMask.B := CapMask.B And (Not ifDiff2);
    End;
  End;
End; { TInterface.GetDigitalAny }

Procedure TInterface.GetAnalog(Min,Mid,Max,Value,XM: LongInt;
                               Var Cap: TCapability;
                               Var CapMask: TCapability;
                               Var Controllers: TCapability;
                               Var Info: TAtariControls);
Var
  PadGround : LongInt;
  I         : Integer;

Begin
  If Max = 0 Then Exit;
  PadGround := Round(27 * (640 / Max) * (Max - Value));

  { Paddle controllers }

  For I := 1 To 4 Do
  Begin
    If ((Cap.A         And PadMaskA[I]) <> 0) And
       ((Controllers.A And PadMaskA[I]) <> 0) Then
    Begin
      Info.Pad[I] := PadGround;
      CapMask.A   := CapMask.A And PadMaskNA[I];
    End;
  End; { For I }

  { Joysticks }

  For I := 1 To 2 Do
  Begin
    If ((Cap.A         And JoyMaskX[I]) <> 0) And
       ((Controllers.A And JoyMaskX[I]) <> 0) Then
    Begin
      If (Value <= (Min + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdLeft];
      If (Value >= (Max + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdRight];
      CapMask.A := CapMask.A And JoyMaskNX[I];
    End;
    If ((Cap.A         And JoyMaskY[I]) <> 0) And
       ((Controllers.A And JoyMaskY[I]) <> 0) Then
    Begin
      If (Value <= (Min + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdUp];
      If (Value >= (Max + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdDown];
      CapMask.A := CapMask.A And JoyMaskNY[I];
    End;
  End; { For I }

  { Driving controllers }

  For I := 1 To 2 Do
  Begin
    If ((Cap.A         And DrvMaskA[I]) <> 0) And
       ((Controllers.A And DrvMaskA[I]) <> 0) Then
    Begin
      If (Value <= (Min + Mid) Div 2) Then Dec(Info.Driv[I],3);
      If (Value >= (Max + Mid) Div 2) Then Inc(Info.Driv[I],3);
      CapMask.A := CapMask.A And (Not DrvMaskA[I]);
    End;
  End; { For I }
End; { TInterface.GetAnalog }

Procedure TInterface.WriteToPort(B: Byte);
Begin
End; { TInterface.WriteToPort }

{ --------------- }
{ TMouseInterface }
{ --------------- }

Constructor TMouseInterface.Init;
Var MX,MY,MB: LongInt;
Begin
  Inherited Init('Mouse');
  FillChar(MouseX,SizeOf(MouseX),#0);
  FillChar(MouseY,SizeOf(MouseY),#0);
  FillChar(MouseBtn,SizeOf(MouseBtn),#0);
  MouseX.Min := 0;
  MouseY.Min := 0;
  MouseX.Mid := MScreenWidth;
  MouseY.Mid := MScreenHeight;
  MouseX.Max := MScreenWidth  * 2;
  MouseY.Max := MScreenHeight * 2;
  DrivX      := 99;
  DrivCount  := 0;
  DrivAdd    := 0;
  MX         := 0;
  MY         := 0;
  MB         := 0;
  GetMousePosition(MX,MY,MB);
End; { TMouseInterface.Init }

Destructor TMouseInterface.Done;
Begin
  Inherited Done;
End; { TMouseInterface.Done }

Procedure TMouseInterface.LoadConfiguration(F: PINIFile);
Begin
  Inherited LoadConfiguration(F);
  ReadCapability(F,Name,'X',MouseX.Cap);
  MouseX.Min   := F^.ReadInteger(Name,'XMIN',0);
  MouseX.Mid   := F^.ReadInteger(Name,'XMID',0);
  MouseX.Max   := F^.ReadInteger(Name,'XMAX',0);

  ReadCapability(F,Name,'Y',MouseY.Cap);
  MouseY.Min   := F^.ReadInteger(Name,'YMIN',0);
  MouseY.Mid   := F^.ReadInteger(Name,'YMID',0);
  MouseY.Max   := F^.ReadInteger(Name,'YMAX',0);

  ReadCapability(F,Name,'B1',MouseBtn[1]);
  ReadCapability(F,Name,'B2',MouseBtn[2]);
  ReadCapability(F,Name,'B3',MouseBtn[3]);
End; { TMouseInterface.LoadConfiguration }

Procedure TMouseInterface.SaveConfiguration(F: PINIFile);
Begin
  Inherited SaveConfiguration(F);

  WriteCapability(F,Name,'X',MouseX.Cap);
  F^.WriteInteger(Name,'XMIN',MouseX.Min);
  F^.WriteInteger(Name,'XMID',MouseX.Mid);
  F^.WriteInteger(Name,'XMAX',MouseX.Max);

  WriteCapability(F,Name,'Y',MouseY.Cap);
  F^.WriteInteger(Name,'YMIN',MouseY.Min);
  F^.WriteInteger(Name,'YMID',MouseY.Mid);
  F^.WriteInteger(Name,'YMAX',MouseY.Max);

  WriteCapability(F,Name,'B1',MouseBtn[1]);
  WriteCapability(F,Name,'B2',MouseBtn[2]);
  WriteCapability(F,Name,'B3',MouseBtn[3]);
End; { TMouseInterface.SaveConfiguration }

Procedure TMouseInterface.Configure;
Var Menu: PMenu;
Begin
  Inherited Configure;

  Menu := New(PMenu,InitWH(34,7,
              Black,LightGray,Black,LightGray,Blue,LightGray,
              Red,LightGray,Black,Green,Red,Green,
              DarkGray,LightGray,DarkGray,Green,
              SingleBorder,' Mouse Configuration ',
              ' <Enter> selects, <Esc> exits ',True));
  Menu^.AddSelection(1 ,1,32,1,False,False,'Mouse X axis');
  Menu^.AddSelection(1 ,2,32,1,False,False,'Mouse Y axis');
  Menu^.AddSelection(1 ,3,32,1,False,False,'Mouse left button');
  Menu^.AddSelection(1 ,4,32,1,False,False,'Mouse right button');
  Menu^.AddSelection(1 ,5,32,1,False,False,'Mouse middle button');
  Repeat
    Menu^.Execute;
    If (Menu^.CurSel >= 1) And (Menu^.CurSel <= 6) Then
    Begin
      Case Menu^.CurSel Of
        1: SelectAxis('Select mouse X axis',MouseX.Cap);
        2: SelectAxis('Select mouse Y axis',MouseY.Cap);
        3: SelectAny(0,0,'Select mouse left button',MouseBtn[1]);
        4: SelectAny(0,0,'Select mouse right button',MouseBtn[2]);
        5: SelectAny(0,0,'Select mouse middle button',MouseBtn[3]);
      End; { Case }
    End;
  Until Menu^.CurSel = 0;
  Dispose(Menu,Done);
End; { TMouseInterface.Configure }

Procedure TMouseInterface.GetControllerInfo(Var Controllers: TCapability;
                                            Var Info: TAtariControls);
Var
  PadGround : LongInt;
  MX,MY,MB  : LongInt;
  XM,YM     : Integer;
  CapMask   : TCapability;

Begin

  { Refresh bounds }

  MouseX.Min := 0;
  MouseY.Min := 0;
  MouseX.Mid := MScreenWidth;
  MouseY.Mid := MScreenHeight;
  MouseX.Max := MScreenWidth  * 2;
  MouseY.Max := MScreenHeight * 2;

  { Initialize the capability mask to include all capabliities }

  SetAllCapability(CapMask);

  { Read the mouse position and calculate the paddle "position" }

  XM := 0;
  YM := 0;
  GetMouseMotion(XM,YM);
  MX := 0;
  MY := 0;
  MB := 0;
  GetMousePosition(MX,MY,MB);

  { Left button }

  GetDigitalAny(((MB And 1) <> 0),MouseBtn[1],CapMask,Controllers,Info);

  { Right button }

  GetDigitalAny(((MB And 2) <> 0),MouseBtn[2],CapMask,Controllers,Info);

  { Middle button }

  GetDigitalAny(((MB And 4) <> 0),MouseBtn[3],CapMask,Controllers,Info);

  { X axis }

  GetAnalog(MouseX.Min,MouseX.Mid,MouseX.Max,MX,XM,MouseX.Cap,CapMask,Controllers,Info);

  { Y axis }

  GetAnalog(MouseY.Min,MouseY.Mid,MouseY.Max,MY,YM,MouseY.Cap,CapMask,Controllers,Info);

  { Remove capabilities that were used }

  AndCapabilities(CapMask,Controllers);
End; { TMouseInterface.GetControllerInfo }

Procedure TMouseInterface.GetAnalog(Min,Mid,Max,Value,XM: LongInt;
                               Var Cap: TCapability;
                               Var CapMask: TCapability;
                               Var Controllers: TCapability;
                               Var Info: TAtariControls);
Var
  PadGround : LongInt;
  XInc      : Integer;
  I         : Integer;

Begin
  If Max = 0 Then Exit;
  PadGround := Round(27 * (640 / Max) * (Max - Value));

  { Paddle controllers }

  For I := 1 To 4 Do
  Begin
    If ((Cap.A         And PadMaskA[I]) <> 0) And
       ((Controllers.A And PadMaskA[I]) <> 0) Then
    Begin
      Info.Pad[I] := PadGround;
      CapMask.A   := CapMask.A And PadMaskNA[I];
    End;
  End; { For I }

  { Joysticks }

  For I := 1 To 2 Do
  Begin
    If ((Cap.A         And JoyMaskX[I]) <> 0) And
       ((Controllers.A And JoyMaskX[I]) <> 0) Then
    Begin
      If (Value <= (Min + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdLeft];
      If (Value >= (Max + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdRight];
      CapMask.A := CapMask.A And JoyMaskNX[I];
    End;
    If ((Cap.A         And JoyMaskY[I]) <> 0) And
       ((Controllers.A And JoyMaskY[I]) <> 0) Then
    Begin
      If (Value <= (Min + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdUp];
      If (Value >= (Max + Mid) Div 2) Then Info.PortA := Info.PortA And JoyDirOn[I,jdDown];
      CapMask.A := CapMask.A And JoyMaskNY[I];
    End;
  End; { For I }

  { Driving controller 1 }

  If ((Cap.A         And imDriving1) <> 0) And
     ((Controllers.A And imDriving1) <> 0) Then
  Begin
    If ((Cap.A         And imDriving1Axis) <> 0) And
       ((Controllers.A And imDriving1Axis) <> 0) Then
    Begin
      If DrivX > 32 Then
      Begin
        XM    := 0;
        DrivX := 0;
      End;
      XInc := Round((XM + DrivAdd) / 64);
      If (XM <> 0) And (XInc = 0) Then
      Begin
        Inc(DrivAdd,XM);
      End;
      If XInc < 0 Then
      Begin
        Inc(DrivX,XInc);
        If DrivX < -32 Then DrivX := -32;
        DrivAdd := 0;
      End;
      If XInc > 0 Then
      Begin
        Inc(DrivX,XInc);
        If DrivX > 32 Then DrivX := 32;
        DrivAdd := 0;
      End;
      If DrivX < 0 Then
      Begin
        If DrivCount = 0 Then
        Begin
          Inc(DrivX);
          If DrivX > 0 Then DrivX := 0;
          Dec(Info.Driv[1],3);
          DrivCount := 1;
        End
        Else Dec(DrivCount);
      End;
      If DrivX > 0 Then
      Begin
        If DrivCount = 0 Then
        Begin
          Dec(DrivX);
          If DrivX < 0 Then DrivX := 0;
          Inc(Info.Driv[1],3);
          DrivCount := 1;
        End
        Else Dec(DrivCount);
      End;
    End;
    CapMask.A := CapMask.A And imNoDriving1;
  End;

  { Driving controller 2 }

  If ((Cap.A         And imDriving2) <> 0) And
     ((Controllers.A And imDriving2) <> 0) Then
  Begin
    If ((Cap.A         And imDriving2Axis) <> 0) And
       ((Controllers.A And imDriving2Axis) <> 0) Then
    Begin
      If (Value Shr 2) < DrivX Then
      Begin
        If DrivCount = 0 Then
        Begin
          Dec(Info.Driv[2],3);
          DrivCount := 4;
        End
        Else Dec(DrivCount);
        Dec(DrivX);
      End;
      If (Value Shr 2) > DrivX Then
      Begin
        If DrivCount = 0 Then
        Begin
          Inc(Info.Driv[2],3);
          DrivCount := 4;
        End
        Else Dec(DrivCount);
        Inc(DrivX);
      End;
    End;
    CapMask.A := CapMask.A And imNoDriving2;
  End;
End; { TMouseInterface.GetAnalog }

{ ------------------ }
{ TKeyboardInterface }
{ ------------------ }

Constructor TKeyboardInterface.Init;
Begin
  Inherited Init('Keyboard');
  FillChar(KeyCap,SizeOf(KeyCap),#0);

  { Predefine console switches - other function }
  { keys are handled in the main emulator.      }

  KeyCap[kESC].B := ifPower;
  KeyCap[kF2].B  := ifReset;
  KeyCap[kF4].B  := ifSelect;
  KeyCap[kF5].B  := ifColorBW;
  KeyCap[kF6].B  := ifDiff1;
  KeyCap[kF7].B  := ifDiff2;
End; { TKeyboardInterface.Init }

Destructor TKeyboardInterface.Done;
Begin
  Inherited Done;
End; { TKeyboardInterface.Done }

Procedure TKeyboardInterface.LoadConfiguration(F: PINIFile);
Var I: Integer;
Begin
  Inherited LoadConfiguration(F);
  For I := 0 To 255 Do
   ReadCapability(F,Name,'K' + IntToStr(I),KeyCap[I]);
End; { TKeyboardInterface.LoadConfiguration }

Procedure TKeyboardInterface.SaveConfiguration(F: PINIFile);
Var I: Integer;
Begin
  Inherited SaveConfiguration(F);
  For I := 0 To 255 Do
  Begin
    If UsedCapability(KeyCap[I]) Then
     WriteCapability(F,Name,'K' + IntToStr(I),KeyCap[I]);
  End; { For I }
End; { TKeyboardInterface.SaveConfiguration }

Procedure TKeyboardInterface.Configure;
Type
  TKeyStr = String[5];
  TKeyRec = Record
    Name   : TKeyStr;
    X      : Integer;
    Y      : Integer;
  End;

Const
  { Backspace was at (29,7) but has since been deactivated so it can be }
  { used to save the video sequence to an .AVI file                     }

  KeyList : Array[0..$FF] Of TKeyRec =
   ((Name:'';      X:0;  Y:0),  (Name:'ESC';   X:0;  Y:0),  (Name:'1';     X:4;  Y:7),  (Name:'2';     X:6;  Y:7),  { 00 }
    (Name:'3';     X:8;  Y:7),  (Name:'4';     X:10; Y:7),  (Name:'5';     X:12; Y:7),  (Name:'6';     X:14; Y:7),
    (Name:'7';     X:16; Y:7),  (Name:'8';     X:18; Y:7),  (Name:'9';     X:20; Y:7),  (Name:'0';     X:22; Y:7),
    (Name:'-';     X:0;  Y:0),  (Name:'=';     X:0;  Y:0),  (Name:'BKSPC'; X:0;  Y:0),  (Name:'TAB';   X:2;  Y:9),
    (Name:'Q';     X:6;  Y:9),  (Name:'W';     X:8;  Y:9),  (Name:'E';     X:10; Y:9),  (Name:'R';     X:12; Y:9),  { 10 }
    (Name:'T';     X:14; Y:9),  (Name:'Y';     X:16; Y:9),  (Name:'U';     X:18; Y:9),  (Name:'I';     X:20; Y:9),
    (Name:'O';     X:22; Y:9),  (Name:'P';     X:24; Y:9),  (Name:'[';     X:26; Y:9),  (Name:']';     X:28; Y:9),
    (Name:'ENTER'; X:29; Y:11), (Name:'CTL';   X:2;  Y:15), (Name:'A';     X:7;  Y:11), (Name:'S';     X:9;  Y:11),
    (Name:'D';     X:11; Y:11), (Name:'F';     X:13; Y:11), (Name:'G';     X:15; Y:11), (Name:'H';     X:17; Y:11), { 20 }
    (Name:'J';     X:19; Y:11), (Name:'K';     X:21; Y:11), (Name:'L';     X:23; Y:11), (Name:';';     X:25; Y:11),
    (Name:'''';    X:27; Y:11), (Name:'`';     X:2;  Y:7),  (Name:'SHIFT'; X:2;  Y:13), (Name:'\';     X:32; Y:9),
    (Name:'Z';     X:8;  Y:13), (Name:'X';     X:10; Y:13), (Name:'C';     X:12; Y:13), (Name:'V';     X:14; Y:13),
    (Name:'B';     X:16; Y:13), (Name:'N';     X:18; Y:13), (Name:'M';     X:20; Y:13), (Name:',';     X:22; Y:13), { 30 }
    (Name:'.';     X:24; Y:13), (Name:'/';     X:26; Y:13), (Name:'SHIFT'; X:29; Y:13), (Name:'*';     X:64; Y:7),
    (Name:'ALT';   X:9;  Y:15), (Name:'SPACE'; X:14; Y:15), (Name:'CAPS';  X:2;  Y:11), (Name:'F1';    X:0;  Y:0),
    (Name:'F2';    X:0;  Y:0),  (Name:'F3';    X:0;  Y:0),  (Name:'F4';    X:0;  Y:0),  (Name:'F5';    X:0;  Y:0),
    (Name:'F6';    X:0;  Y:0),  (Name:'F7';    X:0;  Y:0),  (Name:'F8';    X:0;  Y:0),  (Name:'F9';    X:0;  Y:0),  { 40 }
    (Name:'F10';   X:0;  Y:0),  (Name:'NUM';   X:55; Y:7),  (Name:'SCRL';  X:43; Y:3),  (Name:'7';     X:56; Y:9),
    (Name:'8';     X:60; Y:9),  (Name:'9';     X:64; Y:9),  (Name:'-';     X:68; Y:7),  (Name:'4';     X:56; Y:11),
    (Name:'5';     X:60; Y:11), (Name:'6';     X:64; Y:11), (Name:'+';     X:68; Y:10), (Name:'1';     X:56; Y:13),
    (Name:'2';     X:60; Y:13), (Name:'3';     X:64; Y:13), (Name:'0';     X:58; Y:15), (Name:'.';     X:64; Y:15), { 50 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'F11';   X:0;  Y:0),
    (Name:'F12';   X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 60 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 70 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 80 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 90 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'ENT';   X:67; Y:14), (Name:'CTL';   X:32; Y:15), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { A0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'PRT';   X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { B0 }
    (Name:'';      X:0;  Y:0),  (Name:'/';     X:60; Y:7),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'ALT';   X:21; Y:15), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { C0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'HOME';  X:43; Y:7),
    (Name:'UP';    X:44; Y:13), (Name:'PGUP';  X:48; Y:7),  (Name:'';      X:0;  Y:0),  (Name:'LF';    X:39; Y:15),
    (Name:'';      X:0;  Y:0),  (Name:'RT';    X:49; Y:15), (Name:'';      X:0;  Y:0),  (Name:'END';   X:43; Y:9),
    (Name:'DN';    X:44; Y:15), (Name:'PGDN';  X:48; Y:9),  (Name:'INS';   X:38; Y:7),  (Name:'DEL';   X:38; Y:9),  { D0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'WN';    X:6;  Y:15),
    (Name:'WN';    X:25; Y:15), (Name:'MNU';   X:28; Y:15), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { E0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { F0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0));

(*
  KeyList : Array[0..$FF] Of TKeyRec =
   ((Name:'';      X:0;  Y:0),  (Name:'F9';    X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'F5';    X:0;  Y:0),  { 00 }
    (Name:'F3';    X:0;  Y:0),  (Name:'F1';    X:0;  Y:0),  (Name:'F2';    X:0;  Y:0),  (Name:'F12';   X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'F10';   X:0;  Y:0),  (Name:'F8';    X:0;  Y:0),  (Name:'F6';    X:0;  Y:0),
    (Name:'F4';    X:0;  Y:0),  (Name:'TAB';   X:2;  Y:9),  (Name:'`';     X:2;  Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'ALT';   X:9;  Y:15), (Name:'SHIFT'; X:2;  Y:13), (Name:'';      X:0;  Y:0),  { 10 }
    (Name:'CTL';   X:2;  Y:15), (Name:'Q';     X:6;  Y:9),  (Name:'1';     X:4;  Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'Z';     X:8;  Y:13), (Name:'S';     X:9;  Y:11),
    (Name:'A';     X:7;  Y:11), (Name:'W';     X:8;  Y:9),  (Name:'2';     X:6;  Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'C';     X:12; Y:13), (Name:'X';     X:10; Y:13), (Name:'D';     X:11; Y:11), { 20 }
    (Name:'E';     X:10; Y:9),  (Name:'4';     X:10; Y:7),  (Name:'3';     X:8;  Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'SPACE'; X:14; Y:15), (Name:'V';     X:14; Y:13), (Name:'F';     X:13; Y:11),
    (Name:'T';     X:14; Y:9),  (Name:'R';     X:12; Y:9),  (Name:'5';     X:12; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'N';     X:18; Y:13), (Name:'B';     X:16; Y:13), (Name:'H';     X:17; Y:11), { 30 }
    (Name:'G';     X:15; Y:11), (Name:'Y';     X:16; Y:9),  (Name:'6';     X:14; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'M';     X:20; Y:13), (Name:'J';     X:19; Y:11),
    (Name:'U';     X:18; Y:9),  (Name:'7';     X:16; Y:7),  (Name:'8';     X:18; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:',';     X:22; Y:13), (Name:'K';     X:21; Y:11), (Name:'I';     X:20; Y:9),  { 40 }
    (Name:'O';     X:22; Y:9),  (Name:'0';     X:22; Y:7),  (Name:'9';     X:20; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:60; Y:9),  (Name:'.';     X:24; Y:13), (Name:'/';     X:26; Y:13), (Name:'L';     X:23; Y:11),
    (Name:';';     X:25; Y:11), (Name:'P';     X:24; Y:9),  (Name:'-';     X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'''';    X:27; Y:11), (Name:'';      X:0;  Y:0),  { 50 }
    (Name:'[';     X:26; Y:9),  (Name:'=';     X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'CAPS';  X:2;  Y:11), (Name:'SHIFT'; X:29; Y:13), (Name:'ENTER'; X:29; Y:11), (Name:']';     X:28; Y:9),
    (Name:'';      X:0;  Y:0),  (Name:'\';     X:32; Y:9),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 60 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'BKSPC'; X:29; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'1';     X:56; Y:13), (Name:'';      X:0;  Y:0),  (Name:'4';     X:56; Y:11),
    (Name:'7';     X:56; Y:9),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'0';     X:58; Y:15), (Name:'.';     X:64; Y:15), (Name:'2';     X:60; Y:13), (Name:'5';     X:60; Y:11), { 70 }
    (Name:'6';     X:64; Y:11), (Name:'8';     X:60; Y:9),  (Name:'ESC';   X:0;  Y:0),  (Name:'NUM';   X:55; Y:7),
    (Name:'F11';   X:0;  Y:0),  (Name:'+';     X:68; Y:10), (Name:'3';     X:64; Y:13), (Name:'-';     X:68; Y:7),
    (Name:'*';     X:64; Y:7),  (Name:'9';     X:64; Y:9),  (Name:'SCRL';  X:43; Y:3),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'F7';    X:0;  Y:0),  { 80 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'ALT';   X:21; Y:15), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { 90 }
    (Name:'CTL';   X:32; Y:15), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { A0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { B0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { C0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'/';     X:60; Y:7),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { D0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'ENT';   X:67; Y:14), (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  { E0 }
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'END';   X:43; Y:9),  (Name:'';      X:0;  Y:0),  (Name:'LF';    X:39; Y:15),
    (Name:'HOME';  X:43; Y:7),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'INS';   X:38; Y:7),  (Name:'DEL';   X:38; Y:9),  (Name:'DN';    X:44; Y:15), (Name:'';      X:0;  Y:0),  { F0 }
    (Name:'RT';    X:49; Y:15), (Name:'UP';    X:44; Y:13), (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),
    (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0),  (Name:'PGDN';  X:48; Y:9),  (Name:'';      X:0;  Y:0),
    (Name:'PRT';   X:38; Y:3),  (Name:'PGUP';  X:48; Y:7),  (Name:'';      X:0;  Y:0),  (Name:'';      X:0;  Y:0));
*)
Var
  Window  : PWindow;
  Menu    : PMenu;
  PadMenu : PMenu;
  JoyMenu : PMenu;
  CBSMenu : PMenu;
  DrvMenu : PMenu;
  KeyMenu : PMenu;
  OldKey  : Array[0..$FF] Of Byte;
  TheKey  : Integer;
  Pressed : Boolean;
  I,J     : Integer;
  X1,X2   : Integer;

Begin
  Inherited Configure;
  Window := New(PWindow,Init(4,4,MaxX - 3,MaxY - 3,
              Black,Cyan,White,Cyan,White,Cyan,
              SingleBorder,' Keyboard Configuration ',
              ' <Key> to change, <Esc> exits ',True));
  Window^.Display;
  Screen.GotoXY(1,1);
  Screen.WriteLn('');
  Screen.WriteLn('Ŀ Ŀ Ŀ Ŀ   Ŀ');
  Screen.WriteLn('                       SCRL    ');
  Screen.WriteLn('      ');
  Screen.WriteLn('');
  Screen.WriteLn('Ŀ Ŀ Ŀ');
  Screen.WriteLn('`1234567890          INS HOMEPGUP NUM /  *  - ');
  Screen.WriteLn('Ĵ Ĵ Ĵ');
  Screen.WriteLn('TABQWERTYUIOP[]  \   DEL END PGDN  7  8  9    ');
  Screen.WriteLn('Ĵ  Ĵ + ');
  Screen.WriteLn('CAPSASDFGHJKL;"ENTER                    4  5  6    ');
  Screen.WriteLn('Ĵ      Ŀ      Ĵ');
  Screen.WriteLn('SHIFTZXCVBNM,./ SHIFT        UP        1  2  3    ');
  Screen.WriteLn('Ĵ Ŀ ĴENT');
  Screen.WriteLn('CTLWNALT SPACE ALTWNMNUCTL  LF  DN  RT     0    .    ');
  Screen.WriteLn('  ');

  Screen.TextColor(Yellow);
  Screen.GotoXY(1,1);
  Screen.Write('Esc, pause, function keys, minus, and equal keys cannot be remapped.');

  TheKey := 0;
  Repeat

    { Display all keys that have definitions }

    For I := 0 To $FF Do
    Begin
      If (KeyList[I].Name <> '') And
         (KeyList[I].X <> 0) And
         (KeyList[I].Y <> 0) Then
      Begin
        If UsedCapability(KeyCap[I])
         Then Screen.TextColor(Yellow)
         Else Screen.TextColor(Black);
        Screen.TextBackground(Window^.WindowAttr Shr 4);
        Screen.GotoXY(KeyList[I].X,KeyList[I].Y);
        Screen.Write(KeyList[I].Name);
      End;
    End; { For I }

    { Initialize the keyboard handler }

    FillChar(Key,SizeOf(Key),#0);
    InitKeyboard;

    { Wait for a key to be pressed }

    Pressed := False;
    Repeat
      TheKey := 0;
      While (TheKey < 256) And Not Pressed Do
      Begin
        If (Key[TheKey] <> 0) And
           ((KeyList[TheKey].X <> 0) Or
            (TheKey = kESC)) Then Pressed := True Else Inc(TheKey);
      End; { While }
    Until Pressed;

    { Wait until the key is released }

    Repeat
    Until Key[TheKey] = 0;

    { Clean up the keyboard handler }

    ExitKeyboard;
    FillChar(Key,SizeOf(Key),#0);

    { Allow for all but the special keys }

    If Not (TheKey In [kF1,kF2,kF3,kF4,kF5,kF6,kF7,kF8,kF9,kF10,kF11,kF12,kESC,kMINUS,kEQUAL]) Then
    Begin
      If (KeyList[TheKey].Name <> '') And
         (KeyList[TheKey].X <> 0) And
         (KeyList[TheKey].Y <> 0) Then
      Begin
        Screen.TextColor(Red);
        Screen.TextBackground(Window^.WindowAttr Shr 4);
        Screen.GotoXY(KeyList[TheKey].X,KeyList[TheKey].Y);
        Screen.Write(KeyList[TheKey].Name);

        { Move the menu left or right if necessary }

        X1 := (MaxX - 34) Div 2;
        X2 := X1 + 34 - 1;
        I  := KeyList[TheKey].X + Window^.X1 - 1;
        J  := I + Length(KeyList[TheKey].Name) - 1;

        If ((I >= X1 - 1) And (I <= X2 + 1)) Or
           ((J >= X1 - 1) And (J <= X2 + 1)) Then
        Begin
          If I < (MaxX Div 2) Then
          Begin
            I := I - X1 + 2 + Length(KeyList[TheKey].Name);
            Inc(X1,I);
            Inc(X2,I);
          End
          Else
          Begin
            I := X2 - I + 1;
            Dec(X1,I);
            Dec(X2,I);
          End;
        End;
        SelectAny(X1,X2,' Key ''' + KeyList[TheKey].Name +
                        ''': Select Controller ',KeyCap[TheKey]);
      End;
    End;
  Until TheKey = kESC;
  Window^.Remove;
  Dispose(Window,Done);
End; { TKeyboardInterface.Configure }

Procedure TKeyboardInterface.GetControllerInfo(Var Controllers: TCapability;
                                               Var Info: TAtariControls);
Const
  PadInc = 100;
  PadMax = Trunc(3.1 * 6.4 * 800);

Var
  TheKey  : Integer;
  CapMask : TCapability;

Begin

  { Initialize the capability mask to include all capabliities }

  SetAllCapability(CapMask);

  { Assume that InitKeyboard has already been run }

  For TheKey := 0 To $FF Do
   GetDigitalAny((Key[TheKey] <> 0),KeyCap[TheKey],CapMask,Controllers,Info);

  { Remove capabilities that were used }

  AndCapabilities(CapMask,Controllers);
End; { TKeyboardInterface.GetControllerInfo }

{ ------------------ }
{ TJoystickInterface }
{ ------------------ }

Constructor TJoystickInterface.Init;
Var I: Integer;
Begin
  Inherited Init('Joystick');
  Extension := 0; { Default is normal two-button joystick }
  FillChar(JoyCap,SizeOf(JoyCap),#0);
  For I := 1 To Max_Joy_Axis Do
  Begin
    JoyCap[1].Axis[I].Min := -1;  { Joysticks are disabled by default }
    JoyCap[1].Axis[I].Mid := -1;
    JoyCap[1].Axis[I].Max := -1;
    JoyCap[2].Axis[I].Min := -1;
    JoyCap[2].Axis[I].Mid := -1;
    JoyCap[2].Axis[I].Max := -1;
  End; { For I }
End; { TJoystickInterface.Init }

Destructor TJoystickInterface.Done;
Begin
  Inherited Done;
End; { TJoystickInterface.Done }

Procedure TJoystickInterface.SetupCapabilities;
Var I: Integer;
Begin

  { Handle extensions }

  If (Extension And (JS_AN_HAT1_CHF Or JS_AN_HAT_FCS)) <> 0 Then
  Begin
    JoyCap[1].Axis[3].Min := 0;
    JoyCap[1].Axis[3].Mid := 10;
    JoyCap[1].Axis[3].Max := 20;
    JoyCap[1].Axis[4].Min := 0;
    JoyCap[1].Axis[4].Mid := 10;
    JoyCap[1].Axis[4].Max := 20;
  End
  Else
  Begin
    JoyCap[1].Axis[3].Min := -1;
    JoyCap[1].Axis[3].Mid := -1;
    JoyCap[1].Axis[3].Max := -1;
    JoyCap[1].Axis[4].Min := -1;
    JoyCap[1].Axis[4].Mid := -1;
    JoyCap[1].Axis[4].Max := -1;
  End;
  If (Extension And JS_AN_HAT2_CHF) <> 0 Then
  Begin
    JoyCap[1].Axis[5].Min := 0;
    JoyCap[1].Axis[5].Mid := 10;
    JoyCap[1].Axis[5].Max := 20;
    JoyCap[1].Axis[6].Min := 0;
    JoyCap[1].Axis[6].Mid := 10;
    JoyCap[1].Axis[6].Max := 20;
  End
  Else
  Begin
    JoyCap[1].Axis[5].Min := -1;
    JoyCap[1].Axis[5].Mid := -1;
    JoyCap[1].Axis[5].Max := -1;
    JoyCap[1].Axis[6].Min := -1;
    JoyCap[1].Axis[6].Mid := -1;
    JoyCap[1].Axis[6].Max := -1;
  End;
  If (Extension And JS_AN_BUTTONS_PXY) <> 0 Then
  Begin
    For I := 1 To Max_Joy_Axis Do
    Begin
      JoyCap[2].Axis[I].Min := -1;  { Gamepads use joystick 2 axis }
      JoyCap[2].Axis[I].Mid := -1;
      JoyCap[2].Axis[I].Max := -1;
    End; { For I }
  End;
End; { TJoystickInterface.SetupCapabilities }

Procedure TJoystickInterface.LoadConfiguration(F: PINIFile);
Var
  Joy,Axis,Btn : Integer;
  JoyStr       : String[4];
  AxisStr      : String[4];

Begin
  Inherited LoadConfiguration(F);
  Extension := F^.ReadInteger(Name,'TYPE',0);
  For Joy := 1 To 2 Do
  Begin
    JoyStr := 'J' + IntToStr(Joy);
    For Axis := 1 To Max_Joy_Axis Do
    Begin
      AxisStr := JoyStr + 'A' + IntToStr(Axis);
      ReadCapability(F,Name,AxisStr,JoyCap[Joy].Axis[Axis].Cap);
      JoyCap[Joy].Axis[Axis].Min   := F^.ReadInteger(Name,AxisStr + 'MIN',0);
      JoyCap[Joy].Axis[Axis].Mid   := F^.ReadInteger(Name,AxisStr + 'MID',0);
      JoyCap[Joy].Axis[Axis].Max   := F^.ReadInteger(Name,AxisStr + 'MAX',0);
    End; { For Axis }
    For Btn := 1 To Max_Joy_Btn Do
     ReadCapability(F,Name,JoyStr + 'B' + IntToStr(Btn),JoyCap[Joy].Btn[Btn]);
  End; { For Joy }
  SetupCapabilities;
End; { TJoystickInterface.LoadConfiguration }

Procedure TJoystickInterface.SaveConfiguration(F: PINIFile);
Var
  Joy,Axis,Btn : Integer;
  JoyStr       : String[4];
  AxisStr      : String[4];

Begin
  Inherited SaveConfiguration(F);
  F^.WriteInteger(Name,'TYPE',Extension);
  For Joy := 1 To 2 Do
  Begin
    JoyStr := 'J' + IntToStr(Joy);
    For Axis := 1 To Max_Joy_Axis Do
    Begin
      AxisStr := JoyStr + 'A' + IntToStr(Axis);
      WriteCapability(F,Name,AxisStr,JoyCap[Joy].Axis[Axis].Cap);
      F^.WriteInteger(Name,AxisStr + 'MIN',JoyCap[Joy].Axis[Axis].Min);
      F^.WriteInteger(Name,AxisStr + 'MID',JoyCap[Joy].Axis[Axis].Mid);
      F^.WriteInteger(Name,AxisStr + 'MAX',JoyCap[Joy].Axis[Axis].Max);
    End; { For Axis }
    For Btn := 1 To Max_Joy_Btn Do
     WriteCapability(F,Name,JoyStr + 'B' + IntToStr(Btn),JoyCap[Joy].Btn[Btn]);
  End; { For Joy }
End; { TJoystickInterface.SaveConfiguration }

Procedure TJoystickInterface.Configure;
Var
  ExtMenu : PMenu;
  Menu    : PMenu;
(*
  Procedure Calibrate(Joy: Integer);
  Var
    JoyB  : Byte;
    JoyX1 : LongInt;
    JoyY1 : LongInt;
    CJoyX : LongInt;
    CJoyY : LongInt;
    JoyX2 : LongInt;
    JoyY2 : LongInt;
    JoyX  : LongInt;
    JoyY  : LongInt;
    C     : Char;

  Begin
    StayPopup('Move joystick ' + IntToStr(Joy) + ' to upper left and press any key, or <Esc> to exit:');
    JoyX1 := MaxJoyCount - 1;
    JoyY1 := MaxJoyCount - 1;
    Repeat
      JoyStatus(Joy,JoyB,JoyX,JoyY);
      If JoyX < JoyX1 Then JoyX1 := JoyX;
      If JoyY < JoyY1 Then JoyY1 := JoyY;
    Until KeyPressed;
    C := ReadKey;
    Dispose(_Win,Done);
    If C <> #27 Then
    Begin
      StayPopup('Center joystick ' + IntToStr(Joy) + ' and press any key, or <Esc> to exit:');
      Repeat
        JoyStatus(Joy,JoyB,CJoyX,CJoyY);
      Until KeyPressed;
      C := ReadKey;
      Dispose(_Win,Done);
      If C <> #27 Then
      Begin
        StayPopup('Move joystick ' + IntToStr(Joy) + ' to lower right and press any key, or <Esc> to exit:');
        JoyX2 := 0;
        JoyY2 := 0;
        Repeat
          JoyStatus(Joy,JoyB,JoyX,JoyY);
          If (JoyX > JoyX2) And (JoyX < MaxJoyCount) Then JoyX2 := JoyX;
          If (JoyY > JoyY2) And (JoyY < MaxJoyCount) Then JoyY2 := JoyY;
        Until KeyPressed;
        C := ReadKey;
        Dispose(_Win,Done);
        If C <> #27 Then
        Begin
          If JoyX2 < JoyX1 Then
          Begin
            JoyX1 := 0;
            JoyX2 := MaxJoyCount - 1;
          End;
          If JoyY2 < JoyY1 Then
          Begin
            JoyY1 := 0;
            JoyY2 := MaxJoyCount - 1;
          End;
          JoyCap[Joy].Axis[1].Min := JoyX1;
          JoyCap[Joy].Axis[2].Min := JoyY1;
          JoyCap[Joy].Axis[1].Mid := CJoyX;
          JoyCap[Joy].Axis[2].Mid := CJoyY;
          JoyCap[Joy].Axis[1].Max := JoyX2;
          JoyCap[Joy].Axis[2].Max := JoyY2;
        End;
      End;
    End;
  End; { Calibrate }
*)
  Procedure Calibrate(Joy: Integer; Hat: Boolean);
  Var
    JoyB  : Byte;
    JoyX1 : LongInt;
    JoyY1 : LongInt;
    CJoyX : LongInt;
    CJoyY : LongInt;
    JoyX2 : LongInt;
    JoyY2 : LongInt;
    JoyX  : LongInt;
    JoyY  : LongInt;
    JoyXA : LongInt;
    JoyYA : LongInt;
    C     : Char;
    XC,YC : LongInt;

  Begin
    If Hat
     Then StayPopup4('Slowly move hat through all',
                     'extremes and press a key,',
                     'or press <Esc> to exit:','')
     Else StayPopup4('Center joystick trimmers, then',
                     'slowly move joystick through',
                     'all extremes and hit a key, or',
                     '<Esc> to exit:');
    JoyX1 := MaxJoyCount - 1;
    JoyY1 := MaxJoyCount - 1;
    JoyX2 := 0;
    JoyY2 := 0;
    JoyXA := 0;
    JoyYA := 0;
    XC    := 0;
    YC    := 0;
    Repeat
      JoyStatus(Joy,JoyB,JoyX,JoyY);
      If JoyX < MaxJoyCount Then
      Begin
        JoyXA := Round(JoyXA * (XC / (XC + 1)) + JoyX * (1 / (XC + 1)));
        Inc(XC);
        If XC > JoySamples Then XC := 0;
        If XC = JoySamples Then
        Begin
          If JoyXA < JoyX1 Then JoyX1 := JoyXA;
          If (JoyXA > JoyX2) And (JoyXA < MaxJoyCount) Then JoyX2 := JoyXA;
        End;
      End;
      If JoyY < MaxJoyCount Then
      Begin
        JoyYA := Round(JoyYA * (YC / (YC + 1)) + JoyY * (1 / (YC + 1)));
        Inc(YC);
        If YC > JoySamples Then YC := 0;
        If YC = JoySamples Then
        Begin
          If JoyYA < JoyY1 Then JoyY1 := JoyYA;
          If (JoyYA > JoyY2) And (JoyYA < MaxJoyCount) Then JoyY2 := JoyYA;
        End;
      End;
    Until KeyPressed;
    C := ReadKey;
    Dispose(_Win,Done);
    If C <> #27 Then
    Begin
      If JoyX2 < JoyX1 Then
      Begin
        JoyX1 := 0;
        JoyX2 := MaxJoyCount - 1;
      End;
      If JoyY2 < JoyY1 Then
      Begin
        JoyY1 := 0;
        JoyY2 := MaxJoyCount - 1;
      End;
      JoyCap[Joy].Axis[1].Min := JoyX1;
      JoyCap[Joy].Axis[2].Min := JoyY1;
      JoyCap[Joy].Axis[1].Mid := (JoyX1 + JoyX2) Div 2;
      JoyCap[Joy].Axis[2].Mid := (JoyY1 + JoyY2) Div 2;
      JoyCap[Joy].Axis[1].Max := JoyX2;
      JoyCap[Joy].Axis[2].Max := JoyY2;
    End;
  End; { Calibrate }

  Procedure Disable(Joy: Integer);
  Begin
    JoyCap[Joy].Axis[1].Min := -1;
    JoyCap[Joy].Axis[1].Mid := -1;
    JoyCap[Joy].Axis[1].Max := -1;
    JoyCap[Joy].Axis[2].Min := -1;
    JoyCap[Joy].Axis[2].Mid := -1;
    JoyCap[Joy].Axis[2].Max := -1;
  End; { Disable }

Begin
  Inherited Configure;
  ExtMenu := New(PMenu,InitWH(42,6,
                 Black,LightGray,Black,LightGray,Blue,LightGray,
                 Red,LightGray,Black,Green,Red,Green,
                 DarkGray,LightGray,DarkGray,Green,
                 SingleBorder,' Select Joystick Type ',
                 ' <Enter> selects, <Esc> exits ',True));
  ExtMenu^.AddSelection( 1,1,40,1,False,False,'Standard Joystick');
  ExtMenu^.AddSelection( 1,2,40,1,False,False,'ThrustMaster FCS');
  ExtMenu^.AddSelection( 1,3,40,1,False,False,'CH FlightStick Pro');
  ExtMenu^.AddSelection( 1,4,40,1,False,False,'Six- or Eight-Button Game Pad');

  Repeat
    ExtMenu^.Execute;
    If ExtMenu^.CurSel > 0 Then
    Begin
      Case ExtMenu^.CurSel Of
   1: Begin
        Menu := New(PMenu,InitWH(42,9,
                    Black,LightGray,Black,LightGray,Blue,LightGray,
                    Red,LightGray,Black,Green,Red,Green,
                    DarkGray,LightGray,DarkGray,Green,
                    SingleBorder,' Standard Joystick ',
                    ' <Enter> selects, <Esc> exits ',True));
        Menu^.AddSelection( 1,1,20,1,False,False,'Joy 1 X Axis');
        Menu^.AddSelection( 1,2,20,1,False,False,'Joy 1 Y Axis');
        Menu^.AddSelection( 1,3,20,1,False,False,'Joy 1 Button 1');
        Menu^.AddSelection( 1,4,20,1,False,False,'Joy 1 Button 2');
        Menu^.AddSelection( 1,6,20,1,False,False,'Calibrate');
        Menu^.AddSelection( 1,7,20,1,False,False,'Disable');
        Menu^.AddSelection(21,1,20,1,False,False,'Joy 2 X Axis');
        Menu^.AddSelection(21,2,20,1,False,False,'Joy 2 Y Axis');
        Menu^.AddSelection(21,3,20,1,False,False,'Joy 2 Button 1');
        Menu^.AddSelection(21,4,20,1,False,False,'Joy 2 Button 2');
        Menu^.AddSelection(21,6,20,1,False,False,'Calibrate');
        Menu^.AddSelection(21,7,20,1,False,False,'Disable');

        Repeat
          Menu^.Execute;
          If Menu^.CurSel > 0 Then
          Begin
            Case Menu^.CurSel Of
              1: SelectAxis('Select controllers',JoyCap[1].Axis[1].Cap);
              2: SelectAxis('Select controllers',JoyCap[1].Axis[2].Cap);
              3: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[1]);
              4: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[2]);
              5: Calibrate(1,False);
              6: Disable(1);
              7: SelectAxis('Select controllers',JoyCap[2].Axis[1].Cap);
              8: SelectAxis('Select controllers',JoyCap[2].Axis[2].Cap);
              9: SelectAny(0,0,'Select button functions',JoyCap[2].Btn[1]);
             10: SelectAny(0,0,'Select button functions',JoyCap[2].Btn[2]);
             11: Calibrate(2,False);
             12: Disable(2);
            End; { Case }
          End;
        Until Menu^.CurSel = 0;
        Extension := 0;
        Dispose(Menu,Done);
      End;
   2: Begin
        Menu := New(PMenu,InitWH(42,13,
                    Black,LightGray,Black,LightGray,Blue,LightGray,
                    Red,LightGray,Black,Green,Red,Green,
                    DarkGray,LightGray,DarkGray,Green,
                    SingleBorder,' ThrustMaster FCS ',
                    ' <Enter> selects, <Esc> exits ',True));
        Menu^.AddSelection( 1, 1,20,1,False,False,'Joy 1 X Axis');
        Menu^.AddSelection( 1, 2,20,1,False,False,'Joy 1 Y Axis');
        Menu^.AddSelection( 1, 3,20,1,False,False,'Joy 1 Button 1');
        Menu^.AddSelection( 1, 4,20,1,False,False,'Joy 1 Button 2');
        Menu^.AddSelection( 1, 5,20,1,False,False,'Joy 1 Button 3');
        Menu^.AddSelection( 1, 6,20,1,False,False,'Joy 1 Button 4');
        Menu^.AddSelection( 1, 7,20,1,False,False,'Joy 1 Hat X Axis');
        Menu^.AddSelection( 1, 8,20,1,False,False,'Joy 1 Hat Y Axis');
        Menu^.AddSelection( 1,10,20,1,False,False,'Calibrate');
        Menu^.AddSelection( 1,11,20,1,False,False,'Disable');
        Menu^.AddSelection(21, 1,20,1,False,False,'Joy 2 X Axis');
        Menu^.AddSelection(21,10,20,1,False,False,'Calibrate');
        Menu^.AddSelection(21,11,20,1,False,False,'Disable');

        Repeat
          Menu^.Execute;
          If Menu^.CurSel > 0 Then
          Begin
            Case Menu^.CurSel Of
              1: SelectAxis('Select controllers',JoyCap[1].Axis[1].Cap);
              2: SelectAxis('Select controllers',JoyCap[1].Axis[2].Cap);
              3: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[1]);
              4: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[2]);
              5: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[3]);
              6: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[4]);
              7: SelectAxis('Select controllers',JoyCap[1].Axis[3].Cap);
              8: SelectAxis('Select controllers',JoyCap[1].Axis[4].Cap);
              9: Calibrate(1,False);
             10: Disable(1);
             11: SelectAxis('Select controllers',JoyCap[2].Axis[1].Cap);
             12: Calibrate(2,True);
             13: Disable(2);
            End; { Case }
          End;
        Until Menu^.CurSel = 0;
        Extension := JS_AN_HAT_FCS;
        Dispose(Menu,Done);
      End;
   3: Begin
        Menu := New(PMenu,InitWH(42,17,
                    Black,LightGray,Black,LightGray,Blue,LightGray,
                    Red,LightGray,Black,Green,Red,Green,
                    DarkGray,LightGray,DarkGray,Green,
                    SingleBorder,' CH FlightStick Pro ',
                    ' <Enter> selects, <Esc> exits ',True));
        Menu^.AddSelection( 1, 1,20,1,False,False,'Joy 1 X Axis');
        Menu^.AddSelection( 1, 2,20,1,False,False,'Joy 1 Y Axis');
        Menu^.AddSelection( 1, 3,20,1,False,False,'Joy 1 Button 1');
        Menu^.AddSelection( 1, 4,20,1,False,False,'Joy 1 Button 2');
        Menu^.AddSelection( 1, 5,20,1,False,False,'Joy 1 Button 3');
        Menu^.AddSelection( 1, 6,20,1,False,False,'Joy 1 Button 4');
        Menu^.AddSelection( 1, 7,20,1,False,False,'Joy 1 Button 5');
        Menu^.AddSelection( 1, 8,20,1,False,False,'Joy 1 Button 6');
        Menu^.AddSelection( 1, 9,20,1,False,False,'Joy 1 Hat 1 X Axis');
        Menu^.AddSelection( 1,10,20,1,False,False,'Joy 1 Hat 1 Y Axis');
        Menu^.AddSelection( 1,11,20,1,False,False,'Joy 1 Hat 2 X Axis');
        Menu^.AddSelection( 1,12,20,1,False,False,'Joy 1 Hat 2 Y Axis');
        Menu^.AddSelection( 1,14,20,1,False,False,'Calibrate');
        Menu^.AddSelection( 1,15,20,1,False,False,'Disable');
        Menu^.AddSelection(21, 1,20,1,False,False,'Joy 2 X Axis');
        Menu^.AddSelection(21, 2,20,1,False,False,'Joy 2 Y Axis');
        Menu^.AddSelection(21,14,20,1,False,False,'Calibrate');
        Menu^.AddSelection(21,15,20,1,False,False,'Disable');

        Repeat
          Menu^.Execute;
          If Menu^.CurSel > 0 Then
          Begin
            Case Menu^.CurSel Of
              1: SelectAxis('Select controllers',JoyCap[1].Axis[1].Cap);
              2: SelectAxis('Select controllers',JoyCap[1].Axis[2].Cap);
              3: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[1]);
              4: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[2]);
              5: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[3]);
              6: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[4]);
              7: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[5]);
              8: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[6]);
              9: SelectAxis('Select controllers',JoyCap[1].Axis[3].Cap);
             10: SelectAxis('Select controllers',JoyCap[1].Axis[4].Cap);
             11: SelectAxis('Select controllers',JoyCap[1].Axis[5].Cap);
             12: SelectAxis('Select controllers',JoyCap[1].Axis[6].Cap);
             13: Calibrate(1,False);
             14: Disable(1);
             15: SelectAxis('Select controllers',JoyCap[2].Axis[1].Cap);
             16: SelectAxis('Select controllers',JoyCap[2].Axis[2].Cap);
             17: Calibrate(2,False);
             18: Disable(2);
            End; { Case }
          End;
        Until Menu^.CurSel = 0;
        Extension := JS_AN_ANY_CHF;
        Dispose(Menu,Done);
      End;
   4: Begin
        Menu := New(PMenu,InitWH(42,14,
                    Black,LightGray,Black,LightGray,Blue,LightGray,
                    Red,LightGray,Black,Green,Red,Green,
                    DarkGray,LightGray,DarkGray,Green,
                    SingleBorder,' Six- or Eight-Button Game Pad ',
                    ' <Enter> selects, <Esc> exits ',True));
        Menu^.AddSelection( 1, 1,40,1,False,False,'Pad X Axis');
        Menu^.AddSelection( 1, 2,40,1,False,False,'Pad Y Axis');
        Menu^.AddSelection( 1, 3,40,1,False,False,'Pad Button 1');
        Menu^.AddSelection( 1, 4,40,1,False,False,'Pad Button 2');
        Menu^.AddSelection( 1, 5,40,1,False,False,'Pad Button 3');
        Menu^.AddSelection( 1, 6,40,1,False,False,'Pad Button 4');
        Menu^.AddSelection( 1, 7,40,1,False,False,'Pad Button 5');
        Menu^.AddSelection( 1, 8,40,1,False,False,'Pad Button 6');
        Menu^.AddSelection( 1, 9,40,1,False,False,'Pad Button 7');
        Menu^.AddSelection( 1,10,40,1,False,False,'Pad Button 8');
        Menu^.AddSelection( 1,11,40,1,False,False,'Calibrate');
        Menu^.AddSelection( 1,12,40,1,False,False,'Disable');

        Repeat
          Menu^.Execute;
          If Menu^.CurSel > 0 Then
          Begin
            Case Menu^.CurSel Of
              1: SelectAxis('Select controllers',JoyCap[1].Axis[1].Cap);
              2: SelectAxis('Select controllers',JoyCap[1].Axis[2].Cap);
              3: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[1]);
              4: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[2]);
              5: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[3]);
              6: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[4]);
              7: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[5]);
              8: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[6]);
              7: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[7]);
              8: SelectAny(0,0,'Select button functions',JoyCap[1].Btn[8]);
             13: Calibrate(1,False);
             14: Disable(1);
            End; { Case }
          End;
        Until Menu^.CurSel = 0;
        Extension := JS_AN_BUTTONS_PXY;
        Dispose(Menu,Done);
      End;
      End; { Case }
      SetupCapabilities;
    End;
  Until ExtMenu^.CurSel = 0;
  Dispose(ExtMenu,Done);
End; { TJoystickInterface.Configure }

Procedure TJoystickInterface.GetControllerInfo(Var Controllers: TCapability;
                                               Var Info: TAtariControls);
Var
  B         : Array[1..2] Of Byte;
  Axis      : Array[1..2,1..Max_Joy_Axis] Of LongInt;
  Joy       : Integer;
  CapMask   : TCapability;
  Ax        : Integer;
  Btn       : Integer;
  Button    : Array[1..2,1..Max_Joy_Btn] Of Boolean;
  I         : Integer;

Begin
  B[1] := 0;
  B[2] := 0;
  For Ax := 1 To Max_Joy_Axis Do
  Begin
    Axis[1,Ax] := JoyCap[1].Axis[Ax].Mid;
    Axis[2,Ax] := JoyCap[2].Axis[Ax].Mid;
  End; { For Ax }
  If JoyCap[1].Axis[1].Mid >= 0 Then JoyStatus(1,B[1],Axis[1,1],Axis[1,2]);
  If JoyCap[2].Axis[1].Mid >= 0 Then JoyStatus(2,B[2],Axis[2,1],Axis[2,2]);
  Button[1,1] := ((B[1] And 1) <> 0);
  Button[1,2] := ((B[1] And 2) <> 0);
  Button[2,1] := ((B[1] And 4) <> 0);
  Button[2,2] := ((B[1] And 8) <> 0);

  { Handle extensions }

  If (Extension And JS_AN_BUTTONS_CHF) <> 0 Then
  Begin
    FillChar(Button,SizeOf(Button),#0);
    Case B[1] And $F Of
      1: Button[1,1] := True;
      2: Button[1,2] := True;
      4: Button[1,3] := True;
      8: Button[1,4] := True;
      5: Button[1,5] := True;
      9: Button[1,6] := True;
    End; { Case }
  End;
  If (Extension And JS_AN_HAT1_CHF) <> 0 Then
  Begin
    Case B[1] And $F Of
     $F: Axis[1,4] := 0;
     $B: Axis[1,3] := 20;
      7: Axis[1,4] := 20;
      3: Axis[1,3] := 0;
    Else
      Axis[1,3] := 10;
      Axis[1,4] := 10;
    End; { Case }
  End;
  If (Extension And JS_AN_HAT2_CHF) <> 0 Then
  Begin
    Case B[1] And $F Of
     $E: Axis[1,6] := 0;
     $A: Axis[1,5] := 20;
      6: Axis[1,6] := 20;
     $C: Axis[1,5] := 0;
    Else
      Axis[1,5] := 10;
      Axis[1,6] := 10;
    End; { Case }
  End;

  If (Extension And (JS_AN_BUTTONS_PXY Or JS_AN_HAT_FCS)) <> 0 Then
  Begin
    Button[1,3] := Button[2,1];
    Button[1,4] := Button[2,2];
    Button[2,1] := False;
    Button[2,2] := False;
  End;

  If (Extension And JS_AN_BUTTON_PXY_X) <> 0 Then
   Button[1,5] := (Axis[2,1] < JoyCap[1].Axis[1].Min + ((JoyCap[1].Axis[1].Mid - JoyCap[1].Axis[1].Min) Div 2));

  If (Extension And JS_AN_BUTTON_PXY_Y) <> 0 Then
   Button[1,6] := (Axis[2,2] < JoyCap[1].Axis[2].Min + ((JoyCap[1].Axis[2].Mid - JoyCap[1].Axis[2].Min) Div 2));

  If (Extension And JS_AN_BUTTON_PXY_U) <> 0 Then
   Button[1,7] := (Axis[2,1] > JoyCap[1].Axis[1].Min + ((JoyCap[1].Axis[1].Max - JoyCap[1].Axis[1].Mid) Div 2));

  If (Extension And JS_AN_BUTTON_PXY_V) <> 0 Then
   Button[1,7] := (Axis[2,2] > JoyCap[1].Axis[2].Min + ((JoyCap[1].Axis[2].Max - JoyCap[1].Axis[2].Mid) Div 2));

  If (Extension And JS_AN_BUTTONS_PXY) <> 0 Then
  Begin
    For Ax := 1 To Max_Joy_Axis Do Axis[2,Ax] := JoyCap[2].Axis[Ax].Mid;
  End;

  If (Extension And JS_AN_HAT_FCS) <> 0 Then
  Begin
    I := (JoyCap[2].Axis[2].Max - JoyCap[2].Axis[2].Min) Div 8;
         If (Axis[2,2] - JoyCap[2].Axis[2].Min) < 1 * I Then Axis[1,4] := 0
    Else If (Axis[2,2] - JoyCap[2].Axis[2].Min) < 3 * I Then Axis[1,3] := 20
    Else If (Axis[2,2] - JoyCap[2].Axis[2].Min) < 5 * I Then Axis[1,4] := 20
    Else If (Axis[2,2] - JoyCap[2].Axis[2].Min) < 7 * I Then Axis[1,3] := 0
    Else
    Begin
      Axis[1,3] := 10;
      Axis[1,4] := 10;
    End;
    For Ax := 1 To Max_Joy_Axis Do Axis[2,Ax] := JoyCap[2].Axis[Ax].Mid;
  End;

  { Initialize the capability mask }

  SetAllCapability(CapMask);

  For Joy := 1 To 2 Do
  Begin

    { Only process axes if the joystick is enabled }

    If (Axis[Joy,1] >= 0) And (Axis[Joy,2] >= 0) Then
    Begin

      { Process axes }

      For Ax := 1 To Max_Joy_Axis Do
       GetAnalog(JoyCap[Joy].Axis[Ax].Min,
                 JoyCap[Joy].Axis[Ax].Mid,
                 JoyCap[Joy].Axis[Ax].Max,
                 Axis[Joy,Ax],
                 0,
                 JoyCap[Joy].Axis[Ax].Cap,
                 CapMask,
                 Controllers,
                 Info);
    End;

    { Process buttons }

    For Btn := 1 To Max_Joy_Btn Do
     GetDigitalAny(Button[Joy,Btn],JoyCap[Joy].Btn[Btn],CapMask,Controllers,Info);
  End; { For Joy }

  { Remove capabilities that were used }

  AndCapabilities(CapMask,Controllers);
End; { TJoystickInterface.GetControllerInfo }

{ ------------------ }
{ TDigitalInterface  }
{ ------------------ }

Constructor TDigitalInterface.Init(St: String);
Begin
  Inherited Init(St);
  FillChar(Cap,SizeOf(Cap),#0);
  FillChar(ContInfo,SizeOf(ContInfo),#0);
  FillChar(ConInfo,SizeOf(ConInfo),#0);
  NumDefs   := 0;
  PacketDef := New(PCollection,Init(10,10));
End; { TDigitalInterface.Init }

Destructor TDigitalInterface.Done;
Begin
  Dispose(PacketDef,Done);
  Inherited Done;
End; { TDigitalInterface.Done }

Procedure TDigitalInterface.LoadConfiguration(F: PINIFile);
Var
  Con,Btn,Axis,Hat,Thr,Ana : Integer;
  ConStr,ThrStr,AnaStr     : String[4];
  Nam,Def,Num,Bit,Flp      : String;
  I,J                      : Integer;
  _Def,_Num,_Bit,_Flp      : TDigitalPacket;

Begin
  Inherited LoadConfiguration(F);
  For Con := 1 To Max_Digital_Con Do
  Begin
    ConStr := 'C' + IntToStr(Con);
    Cap[Con].Loaded   := F^.ReadBool(Name,ConStr + 'LOADED',False);
    Cap[Con].ClassMap := F^.ReadInteger(Name,ConStr + 'CLASSMAP',0);
    Cap[Con].NumBtns  := F^.ReadInteger(Name,ConStr + 'NUMBTNS',0);
    Cap[Con].NumAxes  := F^.ReadInteger(Name,ConStr + 'NUMAXES',0);
    Cap[Con].NumHats  := F^.ReadInteger(Name,ConStr + 'NUMHATS',0);
    Cap[Con].NumThrs  := F^.ReadInteger(Name,ConStr + 'NUMTHRS',0);
    Cap[Con].NumAnas  := F^.ReadInteger(Name,ConStr + 'NUMANAS',0);
    For Btn := 1 To Max_Digital_Btn Do
     ReadCapability(F,Name,ConStr + 'B' + IntToStr(Btn),Cap[Con].Btn[Btn]);
    For Axis := 1 To Max_Digital_Axis Do
     ReadCapability(F,Name,ConStr + 'D' + IntToStr(Axis),Cap[Con].Axis[Axis]);
    For Hat := 1 To Max_Digital_Hat Do
     ReadCapability(F,Name,ConStr + 'H' + IntToStr(Hat),Cap[Con].Hat[Hat]);
    For Thr := 1 To Max_Digital_Thr Do
    Begin
      ThrStr := ConStr + 'T' + IntToStr(Thr);
      ReadCapability(F,Name,ThrStr,Cap[Con].Thr[Thr].Cap);
      Cap[Con].Thr[Thr].Min   := F^.ReadInteger(Name,ThrStr + 'MIN',0);
      Cap[Con].Thr[Thr].Mid   := F^.ReadInteger(Name,ThrStr + 'MID',0);
      Cap[Con].Thr[Thr].Max   := F^.ReadInteger(Name,ThrStr + 'MAX',0);
    End; { For Thr }
    For Ana := 1 To Max_Digital_Ana Do
    Begin
      AnaStr := ConStr + 'A' + IntToStr(Ana);
      ReadCapability(F,Name,AnaStr,Cap[Con].Ana[Ana].Cap);
      Cap[Con].Ana[Ana].Min   := F^.ReadInteger(Name,AnaStr + 'MIN',0);
      Cap[Con].Ana[Ana].Mid   := F^.ReadInteger(Name,AnaStr + 'MID',0);
      Cap[Con].Ana[Ana].Max   := F^.ReadInteger(Name,AnaStr + 'MAX',0);
    End; { For Ana }
  End; { For Con }

  { Load packet definitions }

  I := 1;
  Repeat
    Nam := F^.ReadString(Name,'DIG' + IntToStr(I) + 'AAA','');
    Def := UpperCase(F^.ReadString(Name,'DIG' + IntToStr(I) + 'DEF',''));
    Num := UpperCase(F^.ReadString(Name,'DIG' + IntToStr(I) + 'NUM',''));
    Bit := UpperCase(F^.ReadString(Name,'DIG' + IntToStr(I) + 'BIT',''));
    Flp := UpperCase(F^.ReadString(Name,'DIG' + IntToStr(I) + 'FLP',''));
    FillChar(_Def,SizeOf(_Def),#0);  { Important! }
    FillChar(_Num,SizeOf(_Num),#0);
    FillChar(_Bit,SizeOf(_Bit),#0);
    FillChar(_Flp,SizeOf(_Flp),#0);
    If (Def <> '') And (Num <> '') And (Bit <> '') And (Flp <> '') Then
    Begin
      For J := 1 To Length(Def) Do
       If J <= MaxChannelLength Then _Def[J - 1] := Ord(Def[J]);
      For J := 1 To Length(Num) Do
       If J <= MaxChannelLength Then _Num[J - 1] := Ord(Num[J]);
      For J := 1 To Length(Bit) Do
       If J <= MaxChannelLength Then _Bit[J - 1] := Ord(Bit[J]);
      For J := 1 To Length(Flp) Do
       If J <= MaxChannelLength Then _Flp[J - 1] := Ord(Flp[J]);
      PacketDef^.Insert(New(PDigitalPacketDef,Init(Nam,_Def,_Num,_Bit,_Flp)));
    End;
    Inc(I);
  Until (Def = '') Or (Num = '') Or (Bit = '') Or (Flp = '');
End; { TDigitalInterface.LoadConfiguration }

Procedure TDigitalInterface.SaveConfiguration(F: PINIFile);
Var
  Con,Btn,Axis,Hat,Thr,Ana : Integer;
  ConStr,ThrStr,AnaStr     : String[4];
  Def,Num,Bit,Flp          : String;
  I,J                      : Integer;
  Pkt                      : PDigitalPacketDef;

Begin
  Inherited SaveConfiguration(F);
  For Con := 1 To Max_Digital_Con Do
  Begin
    If Cap[Con].ClassMap <> 0 Then
    Begin
      ConStr := 'C' + IntToStr(Con);
      F^.WriteBool(Name,ConStr + 'LOADED',Cap[Con].Loaded);
      F^.WriteInteger(Name,ConStr + 'CLASSMAP',Cap[Con].ClassMap);
      F^.WriteInteger(Name,ConStr + 'NUMBTNS',Cap[Con].NumBtns);
      F^.WriteInteger(Name,ConStr + 'NUMAXES',Cap[Con].NumAxes);
      F^.WriteInteger(Name,ConStr + 'NUMHATS',Cap[Con].NumHats);
      F^.WriteInteger(Name,ConStr + 'NUMTHRS',Cap[Con].NumThrs);
      F^.WriteInteger(Name,ConStr + 'NUMANAS',Cap[Con].NumAnas);
      For Btn := 1 To Max_Digital_Btn Do
      Begin
        If UsedCapability(Cap[Con].Btn[Btn]) Then
         WriteCapability(F,Name,ConStr + 'B' + IntToStr(Btn),Cap[Con].Btn[Btn]);
      End; { For Btn }
      For Axis := 1 To Max_Digital_Axis Do
      Begin
        If UsedCapability(Cap[Con].Axis[Axis]) Then
         WriteCapability(F,Name,ConStr + 'D' + IntToStr(Axis),Cap[Con].Axis[Axis]);
      End; { For Axis }
      For Hat := 1 To Max_Digital_Hat Do
      Begin
        If UsedCapability(Cap[Con].Hat[Hat]) Then
         WriteCapability(F,Name,ConStr + 'H' + IntToStr(Hat),Cap[Con].Hat[Hat]);
      End; { For Hat }
      For Thr := 1 To Max_Digital_Thr Do
      Begin
        If UsedCapability(Cap[Con].Thr[Thr].Cap) Then
        Begin
          ThrStr := ConStr + 'T' + IntToStr(Thr);
          WriteCapability(F,Name,ThrStr,Cap[Con].Thr[Thr].Cap);
          F^.WriteInteger(Name,ThrStr + 'MIN',Cap[Con].Thr[Thr].Min);
          F^.WriteInteger(Name,ThrStr + 'MID',Cap[Con].Thr[Thr].Mid);
          F^.WriteInteger(Name,ThrStr + 'MAX',Cap[Con].Thr[Thr].Max);
        End;
      End; { For Thr }
      For Ana := 1 To Max_Digital_Ana Do
      Begin
        If UsedCapability(Cap[Con].Ana[Ana].Cap) Then
        Begin
          AnaStr := ConStr + 'A' + IntToStr(Ana);
          WriteCapability(F,Name,AnaStr,Cap[Con].Ana[Ana].Cap);
          F^.WriteInteger(Name,AnaStr + 'MIN',Cap[Con].Ana[Ana].Min);
          F^.WriteInteger(Name,AnaStr + 'MID',Cap[Con].Ana[Ana].Mid);
          F^.WriteInteger(Name,AnaStr + 'MAX',Cap[Con].Ana[Ana].Max);
        End;
      End; { For Ana }
    End;
  End; { For Con }

  { Save packet definitions }

  I := 0;
  While I < PacketDef^.Count Do
  Begin
    Pkt := PDigitalPacketDef(PacketDef^.At(I));
    Def := '';
    Num := '';
    Bit := '';
    Flp := '';
    For J := 0 To MaxChannelLength - 1 Do
    Begin
      Def := Def + Chr(Pkt^.Def[J]);
      Num := Num + Chr(Pkt^.Num[J]);
      Bit := Bit + Chr(Pkt^.Bit[J]);
      Flp := Flp + Chr(Pkt^.Flp[J]);
    End; { For J }
    F^.WriteString(Name,'DIG' + IntToStr(I + 1) + 'AAA',Pkt^.Nam);
    F^.WriteString(Name,'DIG' + IntToStr(I + 1) + 'DEF',Trim(Def));
    F^.WriteString(Name,'DIG' + IntToStr(I + 1) + 'NUM',Trim(Num));
    F^.WriteString(Name,'DIG' + IntToStr(I + 1) + 'BIT',Trim(Bit));
    F^.WriteString(Name,'DIG' + IntToStr(I + 1) + 'FLP',Trim(Flp));
    Inc(I);
  End; { While }
End; { TDigitalInterface.SaveConfiguration }

Procedure TDigitalInterface.RefreshControllers;
Begin
End; { TDigitalInterface.RefreshControllers }

Function TDigitalInterface.GetVendorName(Slot: Integer): String;
Begin
  GetVendorName := '';
End; { TDigitalInterface.GetVendorName }

Function TDigitalInterface.GetProductName(Slot: Integer): String;
Begin
  GetProductName := '';
End; { TDigitalInterface.GetProductName }

Function TDigitalInterface.GetSlotMap: GRIP_BITFIELD;
Begin
  GetSlotMap := 0;
End; { TDigitalInterface.GetSlotMap }

Function TDigitalInterface.GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;
Begin
  GetClassMap := 0;
End; { TDigitalInterface.GetClassMap }

Function TDigitalInterface.GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX;
Begin
  GetMaxIndex := 0;
End; { TDigitalInterface.GetMaxIndex }

Function TDigitalInterface.GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE;
Begin
  GetMaxValue := 0;
End; { TDigitalInterface.GetMaxValue }

Function TDigitalInterface.GetPackedValues(S: GRIP_SLOT; C: GRIP_CLASS; IStart: GRIP_INDEX;
                         IEnd: GRIP_INDEX): GRIP_BITFIELD;
Var
  I : Integer;
  L : LongInt;

Begin
  L := 0;
  For I := IStart To IEnd Do L := L Or (1 Shl I);
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    If C = GRIP_CLASS_BUTTON Then GetPackedValues := ConInfo.Buttons And L;
  End
  Else GetPackedValues := 0;
End; { TDigitalInterface.GetPackedValues }

Function TDigitalInterface.GetValue(S: GRIP_SLOT; C: GRIP_CLASS;
                                    I: GRIP_INDEX): GRIP_VALUE;
Begin
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    If I <= GetMaxIndex(S,C) Then
    Begin
      Case C Of
        GRIP_CLASS_AXIS: GetValue := ConInfo.Axis[I + 1];
     GRIP_CLASS_POV_HAT: GetValue := ConInfo.Hat[I + 1];
    GRIP_CLASS_THROTTLE: GetValue := ConInfo.Throttle[I + 1];
      GRIP_CLASS_ANALOG: GetValue := ConInfo.Analog[I + 1];
      End; { Case }
    End
    Else GetValue := 0;
  End
  Else GetValue := 0;
End; { TDigitalInterface.GetValue }

Procedure TDigitalInterface.Configure;
Var
  Menu     : PMenu;
  CompMenu : PMenu;
  NumCons  : Integer;
  NumBtns  : Integer;
  NumAxes  : Integer;
  NumHats  : Integer;
  NumThrs  : Integer;
  NumAnas  : Integer;
  I,J,K    : LongInt;
  SlotMap  : LongInt;
  ClassMap : LongInt;
  Vendor   : String;
  Product  : String;
  Slot     : Integer;

  Procedure DigitalSelectButton;
  Var
    BtnMenu    : PMenu;
    MenuHeight : Integer;
    I          : Integer;
    X,Y        : Integer;
    Checked    : Boolean;
    Sel        : PSelection;

  Begin
    MenuHeight := NumBtns + 2;
    If MenuHeight > ((Max_Digital_Btn + 1) Div 2) + 2 Then
     MenuHeight := ((Max_Digital_Btn + 1) Div 2) + 2;
    BtnMenu := New(PMenu,InitWH(42,MenuHeight,
                   Black,LightGray,Black,LightGray,Blue,LightGray,
                   Red,LightGray,Black,Green,Red,Green,
                   DarkGray,LightGray,DarkGray,Green,
                   SingleBorder,' Select button (push button to test) ',
                   ' <Enter> selects, <Esc> exits ',True));
    BtnMenu^.Callback := CallbackProc;
    Callback.Menu     := BtnMenu;
    Callback.Slot     := Slot;
    Callback.Intf     := @Self;
    Callback.CType    := cbButton;
    For I := 1 To NumBtns Do
    Begin
      If I <= (Max_Digital_Btn + 1) Div 2 Then
      Begin
        X := 1;
        Y := I;
      End
      Else
      Begin
        X := 17;
        Y := I - ((Max_Digital_Btn + 1) Div 2);
      End;
      If NumBtns > (Max_Digital_Btn + 1) Div 2
       Then BtnMenu^.AddSelection(X,Y,20,1,False,False,'  Button ' + IntToStr(I))
       Else BtnMenu^.AddSelection(X,Y,40,1,False,False,'  Button ' + IntToStr(I))
    End; { For I }

    Repeat

      { If any buttons are assigned to anything, check their menu entries }

      For I := 1 To NumBtns Do
      Begin
        Sel          := BtnMenu^.GetSelection(I);
        Sel^.Checked := UsedCapability(Cap[Menu^.CurSel].Btn[I]);
      End; { For I }
      BtnMenu^.Execute;
      If BtnMenu^.CurSel > 0 Then
       SelectAny(0,0,'Select button',Cap[Menu^.CurSel].Btn[BtnMenu^.CurSel]);
    Until BtnMenu^.CurSel = 0;
    Dispose(BtnMenu,Done);
  End; { DigitalSelectButton }

  Procedure DigitalSelectAxis;
  Var
    AxisMenu   : PMenu;
    MenuHeight : Integer;
    I          : Integer;
    X,Y        : Integer;
    Sel        : PSelection;

  Begin
    MenuHeight := NumAxes + 2;
    If MenuHeight > ((Max_Digital_Axis + 1) Div 2) + 2 Then
     MenuHeight := ((Max_Digital_Axis + 1) Div 2) + 2;
    AxisMenu := New(PMenu,InitWH(46,MenuHeight,
                    Black,LightGray,Black,LightGray,Blue,LightGray,
                    Red,LightGray,Black,Green,Red,Green,
                    DarkGray,LightGray,DarkGray,Green,
                    SingleBorder,' Select digital axis (move axis to test) ',
                    ' <Enter> selects, <Esc> exits ',True));
    AxisMenu^.Callback := CallbackProc;
    Callback.Menu      := AxisMenu;
    Callback.Slot      := Slot;
    Callback.Intf      := @Self;
    Callback.CType     := cbAxis;
    For I := 1 To NumAxes Do
    Begin
      If I <= (Max_Digital_Axis + 1) Div 2 Then
      Begin
        X := 1;
        Y := I;
      End
      Else
      Begin
        X := 17;
        Y := I - ((Max_Digital_Axis + 1) Div 2);
      End;
      If NumAxes > (Max_Digital_Axis + 1) Div 2
       Then AxisMenu^.AddSelection(X,Y,22,1,False,False,'  Digital axis ' + IntToStr(I))
       Else AxisMenu^.AddSelection(X,Y,44,1,False,False,'  Digital axis ' + IntToStr(I))
    End; { For I }

    Repeat

      { If any axes are assigned to anything, check their menu entries }

      For I := 1 To NumAxes Do
      Begin
        Sel          := AxisMenu^.GetSelection(I);
        Sel^.Checked := UsedCapability(Cap[Menu^.CurSel].Axis[I]);
      End; { For I }
      AxisMenu^.Execute;
      If AxisMenu^.CurSel > 0 Then
       SelectAxis('Select digital axis',Cap[Menu^.CurSel].Axis[AxisMenu^.CurSel]);
    Until AxisMenu^.CurSel = 0;
    Dispose(AxisMenu,Done);
  End; { DigitalSelectAxis }

  Procedure DigitalSelectHat;
  Var
    HatMenu    : PMenu;
    MenuHeight : Integer;
    I          : Integer;
    X,Y        : Integer;
    Sel        : PSelection;

  Begin
    MenuHeight := NumHats + 2;
    If MenuHeight > ((Max_Digital_Hat + 1) Div 2) + 2 Then
     MenuHeight := ((Max_Digital_Hat + 1) Div 2) + 2;
    HatMenu := New(PMenu,InitWH(42,MenuHeight,
                   Black,LightGray,Black,LightGray,Blue,LightGray,
                   Red,LightGray,Black,Green,Red,Green,
                   DarkGray,LightGray,DarkGray,Green,
                   SingleBorder,' Select hat axis (move hat axis to test) ',
                   ' <Enter> selects, <Esc> exits ',True));
    HatMenu^.Callback := CallbackProc;
    Callback.Menu     := HatMenu;
    Callback.Slot     := Slot;
    Callback.Intf     := @Self;
    Callback.CType    := cbHat;
    For I := 1 To NumHats Do
    Begin
      If I <= (Max_Digital_Hat + 1) Div 2 Then
      Begin
        X := 1;
        Y := I;
      End
      Else
      Begin
        X := 17;
        Y := I - ((Max_Digital_Hat + 1) Div 2);
      End;
      If NumHats > (Max_Digital_Hat + 1) Div 2
       Then HatMenu^.AddSelection(X,Y,20,1,False,False,'  Hat Axis ' + IntToStr(I))
       Else HatMenu^.AddSelection(X,Y,40,1,False,False,'  Hat Axis ' + IntToStr(I))
    End; { For I }

    Repeat

      { If any hat axes are assigned to anything, check their menu entries }

      For I := 1 To NumHats Do
      Begin
        Sel          := HatMenu^.GetSelection(I);
        Sel^.Checked := UsedCapability(Cap[Menu^.CurSel].Hat[I]);
      End; { For I }
      HatMenu^.Execute;
      If HatMenu^.CurSel > 0 Then
       SelectAxis('Select hat axis',Cap[Menu^.CurSel].Hat[HatMenu^.CurSel]);
    Until HatMenu^.CurSel = 0;
    Dispose(HatMenu,Done);
  End; { DigitalSelectHat }

  Procedure DigitalSelectThrottle;
  Var
    ThrMenu    : PMenu;
    MenuHeight : Integer;
    I          : Integer;
    X,Y        : Integer;
    Sel        : PSelection;

  Begin
    MenuHeight := NumThrs + 2;
    If MenuHeight > ((Max_Digital_Thr + 1) Div 2) + 2 Then
     MenuHeight := ((Max_Digital_Thr + 1) Div 2) + 2;
    ThrMenu := New(PMenu,InitWH(46,MenuHeight,
                   Black,LightGray,Black,LightGray,Blue,LightGray,
                   Red,LightGray,Black,Green,Red,Green,
                   DarkGray,LightGray,DarkGray,Green,
                   SingleBorder,' Select throttle (move throttle to test) ',
                   ' <Enter> selects, <Esc> exits ',True));
    ThrMenu^.Callback := CallbackProc;
    Callback.Menu     := ThrMenu;
    Callback.Slot     := Slot;
    Callback.Intf     := @Self;
    Callback.CType    := cbThrottle;
    For I := 1 To NumThrs Do
    Begin
      If I <= (Max_Digital_Thr + 1) Div 2 Then
      Begin
        X := 1;
        Y := I;
      End
      Else
      Begin
        X := 17;
        Y := I - ((Max_Digital_Thr + 1) Div 2);
      End;
      If NumThrs > (Max_Digital_Thr + 1) Div 2
       Then ThrMenu^.AddSelection(X,Y,22,1,False,False,'  Throttle ' + IntToStr(I))
       Else ThrMenu^.AddSelection(X,Y,44,1,False,False,'  Throttle ' + IntToStr(I))
    End; { For I }

    Repeat

      { If any throttles are assigned to anything, check their menu entries }

      For I := 1 To NumThrs Do
      Begin
        Sel          := ThrMenu^.GetSelection(I);
        Sel^.Checked := UsedCapability(Cap[Menu^.CurSel].Thr[I].Cap);
      End; { For I }
      ThrMenu^.Execute;
      If ThrMenu^.CurSel > 0 Then
       SelectAxis('Select throttle',Cap[Menu^.CurSel].Thr[ThrMenu^.CurSel].Cap);
    Until ThrMenu^.CurSel = 0;
    Dispose(ThrMenu,Done);
  End; { DigitalSelectThrottle }

  Procedure DigitalSelectAnalog;
  Var
    AnaMenu    : PMenu;
    MenuHeight : Integer;
    I          : Integer;
    X,Y        : Integer;
    Sel        : PSelection;

  Begin
    MenuHeight := NumAnas + 2;
    If MenuHeight > ((Max_Digital_Ana + 1) Div 2) + 2 Then
     MenuHeight := ((Max_Digital_Ana + 1) Div 2) + 2;
    AnaMenu := New(PMenu,InitWH(46,MenuHeight,
                   Black,LightGray,Black,LightGray,Blue,LightGray,
                   Red,LightGray,Black,Green,Red,Green,
                   DarkGray,LightGray,DarkGray,Green,
                   SingleBorder,' Select analog axis (move axis to test) ',
                   ' <Enter> selects, <Esc> exits ',True));
    AnaMenu^.Callback := CallbackProc;
    Callback.Menu     := AnaMenu;
    Callback.Slot     := Slot;
    Callback.Intf     := @Self;
    Callback.CType    := cbAnalog;
    For I := 1 To NumAnas Do
    Begin
      If I <= (Max_Digital_Ana + 1) Div 2 Then
      Begin
        X := 1;
        Y := I;
      End
      Else
      Begin
        X := 17;
        Y := I - ((Max_Digital_Ana + 1) Div 2);
      End;
      If NumAnas > (Max_Digital_Ana + 1) Div 2
       Then AnaMenu^.AddSelection(X,Y,22,1,False,False,'  Analog axis ' + IntToStr(I))
       Else AnaMenu^.AddSelection(X,Y,44,1,False,False,'  Analog axis ' + IntToStr(I))
    End; { For I }

    Repeat

      { If any axes are assigned to anything, check their menu entries }

      For I := 1 To NumAnas Do
      Begin
        Sel          := AnaMenu^.GetSelection(I);
        Sel^.Checked := UsedCapability(Cap[Menu^.CurSel].Ana[I].Cap);
      End; { For I }
      AnaMenu^.Execute;
      If AnaMenu^.CurSel > 0 Then
      Begin
       SelectAxis('Select analog axis',Cap[Menu^.CurSel].Ana[AnaMenu^.CurSel].Cap);
      End;
    Until AnaMenu^.CurSel = 0;
    Dispose(AnaMenu,Done);
  End; { DigitalSelectAnalog }

Begin
  Inherited Configure;
  I := 0;
  Repeat
    RefreshControllers;
    SlotMap := GetSlotMap;
    Inc(I);
  Until (I > 31) Or (SlotMap <> 0);

  { Find out how many controllers are connected }

  J       := 1;
  NumCons := 0;
  For I := 0 To 31 Do
  Begin
    If (SlotMap And J) <> 0 Then Inc(NumCons);
    J := J Shl 1;
  End; { For I }

  { Initialize the menu and get the controller information }

  If NumCons > 0 Then
  Begin
    Menu := New(PMenu,InitWH(44,NumCons + 2,
                Black,LightGray,Black,LightGray,Blue,LightGray,
                Red,LightGray,Black,Green,Red,Green,
                DarkGray,LightGray,DarkGray,Green,
                SingleBorder,' Detected controllers ',
                ' <Enter> selects, <Esc> exits ',True));
    J := 1;
    K := 1;
    For I := 0 To 31 Do
    Begin
      If (SlotMap And J) <> 0 Then
      Begin
        Vendor  := GetVendorName(I);
        Product := GetProductName(I);
        While (Vendor <> '') And (Vendor[1] < ' ') Do
         Vendor := Copy(Vendor,2,Length(Vendor) - 1);
        While (Product <> '') And (Product[1] < ' ') Do
         Product := Copy(Product,2,Length(Product) - 1);
        Menu^.AddSelection(1,K,42,1,False,False,Vendor + ' ' + Product);
        Inc(K);
      End;
      J := J Shl 1;
    End; { For I }

    Repeat
      Menu^.Execute;
      If Menu^.CurSel > 0 Then
      Begin

        { Find out which slot it was }

        Slot := 0;
        J    := 1;
        I    := 0;
        While (Slot < 32) And (I < Menu^.CurSel) Do
        Begin
          If (SlotMap And J) <> 0 Then Inc(I);
          If I < Menu^.CurSel Then
          Begin
            Inc(Slot);
            J := J Shl 1;
          End;
        End; { While }

        { Get the class map and find out what the controller has }

        ClassMap := GetClassMap(Slot);
        Cap[I].ClassMap := ClassMap;

        If (ClassMap And (1 Shl GRIP_CLASS_BUTTON)) <> 0
         Then NumBtns := GetMaxIndex(Slot,GRIP_CLASS_BUTTON) + 1
         Else NumBtns := 0;
        If (ClassMap And (1 Shl GRIP_CLASS_AXIS)) <> 0
         Then NumAxes := GetMaxIndex(Slot,GRIP_CLASS_AXIS) + 1
         Else NumAxes := 0;
        If (ClassMap And (1 Shl GRIP_CLASS_POV_HAT)) <> 0
         Then NumHats := GetMaxIndex(Slot,GRIP_CLASS_POV_HAT) + 1
         Else NumHats := 0;
        If (ClassMap And (1 Shl GRIP_CLASS_THROTTLE)) <> 0
         Then NumThrs := GetMaxIndex(Slot,GRIP_CLASS_THROTTLE) + 1
         Else NumThrs := 0;
        If (ClassMap And (1 Shl GRIP_CLASS_ANALOG)) <> 0
         Then NumAnas := GetMaxIndex(Slot,GRIP_CLASS_ANALOG) + 1
         Else NumAnas := 0;

        { Bound the components }

        If NumBtns > Max_Digital_Btn  Then NumBtns := Max_Digital_Btn;
        If NumAxes > Max_Digital_Axis Then NumAxes := Max_Digital_Axis;
        If NumHats > Max_Digital_Hat  Then NumHats := Max_Digital_Hat;
        If NumThrs > Max_Digital_Thr  Then NumThrs := Max_Digital_Thr;
        If NumAnas > Max_Digital_Ana  Then NumAnas := Max_Digital_Ana;

        { Build the component menu }

        CompMenu := New(PMenu,InitWH(44,7,
                        Black,LightGray,Black,LightGray,Blue,LightGray,
                        Red,LightGray,Black,Green,Red,Green,
                        DarkGray,LightGray,DarkGray,Green,
                        SingleBorder,
                        ' ' + Menu^.GetSelection(Menu^.CurSel)^.SelStr + ' ',
                        ' <Enter> selects, <Esc> exits ',True));
        If NumBtns > 0
         Then CompMenu^.AddSelection(1,1,42,1,False,False,'Buttons (' + IntToStr(NumBtns) + ')')
         Else CompMenu^.AddSelection(1,1,42,1,True ,False,'Buttons (' + IntToStr(NumBtns) + ')');
        If NumAxes > 0
         Then CompMenu^.AddSelection(1,2,42,1,False,False,'Digital axes (' + IntToStr(NumAxes) + ')')
         Else CompMenu^.AddSelection(1,2,42,1,True ,False,'Digital axes (' + IntToStr(NumAxes) + ')');
        If NumHats > 0
         Then CompMenu^.AddSelection(1,3,42,1,False,False,'Hat axes (' + IntToStr(NumHats) + ')')
         Else CompMenu^.AddSelection(1,3,42,1,True ,False,'Hat axes (' + IntToStr(NumHats) + ')');
        If NumThrs > 0
         Then CompMenu^.AddSelection(1,4,42,1,False,False,'Throttles (' + IntToStr(NumThrs) + ')')
         Else CompMenu^.AddSelection(1,4,42,1,True ,False,'Throttles (' + IntToStr(NumThrs) + ')');
        If NumAnas > 0
         Then CompMenu^.AddSelection(1,5,42,1,False,False,'Analog axes (' + IntToStr(NumAnas) + ')')
         Else CompMenu^.AddSelection(1,5,42,1,True ,False,'Analog axes (' + IntToStr(NumAnas) + ')');
        Repeat
          CompMenu^.Execute;
          If CompMenu^.CurSel > 0 Then
          Begin
            Case CompMenu^.CurSel Of
              1: DigitalSelectButton;
              2: DigitalSelectAxis;
              3: DigitalSelectHat;
              4: DigitalSelectThrottle;
              5: DigitalSelectAnalog;
            End; { Case }
          End;
        Until CompMenu^.CurSel = 0;
        Dispose(CompMenu,Done);
      End;
    Until Menu^.CurSel = 0;
    Dispose(Menu,Done);
  End
  Else Popup('There were no controllers detected.');
End; { TDigitalInterface.Configure }

Procedure TDigitalInterface.GetControllerInfo(Var Controllers: TCapability;
                                              Var Info: TAtariControls);
Var
  SlotMap  : LongInt;
  ClassMap : LongInt;
  Slot     : Integer;
  Cont     : Integer;
  Mask     : LongInt;
  NumBtns  : Integer;
  NumAxes  : Integer;
  NumHats  : Integer;
  NumThrs  : Integer;
  NumAnas  : Integer;
  I        : Integer;
  CapMask  : TCapability;
  MaxThr   : Word;
  MaxAna   : Word;

Begin

  { Initialize the capability mask to include all capabliities }

  SetAllCapability(CapMask);

  { Get the slot map }

  SlotMap := GetSlotMap;
  Mask    := 1;
  Cont    := 0;

  { Refresh the controllers }

  RefreshControllers;
  For Slot := 0 To 31 Do
  Begin
    If (SlotMap And Mask) <> 0 Then
    Begin
      Inc(Cont);
      If Not Cap[Cont].Loaded Then
      Begin

        { Fill in the Cap entry }

        { Get the class map and find out what the controller has }

        Cap[Cont].ClassMap := GetClassMap(Slot);

        { Find out how much of each component the controller has }

        If (Cap[Cont].ClassMap And (1 Shl GRIP_CLASS_BUTTON)) <> 0
         Then Cap[Cont].NumBtns := GetMaxIndex(Slot,GRIP_CLASS_BUTTON) + 1
         Else Cap[Cont].NumBtns := 0;
        If (Cap[Cont].ClassMap And (1 Shl GRIP_CLASS_AXIS)) <> 0
         Then Cap[Cont].NumAxes := GetMaxIndex(Slot,GRIP_CLASS_AXIS) + 1
         Else Cap[Cont].NumAxes := 0;
        If (Cap[Cont].ClassMap And (1 Shl GRIP_CLASS_POV_HAT)) <> 0
         Then Cap[Cont].NumHats := GetMaxIndex(Slot,GRIP_CLASS_POV_HAT) + 1
         Else Cap[Cont].NumHats := 0;
        If (Cap[Cont].ClassMap And (1 Shl GRIP_CLASS_THROTTLE)) <> 0
         Then Cap[Cont].NumThrs := GetMaxIndex(Slot,GRIP_CLASS_THROTTLE) + 1
         Else Cap[Cont].NumThrs := 0;
        If (Cap[Cont].ClassMap And (1 Shl GRIP_CLASS_ANALOG)) <> 0
         Then Cap[Cont].NumAnas := GetMaxIndex(Slot,GRIP_CLASS_ANALOG) + 1
         Else Cap[Cont].NumAnas := 0;

        { Bound the components }

        If Cap[Cont].NumBtns > Max_Digital_Btn  Then Cap[Cont].NumBtns := Max_Digital_Btn;
        If Cap[Cont].NumAxes > Max_Digital_Axis Then Cap[Cont].NumAxes := Max_Digital_Axis;
        If Cap[Cont].NumHats > Max_Digital_Hat  Then Cap[Cont].NumHats := Max_Digital_Hat;
        If Cap[Cont].NumThrs > Max_Digital_Thr  Then Cap[Cont].NumThrs := Max_Digital_Thr;
        If Cap[Cont].NumAnas > Max_Digital_Ana  Then Cap[Cont].NumAnas := Max_Digital_Ana;
        If Cap[Cont].ClassMap <> 0 Then Cap[Cont].Loaded := True;
      End;
      If Cap[Cont].Loaded Then
      Begin

        { Get the raw info }

        ContInfo.Buttons := GetPackedValues(Slot,GRIP_CLASS_BUTTON,0,31);
        For I := 1 To Cap[Cont].NumAxes Do ContInfo.Axis[I]     := GetValue(Slot,GRIP_CLASS_AXIS    ,I - 1);
        For I := 1 To Cap[Cont].NumHats Do ContInfo.Hat[I]      := GetValue(Slot,GRIP_CLASS_POV_HAT ,I - 1);
        For I := 1 To Cap[Cont].NumThrs Do ContInfo.Throttle[I] := GetValue(Slot,GRIP_CLASS_THROTTLE,I - 1);
        For I := 1 To Cap[Cont].NumAnas Do ContInfo.Analog[I]   := GetValue(Slot,GRIP_CLASS_ANALOG  ,I - 1);

        { Get the maximum values }

        MaxThr := GetMaxValue(Slot,GRIP_CLASS_THROTTLE);
        MaxAna := GetMaxValue(Slot,GRIP_CLASS_ANALOG);

        { Process the buttons }

        For I := 1 To Cap[Cont].NumBtns Do
         GetDigitalAny(((ContInfo.Buttons And (1 Shl (I - 1))) <> 0),
          Cap[Cont].Btn[I],CapMask,Controllers,Info);

        { Process the digital axes }

        For I := 1 To Cap[Cont].NumAxes Do
        Begin

          { Assume that even-numbered axes have to be flipped }

          If (I And 1) <> 0 Then
          Begin
            GetAnalog(0,10,20,10 * ContInfo.Axis[I],0,Cap[Cont].Axis[I],
             CapMask,Controllers,Info);
          End
          Else
          Begin
            GetAnalog(0,10,20,10 * (2 - ContInfo.Axis[I]),0,Cap[Cont].Axis[I],
             CapMask,Controllers,Info);
          End;
        End; { For I }

        { Process the hats }

        For I := 1 To Cap[Cont].NumHats Do
        Begin

          { Assume that even-numbered hat axes have to be flipped }

          If (I And 1) <> 0 Then
          Begin
            GetAnalog(0,10,20,10 * ContInfo.Hat[I],0,Cap[Cont].Hat[I],
             CapMask,Controllers,Info);
          End
          Else
          Begin
            GetAnalog(0,10,20,10 * (2 - ContInfo.Hat[I]),0,Cap[Cont].Hat[I],
             CapMask,Controllers,Info);
          End;
        End; { For I }

        { Process the throttles }

        For I := 1 To Cap[Cont].NumThrs Do
         GetAnalog(0,MaxThr Div 2,MaxThr,ContInfo.Throttle[I],0,Cap[Cont].Thr[I].Cap,
          CapMask,Controllers,Info);

        { Process the analogs }

        For I := 1 To Cap[Cont].NumAnas Do
         GetAnalog(0,MaxAna Div 2,MaxAna,ContInfo.Analog[I],0,Cap[Cont].Ana[I].Cap,
          CapMask,Controllers,Info);
      End;
    End
    Else Cap[Cont].Loaded := False;
    Mask := Mask Shl 1;
  End; { For Slot }

  { Remove capabilities that were used }

  AndCapabilities(CapMask,Controllers);
End; { TDigitalInterface.GetControllerInfo }

Procedure TDigitalInterface.BtnCallback;
Var
  I       : Integer;
  Sel     : PSelection;
  Buttons : GRIP_BITFIELD;
  Checked : Boolean;

Begin
  If (GetSlotMap And (1 Shl Callback.Slot)) <> 0 Then
  Begin

    { Refresh the controllers }

    RefreshControllers;
    Buttons := GetPackedValues(Callback.Slot, GRIP_CLASS_BUTTON, 0, 31);
    For I := 1 To Callback.Menu^.SelList^.Count Do
    Begin
      Sel     := Callback.Menu^.GetSelection(I);
      Checked := (Buttons And (1 Shl (I - 1)) <> 0);
      If Sel^.Asterisk <> Checked Then
      Begin
        Sel^.Asterisk := Checked;
        Callback.Menu^.DisplaySelection(I);
      End;
    End; { For I }
  End;
End; { TDigitalInterface.BtnCallback }

Procedure TDigitalInterface.AxisCallback;
Var
  I       : Integer;
  Sel     : PSelection;
  Axis    : Word;
  Checked : Boolean;

Begin
  If (GetSlotMap And (1 Shl Callback.Slot)) <> 0 Then
  Begin
    { Refresh the controllers }

    RefreshControllers;
    For I := 1 To Callback.Menu^.SelList^.Count Do
    Begin
      Axis := GetValue(Callback.Slot, GRIP_CLASS_AXIS, I - 1);
      Sel  := Callback.Menu^.GetSelection(I);
      If Sel^.Bar <> (Axis And 3) Then
      Begin
        Sel^.Bar := Axis And 3;
        Callback.Menu^.DisplaySelection(I);
      End;
    End; { For I }
  End;
End; { TDigitalInterface.AxisCallback }

Procedure TDigitalInterface.HatCallback;
Var
  I       : Integer;
  Sel     : PSelection;
  Hat     : Word;
  Checked : Boolean;

Begin
  If (GetSlotMap And (1 Shl Callback.Slot)) <> 0 Then
  Begin
    { Refresh the controllers }

    RefreshControllers;
    For I := 1 To Callback.Menu^.SelList^.Count Do
    Begin
      Hat := GetValue(Callback.Slot, GRIP_CLASS_POV_HAT, I - 1);
      Sel := Callback.Menu^.GetSelection(I);
      If Sel^.Bar <> (Hat And 3) Then
      Begin
        Sel^.Bar := Hat And 3;
        Callback.Menu^.DisplaySelection(I);
      End;
    End; { For I }
  End;
End; { TDigitalInterface.HatCallback }

Procedure TDigitalInterface.ThrCallback;
Var
  I        : Integer;
  Sel      : PSelection;
  Throttle : Word;
  Checked  : Boolean;

Begin
  If (GetSlotMap And (1 Shl Callback.Slot)) <> 0 Then
  Begin
    { Refresh the controllers }

    RefreshControllers;
    For I := 1 To Callback.Menu^.SelList^.Count Do
    Begin
      Throttle := GetValue(Callback.Slot, GRIP_CLASS_THROTTLE, I - 1);
      Sel      := Callback.Menu^.GetSelection(I);
      If Sel^.Bar <> (Throttle And 3) Then
      Begin
        Sel^.Bar := Throttle And 3;
        Callback.Menu^.DisplaySelection(I);
      End;
    End; { For I }
  End;
End; { TDigitalInterface.ThrCallback }

Procedure TDigitalInterface.AnaCallback;
Var
  I       : Integer;
  Sel     : PSelection;
  Analog  : Word;
  Checked : Boolean;

Begin
  If (GetSlotMap And (1 Shl Callback.Slot)) <> 0 Then
  Begin
    { Refresh the controllers }

    RefreshControllers;
    For I := 1 To Callback.Menu^.SelList^.Count Do
    Begin
      Analog := GetValue(Callback.Slot, GRIP_CLASS_ANALOG, I - 1);
      Sel    := Callback.Menu^.GetSelection(I);
      If Sel^.Bar <> (Analog And 3) Then
      Begin
        Sel^.Bar := Analog And 3;
        Callback.Menu^.DisplaySelection(I);
      End;
    End; { For I }
  End;
End; { TDigitalInterface.AnaCallback }

{ ------------------ }
{ TGrIPInterface     }
{ ------------------ }

Constructor TGrIPInterface.Init;
Begin
  Inherited Init('GrIP');
End; { TGrIPInterface.Init }

Destructor TGrIPInterface.Done;
Begin
  Inherited Done;
End; { TGrIPInterface.Done }

Procedure TGrIPInterface.RefreshControllers;
Begin
  GrRefresh(0);
End; { TGrIPInterface.RefreshControllers }

Function TGrIPInterface.GetVendorName(Slot: Integer): String;
Var _Vendor  : Array[0..63] Of Char; { Vendor name for slot  }
Begin
  GrGetVendorName(Slot,@_Vendor);
  GetVendorName := StrPas(_Vendor);
End; { TGrIPInterface.GetVendorName }

Function TGrIPInterface.GetProductName(Slot: Integer): String;
Var _Product : Array[0..63] Of Char; { Product name for slot }
Begin
  GrGetProductName(Slot,@_Product);
  GetProductName := StrPas(_Product);
End; { TGrIPInterface.GetProductName }

Function TGrIPInterface.GetSlotMap: GRIP_BITFIELD;
Begin
  GetSlotMap := GrGetSlotMap;
End; { TGrIPInterface.GetSlotMap }

Function TGrIPInterface.GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;
Begin
  GetClassMap := GrGetClassMap(S);
End; { TGrIPInterface.GetClassMap }

Function TGrIPInterface.GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX;
Begin
  GetMaxIndex := GrGetMaxIndex(S,C);
End; { TGrIPInterface.GetMaxIndex }

Function TGrIPInterface.GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE;
Begin
  GetMaxValue := GrGetMaxValue(S,C);
End; { TGrIPInterface.GetMaxValue }

Function TGrIPInterface.GetPackedValues(S: GRIP_SLOT; C: GRIP_CLASS; IStart: GRIP_INDEX;
                               IEnd: GRIP_INDEX): GRIP_BITFIELD;
Begin
  GetPackedValues := GrGetPackedValues(S,C,IStart,IEnd);
End; { TGrIPInterface.GetPackedValues }

Function TGrIPInterface.GetValue(S: GRIP_SLOT; C: GRIP_CLASS;
                                    I: GRIP_INDEX): GRIP_VALUE;
Begin
  GetValue := GrGetValue(S,C,I);
End; { TGrIPInterface.GetValue }

Procedure TGrIPInterface.Activate;
Var I: Integer;
Begin
  If GrIP_Loaded Then
  Begin
    If GrLink(GrIP_Image,GrIP_ImgSize) Then
    Begin
      If GrInitialize <> 0 Then
      Begin
        Inherited Activate;
      End
      Else
      Begin
        GrUnlink;
        Popup('The GrIP driver could not be initialized.');
      End;
      If Active Then
       For I := 1 To Max_Digital_Con Do Cap[I].Loaded := False;
    End
    Else Popup('The GrIP driver could not be loaded.');
  End
  Else Popup('The GrIP driver was not detected.');
End; { TGrIPInterface.Activate }

Procedure TGrIPInterface.Deactivate;
Begin
  If Active Then GrUnlink;
  Inherited Deactivate;
End; { TGrIPInterface.Deactivate }

{ -------------------- }
{ TSideWinderInterface }
{ -------------------- }

Constructor TSideWinderInterface.Init;
Begin
  Inherited Init('SideWinder');
  ProdName    := '';
  CMap        := 0;
  Max_Btn     := 0;
  Max_Axis    := 0;
  Max_Hat     := 0;
  Max_Thr     := 0;
  Max_Ana     := 0;
  Max_Thr_Val := 0;
  Max_Ana_Val := 0;
  ReadTime    := 0;
End; { TSideWinderInterface.Init }

Destructor TSideWinderInterface.Done;
Begin
  Inherited Done;
End; { TSideWinderInterface.Done }

Function TSideWinderInterface.GetVendorName(Slot: Integer): String;
Begin
  GetVendorName := 'Microsoft';
End; { TSideWinderInterface.GetVendorName }

Function TSideWinderInterface.GetProductName(Slot: Integer): String;
Begin
  If GetClassMap(Slot) <> 0 Then
  Begin
    GetProductName := ProdName;
  End
  Else GetProductName := '';
End; { TSideWinderInterface.GetProductName }

Function TSideWinderInterface.GetSlotMap: GRIP_BITFIELD;
Var
  Slot    : Integer;
  SlotMap : GRIP_BITFIELD;

Begin
  RefreshControllers;

  If PacketLen > 0 Then SlotMap := 1 Else SlotMap := 0;
  GetSlotMap := SlotMap;
End; { TSideWinderInterface.GetSlotMap }

Function TSideWinderInterface.GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;
Begin
  If (GetSlotMap And (1 Shl S)) <> 0 Then
  Begin
    GetClassMap := CMap;
  End
  Else GetClassMap := 0;
End; { TSideWinderInterface.GetClassMap }

Function TSideWinderInterface.GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX;
Var MaxIndex: Integer;
Begin
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    Case C Of
      GRIP_CLASS_BUTTON:   MaxIndex := Max_Btn;
      GRIP_CLASS_AXIS:     MaxIndex := Max_Axis;
      GRIP_CLASS_POV_HAT:  MaxIndex := Max_Hat;
      GRIP_CLASS_THROTTLE: MaxIndex := Max_Thr;
      GRIP_CLASS_ANALOG:   MaxIndex := Max_Ana;
    Else
      MaxIndex := 0;
    End; { Case }
    GetMaxIndex := MaxIndex;
(*
    Case PacketLen Of
      15: Begin
            Case C Of
              GRIP_CLASS_BUTTON: GetMaxIndex := 9;
                GRIP_CLASS_AXIS: GetMaxIndex := 1;
            Else
              GetMaxIndex := 0;
            End; { Case }
          End;
      48: Begin
            Case C Of
              GRIP_CLASS_BUTTON: GetMaxIndex := 8;
             GRIP_CLASS_POV_HAT: GetMaxIndex := 1;
            GRIP_CLASS_THROTTLE: GetMaxIndex := 0;
              GRIP_CLASS_ANALOG: GetMaxIndex := 2;
            Else
              GetMaxIndex := 0;
            End; { Case }
          End;
    End; { Case }
*)
  End
  Else GetMaxIndex := 0;
End; { TSideWinderInterface.GetMaxIndex }

Function TSideWinderInterface.GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE;
Begin
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    Case C Of
      GRIP_CLASS_AXIS:     GetMaxValue := 2;
      GRIP_CLASS_POV_HAT:  GetMaxValue := 2;
      GRIP_CLASS_THROTTLE: GetMaxValue := Max_Thr_Val;
      GRIP_CLASS_ANALOG:   GetMaxValue := Max_Ana_Val;
    Else
      GetMaxValue := 0;
    End; { Case }
(*
    Case PacketLen Of
      15: Begin
            Case C Of
              GRIP_CLASS_AXIS: GetMaxValue := 2;
            Else
              GetMaxValue := 0;
            End; { Case }
          End;
      48: Begin
            Case C Of
             GRIP_CLASS_POV_HAT: GetMaxValue := 2;
            GRIP_CLASS_THROTTLE: GetMaxValue := 63;
              GRIP_CLASS_ANALOG: GetMaxValue := 1023;
            Else
              GetMaxValue := 0;
            End; { Case }
          End;
    End; { Case }
*)
  End
  Else GetMaxValue := 0;
End; { TSideWinderInterface.GetMaxValue }

Procedure TSideWinderInterface.LoadConfiguration(F: PINIFile);
Begin
  Inherited LoadConfiguration(F);
  PacketLen := F^.ReadInteger(Name,'PACKETLEN1',0);
End; { TSideWinderInterface.LoadConfiguration }

Procedure TSideWinderInterface.SaveConfiguration(F: PINIFile);
Begin
  Inherited SaveConfiguration(F);
  F^.WriteInteger(Name,'PACKETLEN1',PacketLen);
End; { TSideWinderInterface.SaveConfiguration }

Procedure TSideWinderInterface.Configure;
Begin
  CMap := 0;
  Inherited Configure;
End; { TSideWinderInterface.Configure }

Procedure TSideWinderInterface.RefreshControllers;
Const

  { Gravis controllers report the vertical axis such that up is 2 and }
  { down is zero, so we'll do the same thing with SideWinder          }
  { controllers.  This allows the same code to handle the readings.   }

  Hat_To_Axis: Array[0..8] Of TXYPoint =
   ((X: 0; Y: 0),
    (X: 0; Y: 1),
    (X: 1; Y: 1),
    (X: 1; Y: 0),
    (X: 1; Y:-1),
    (X: 0; Y:-1),
    (X:-1; Y:-1),
    (X:-1; Y: 0),
    (X:-1; Y: 1));
  BitToValue: Array[0..3] Of Integer = (0,2,2,0);

Var
  Channel      : TDigitalPacket;
  I,J          : Integer;
  Hat          : Byte;
  Kick         : Integer;
  NewPacketLen : Integer;
  Found        : Boolean;
  Pkt          : PDigitalPacketDef;
  Num          : Integer;
  Bit          : Integer;
  MaxThrVal    : Array[1..Max_Digital_Thr] Of Integer;
  MaxAnaVal    : Array[1..Max_Digital_Ana] Of Integer;
  Parity       : Integer;

  Procedure Reset;
  Var I: Integer;
  Begin
{    CMap        := 0;}
    PacketLen   := NewPacketLen;
    ProdName    := Pkt^.Nam;
    Hat         := 0;
    Max_Btn     := 0;
    Max_Axis    := 0;
    Max_Hat     := 0;
    Max_Thr     := 0;
    Max_Ana     := 0;
    Max_Thr_Val := 0;
    Max_Ana_Val := 0;
    Parity      := 0;
    FillChar(ConInfo,SizeOf(ConInfo),#0);
    For I := 1 To Max_Digital_Axis Do ConInfo.Axis[I] := 1;
  End; { Reset }

  Function ReadPacket(Var Packet: TDigitalPacket): Integer;
  Var
    Channel      : TDigitalPacket;
    Count        : LongInt;
    ChLen        : Word;
    I,J          : Integer;
    NewPacketLen : Integer;
    Size         : Integer;
    Cycle        : LongInt;
    CycleTime    : LongInt;
    CycleStart   : LongInt;
    LoopTime     : LongInt;
    CycleSet     : Boolean;
    CycleBegin   : Boolean;

    Procedure Expand1;
    Var I: Integer;
    Begin
      For I := 0 To ChLen - 1 Do Channel[I] := (Channel[I] And $20) Shr 5;
      NewPacketLen := ChLen;
    End; { Expand1 }

    Procedure Expand3;
    Var I: Integer;
    Begin
      For I := ChLen - 1 DownTo 0 Do
      Begin
        If (I * 3) + 2 < SizeOf(Channel) Then
        Begin

          { Flip bits }

          If (Channel[I] And $80) = 0
           Then Channel[I * 3 + 2] := 0
           Else Channel[I * 3 + 2] := 1;
          If (Channel[I] And $40) = 0
           Then Channel[I * 3 + 1] := 0
           Else Channel[I * 3 + 1] := 1;
          If (Channel[I] And $20) = 0
           Then Channel[I * 3] := 0
           Else Channel[I * 3] := 1;
        End;
      End; { For I }
      NewPacketLen := ChLen * 3;
    End; { Expand3 }

    Procedure Expand;
    Var
      I,J,K : Integer;
      Uses3 : Boolean;

    Begin

      { Determine if the packet used only one or all three bits }

      Uses3 := False;
      I     := 1;
      J     := 0;
      K     := 0;
      If ChLen < 8 Then Uses3 := True Else
      Begin
        While (I < ChLen) And Not Uses3 Do
        Begin
          If (Channel[I] And $80) <> (Channel[I - 1] And $80) Then K := $FF Else K := 0;
          J := J Xor (Channel[I] Xor K Xor Channel[I - 1]);
          If (J And $C0) <> 0
           Then Uses3 := True
           Else Inc(I);
        End; { While }
      End;
      If Uses3 Then Expand3 Else Expand1;
  (*
      J := 0;
      For I := 1 To ChLen - 1 Do J := J Or (Channel[I - 1] Xor Channel[I]);
      J ;= (J Shr 5) And 6;
      If (J And $C0) <> 0 Then Expand3 Else Expand1;
  *)
  {    If (J And $70) = 0 Then NewPacketLen := 0;}
    End; { Expand }

  Begin
    FillChar(Channel,SizeOf(Channel),#0);  { Initialize with zeroes }
    Count      := MaxJoyCount;
    Size       := MaxChannelLength;
    Cycle      := 0;
    CycleTime  := 0;
    CycleSet   := False;
    CycleBegin := False;
    CycleStart := 0;
    LoopTime   := 0;
    Asm
      MOV   DX,JoyPort                     { Reset the joystick port }
      MOV   AL,0FFh
      OUT   DX,AL
      IN    AL,DX                          { Read the initial value }

      MOV   BL,AL                          { Save the initial value }
      DB    _32BIT_OPERAND                 { Set the timeout counter }
      MOV   CX,WORD PTR Count
      SUB   SI,SI                          { Packet pointer }

      { Wait for first falling edge on clock }

  @ClockLoop:
      DB    _32BIT_OPERAND                 { Decrement the timeout counter }
      DEC   CX
      JS    @GetOut                        { Exit if timeout }
      IN    AL,DX                          { Read a byte }
      MOV   BH,AL                          { Save it }
      XOR   AL,BL                          { See if anything has changed }
      TEST  AL,10h
      JZ    @ClockLoop
      TEST  BH,10h                         { Check for the falling edge }
      JNZ   @ClockLoop

      { Get data on rising edges }

  @PacketLoop:
      DB    _32BIT_OPERAND                 { Decrement the timeout counter }
      DEC   CX
      JS    @GetOut                        { Exit if timeout }
      IN    AL,DX                          { Read a byte }

      MOV   BH,AL                          { Save it }
      XOR   AL,BL                          { See if anything has changed }

      TEST  AL,10h                         { See if the clock bit changed }
      JZ    @NoClockChanged
      TEST  BH,10h                         { Check for the rising edge }
      JNZ   @DataAvailable

  @NoClockChanged:
      TEST  BYTE PTR CycleSet,0FFh         { Do we know the cycle time? }
      JZ    @NextByte
      DB    _32BIT_OPERAND                 { Exit if the clock has stopped }
      DEC   WORD PTR Cycle
      JZ    @GetOut
      JMP   @NextByte

  @DataAvailable:
      TEST  BYTE PTR CycleBegin,0FFh       { See if we've recorded the }
      JNZ   @FoundBeginning                {  starting time }
      MOV   BYTE PTR CycleBegin,1
      DB    _32BIT_OPERAND
      PUSH  AX
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR LoopTime
      DB    _32BIT_OPERAND
      MOV   WORD PTR CycleStart,AX
      DB    _32BIT_OPERAND
      POP   AX
      JMP   @CycleSet

  @FoundBeginning:
      TEST  BYTE PTR CycleSet,0FFh
      JNZ   @CycleSet
      DB    _32BIT_OPERAND                 { Record 4x the cycle time }
      PUSH  AX
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR LoopTime
      DB    _32BIT_OPERAND
      SUB   AX,WORD PTR CycleStart
      DB    _32BIT_OPERAND
      SHL   AX,2
      DB    _32BIT_OPERAND
      MOV   WORD PTR CycleTime,AX
      MOV   BYTE PTR CycleSet,1
      DB    _32BIT_OPERAND
      POP   AX

  @CycleSet:
      DB    _32BIT_OPERAND                 { Reset the cycle time counter }
      PUSH  AX
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR CycleTime
      DB    _32BIT_OPERAND
      MOV   WORD PTR Cycle,AX
      DB    _32BIT_OPERAND
      POP   AX

      TEST  BH,1                           { If bit 0 goes low, then we're }
      JNZ   @NotHalf                       {  halfway through the packet   }
      CMP   WORD PTR Size,MaxChannelLength
      JNZ   @NotHalf
      CMP   SI,4                           { Ignore any initial low state }
      JBE   @NotHalf
      MOV   WORD PTR Size,SI
      ADD   WORD PTR Size,4                { Allow some fuzziness }
      SHL   WORD PTR Size,1
  @NotHalf:

      { Save the data }

      MOV   BYTE PTR Channel[SI],BH
      INC   SI

      CMP   SI,WORD PTR Size               { Exit if we reach the packet size }
      JAE   @GetOut

  @NextByte:
      MOV   BL,BH                          { Save the byte that was read }
      DB    _32BIT_OPERAND
      INC   WORD PTR LoopTime
      JMP   @PacketLoop
  @GetOut:
      DB    _32BIT_OPERAND                 { Save the final counter }
      MOV   WORD PTR Count,CX
      MOV   WORD PTR ChLen,SI
    End; { Asm }
{    Delay(4); }    { Need this! }

    { Evaluate the packet }
(*
    Screen.FastWrite(1,3,7,'ChLen:' + IntToStr(ChLen) + '  ' +
          'Count:' + IntToStr(Count) + '   ');
*)
    If ChLen < MaxChannelLength Then
    Begin
      Expand;
      ReadPacket := NewPacketLen;
      Move(Channel,Packet,SizeOf(Packet));
    End
    Else ReadPacket := 0;
  End; { ReadPacket }

Label Retry,First;

Begin
  If Clock < ReadTime + 4 Then Exit;

  FillChar(Channel,SizeOf(Channel),#0);  { Initialize with zeroes }
  FillChar(MaxThrVal,SizeOf(MaxThrVal),#0);
  FillChar(MaxAnaVal,SizeOf(MaxAnaVal),#0);
  Kick := 50;
  Goto First;
Retry:
  Delay(4);
First:
  NewPacketLen := ReadPacket(Channel);
  ReadTime := Clock;




(*
  Popup('ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(Count));
*)
{
  Screen.FastWrite(1,3,7,'ChLen:' + IntToStr(ChLen) + '  ' +
        'Count:' + IntToStr(Count) + '   ');
}


{  For I := 0 To 29 Do Screen.FastWrite(I * 3 + 1,1,7,HexByte(Channel[I]));}

{
  Screen.FastWrite(1,2,7,'CMap: ' + IntToStr(CMap) + '  ');
  Screen.FastWrite(1,3,7,'ProdName: ' + ProdName + '  ');
  Screen.FastWrite(1,4,7,'PacketLen: ' + IntToStr(PacketLen) + '  ');
  Screen.FastWrite(1,5,7,'ChLen: ' + IntToStr(ChLen) + '  ');
}
  If {(ChLen < SizeOf(Channel)) And} (PacketDef^.Count > 0) Then
  Begin

{    Screen.FastWrite(1,6,7,'NewPacketLen: ' + IntToStr(NewPacketLen) + '  ');}

    If NewPacketLen > 0 Then
    Begin

{      Screen.FastWrite(1,5,7,'NewPacketLen: ' + IntToStr(NewPacketLen) + '  ');}
{      Screen.Write('NewPacketLen: ' + IntToStr(NewPacketLen) + '  ');}

{      Screen.FastWrite(1,8,7,'CMap = ' + HexLongInt(CMap) + '     ');}

{      If CMap = 0 Then
      Begin}
        I     := 0;
        Found := False;
        While (I < PacketDef^.Count) And Not Found Do
        Begin
          Pkt := PDigitalPacketDef(PacketDef^.At(I));

          { If the controller is sending three bits at a time, it can send }
          { an extra bit or two under some circumstances compared to when  }
          { the controller is in single-bit mode.                          }

          If ((Pkt^.Len Mod 3) = 1) And (NewPacketLen = Pkt^.Len + 2) Then NewPacketLen := Pkt^.Len;
          If ((Pkt^.Len Mod 3) = 2) And (NewPacketLen = Pkt^.Len + 1) Then NewPacketLen := Pkt^.Len;

          If NewPacketLen = Pkt^.Len Then Found := True;
          Inc(I);
        End; { While }
{      End
      Else Found := (NewPacketLen = PacketLen);}
{
      If Found
       Then Screen.FastWrite(1,7,7,'FOUND')
       Else Screen.FastWrite(1,7,7,'NOT FOUND');
}
      { Evaluate the packet }

      If Found Then
      Begin
        Reset;

        { Evaluate bits }
{
        J := 0;
        For I := 0 To NewPacketLen - 1 Do If Channel[I] <> 0 Then Inc(J);
}
        For I := 0 To NewPacketLen - 1 Do
        Begin
{
          Screen.FastWrite(I + 1,10,7,IntToStr(Channel[I]));
          Screen.FastWrite(I + 1,11,7,Chr(Pkt^.Def[I]));
}
{          Screen.FastWrite(1,12,7,IntToStr(J));}

          If (Channel[I] <> 0) And (Chr(Pkt^.Def[I]) <> 'P') Then
           Parity := Parity Xor 1;

          Case Chr(Pkt^.Num[I]) Of
            '0'..'9': Num := Pkt^.Num[I] - Ord('0');
            'A'..'Z': Num := Pkt^.Num[I] - Ord('A') + 10;
          Else
            Num := 0;
          End; { Case }
          Case Chr(Pkt^.Bit[I]) Of
            '0'..'9': Bit := Pkt^.Bit[I] - Ord('0');
            'A'..'Z': Bit := Pkt^.Bit[I] - Ord('A') + 10;
          Else
            Bit := 0;
          End; { Case }
          Case Chr(Pkt^.Def[I]) Of
            'B': Begin
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> 0 Then
                    ConInfo.Buttons := ConInfo.Buttons Or (1 Shl Num);
                   CMap := CMap Or (1 Shl GRIP_CLASS_BUTTON);
                   If Num > Max_Btn Then Max_Btn := Num;
                 End;
            'X': Begin
                   Num := Num * 2;
                   If Bit > 1 Then Inc(Num);
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> 0 Then ConInfo.Axis[Num + 1] := BitToValue[Bit];
                   CMap := CMap Or (1 Shl GRIP_CLASS_AXIS);
                   If Num > Max_Axis Then Max_Axis := Num;
                 End;
            'H': Begin
                   Num := Num * 2 + 1;
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> 0 Then Hat := Hat Or (1 Shl Bit);
                   Case Hat Of
                   0..8: Begin
                           ConInfo.Hat[Num]     := (Hat_To_Axis[Hat].X + 1);
                           ConInfo.Hat[Num + 1] := (Hat_To_Axis[Hat].Y + 1);
                         End;
                   End; { Case }
                   CMap := CMap Or (1 Shl GRIP_CLASS_POV_HAT);
                   If Num > Max_Hat Then Max_Hat := Num;
                 End;
            'T': Begin
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> 0 Then
                    ConInfo.Throttle[Num + 1] := ConInfo.Throttle[Num + 1] Or (1 Shl Bit);
                   CMap := CMap Or (1 Shl GRIP_CLASS_THROTTLE);
                   If (1 Shl (Bit + 1)) - 1 > Max_Thr_Val Then
                    Max_Thr_Val := (1 Shl (Bit + 1)) - 1;
                   If (1 Shl (Bit + 1)) - 1 > MaxThrVal[Num + 1] Then
                    MaxThrVal[Num + 1] := (1 Shl (Bit + 1)) - 1;
                   If Num > Max_Thr Then Max_Thr := Num;
                 End;
            'A': Begin
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> 0 Then
                    ConInfo.Analog[Num + 1] := ConInfo.Analog[Num + 1] Or (1 Shl Bit);
                   CMap := CMap Or (1 Shl GRIP_CLASS_ANALOG);
                   If (1 Shl (Bit + 1)) - 1 > Max_Ana_Val Then
                    Max_Ana_Val := (1 Shl (Bit + 1)) - 1;
                   If (1 Shl (Bit + 1)) - 1 > MaxAnaVal[Num + 1] Then
                    MaxAnaVal[Num + 1] := (1 Shl (Bit + 1)) - 1;
                   If Num > Max_Ana Then Max_Ana := Num;
                 End;
            '0': If Channel[I] = 1 Then Exit;
(*                 Begin
                   CMap := 0;
{                   Delay(4);}
                   Dec(Kick);
                   If Kick <> 0 Then Goto Retry;
                   Reset;
                   ProdName := '';
                   Exit;
                 End;*)
            '1': If Channel[I] = 0 Then Exit;
(*                 Begin
                   CMap := 0;
{                   Delay(4);}
                   Dec(Kick);
                   If Kick <> 0 Then Goto Retry;
                   Reset;
                   ProdName := '';
                   Exit;
                 End;*)
            'P': Begin
                   If Chr(Pkt^.Flp[I]) <> '0' Then Channel[I] := Channel[I] Xor 1;
                   If Channel[I] <> (Parity Xor 1) Then Exit;
(*                   Begin
                     CMap := 0;
{                     Delay(4);}
                     Dec(Kick);
                     If Kick <> 0 Then Goto Retry;
                     Reset;
                     ProdName := '';
                     Exit;
                   End;*)
                 End;
          End; { Case }
        End; { For I }
{
        Screen.FastWrite(1,12,7,IntToStr(ConInfo.Axis[1]));
        Screen.FastWrite(1,13,7,IntToStr(ConInfo.Axis[2]));
}
{
        Screen.FastWrite(1,12,7,IntToStr(ConInfo.Hat[1]));
        Screen.FastWrite(1,13,7,IntToStr(ConInfo.Hat[2]));
}
        { Scale throttles up to the same range }

        J := 0;
        For I := 1 To Max_Digital_Thr Do
         If MaxThrVal[I] > J Then J := MaxThrVal[I];
        For I := 1 To Max_Digital_Thr Do
         If (MaxThrVal[I] < J) And (MaxThrVal[I] > 0) Then
          ConInfo.Throttle[I] := Round(ConInfo.Throttle[I] * (J / MaxThrVal[I]));

        { Scale analog axes up to the same range }

        J := 0;
        For I := 1 To Max_Digital_Ana Do
         If MaxAnaVal[I] > J Then J := MaxAnaVal[I];
        For I := 1 To Max_Digital_Ana Do
         If (MaxAnaVal[I] < J) And (MaxAnaVal[I] > 0) Then
          ConInfo.Analog[I] := Round(ConInfo.Analog[I] * (J / MaxAnaVal[I]));
      End
      Else
      Begin
(*
{        If CMap = 0 Then
        Begin}
          CMap := 0;
{          Delay(4);}
          Dec(Kick);
          If Kick <> 0 Then Goto Retry;
{        End;}
*)
      End;
    End
    Else
    Begin
(*
{      If CMap = 0 Then
      Begin}
        CMap := 0;
{        Delay(4);}
        Dec(Kick);
        If Kick <> 0 Then Goto Retry;
{      End;}
*)
    End;
  End
  Else
  Begin
(*
{    If CMap = 0 Then
    Begin}
{      CMap := 0;
      Delay(10);}
      Dec(Kick);
      If Kick <> 0 Then Goto Retry;
      CMap := 0;
{    End;}
*)
  End;
(*
  For I := 1 To Max_Digital_Axis Do
   Screen.FastWrite(1,10 + I,7,'Axis ' + IntToStr(I) + ': ' + IntToStr(ConInfo.Axis[I]) + '  ');

  For I := 1 To Max_Digital_Hat Do
   Screen.FastWrite(20,10 + I,7,'Hat ' + IntToStr(I) + ': ' + IntToStr(ConInfo.Hat[I]) + '  ');

  For I := 1 To Max_Digital_Thr Do
   Screen.FastWrite(40,10 + I,7,'Thr ' + IntToStr(I) + ': ' + IntToStr(ConInfo.Throttle[I]) + '  ');

  For I := 1 To Max_Digital_Ana Do
   Screen.FastWrite(60,10 + I,7,'Ana ' + IntToStr(I) + ': ' + IntToStr(ConInfo.Analog[I]) + '  ');
*)
End; { TSideWinderInterface.RefreshControllers }

{ ------------------ }
{ TLogitechInterface }
{ ------------------ }

Constructor TLogitechInterface.Init;
Begin
  Inherited Init('Logitech');
  FillChar(PacketLen,SizeOf(PacketLen),#0);
End; { TLogitechInterface.Init }

Destructor TLogitechInterface.Done;
Begin
  Inherited Done;
End; { TLogitechInterface.Done }

Function TLogitechInterface.GetVendorName(Slot: Integer): String;
Begin
  GetVendorName := 'Logitech';
End; { TLogitechInterface.GetVendorName }

Function TLogitechInterface.GetProductName(Slot: Integer): String;
Begin
  If (Slot >= 0) And (Slot <= 1) Then
   Case PacketLen[Slot + 1] Of
     20: GetProductName := 'ThunderPad Digital';
     42: GetProductName := 'WingMan Extreme Digital';
     64: GetProductName := 'CyberMan2';
   Else
     GetProductName := '';
   End; { Case }
End; { TLogitechInterface.GetProductName }

Function TLogitechInterface.GetSlotMap: GRIP_BITFIELD;
Var
  Slot    : Integer;
  SlotMap : GRIP_BITFIELD;

Begin
  SlotMap := 0;
  For Slot := 0 To 1 Do If PacketLen[Slot + 1] > 0 Then SlotMap := SlotMap Or (1 Shl (Slot));
  GetSlotMap := SlotMap;
End; { TLogitechInterface.GetSlotMap }

Function TLogitechInterface.GetClassMap(S: GRIP_SLOT): GRIP_BITFIELD;
Begin
  If (GetSlotMap And (1 Shl S)) <> 0 Then
  Begin
    Case PacketLen[S + 1] Of
      20: GetClassMap := (1 Shl GRIP_CLASS_BUTTON) +
                         (1 Shl GRIP_CLASS_AXIS);
      42: GetClassMap := (1 Shl GRIP_CLASS_BUTTON) +
                         (1 Shl GRIP_CLASS_POV_HAT) +
                         (1 Shl GRIP_CLASS_ANALOG);
      64: GetClassMap := (1 Shl GRIP_CLASS_BUTTON) +
                         (1 Shl GRIP_CLASS_ANALOG);
    Else
      GetClassMap := 0;
    End; { Case }
  End
  Else GetClassMap := 0;
End; { TLogitechInterface.GetClassMap }

Function TLogitechInterface.GetMaxIndex(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_INDEX;
Begin
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    Case PacketLen[S + 1] Of
      20: Begin
            Case C Of
              GRIP_CLASS_BUTTON:  GetMaxIndex := 7;
              GRIP_CLASS_AXIS:    GetMaxIndex := 1;
            Else
              GetMaxIndex := 0;
            End; { Case }
          End;
      42: Begin
            Case C Of
              GRIP_CLASS_BUTTON:  GetMaxIndex := 5;
              GRIP_CLASS_POV_HAT: GetMaxIndex := 1;
              GRIP_CLASS_ANALOG:  GetMaxIndex := 2;
            Else
              GetMaxIndex := 0;
            End; { Case }
          End;
      64: Begin
            Case C Of
              GRIP_CLASS_BUTTON:  GetMaxIndex := 7;
              GRIP_CLASS_ANALOG:  GetMaxIndex := 5;
            Else
              GetMaxIndex := 0;
            End; { Case }
          End;
    End; { Case }
  End
  Else GetMaxIndex := 0;
End; { TLogitechInterface.GetMaxIndex }

Function TLogitechInterface.GetMaxValue(S: GRIP_SLOT; C: GRIP_CLASS): GRIP_VALUE;
Begin
  If (GetClassMap(S) And (1 Shl C)) <> 0 Then
  Begin
    Case PacketLen[S + 1] Of
      20: Begin
            Case C Of
              GRIP_CLASS_AXIS:    GetMaxValue := 2;
            End; { Case }
          End;
      42: Begin
            Case C Of
              GRIP_CLASS_POV_HAT: GetMaxValue := 2;
              GRIP_CLASS_ANALOG:  GetMaxValue := 255;
            End; { Case }
          End;
      64: Begin
            Case C Of
              GRIP_CLASS_ANALOG:  GetMaxValue := 255;
            End; { Case }
          End;
    End; { Case }
  End
  Else GetMaxValue := 0;
End; { TLogitechInterface.GetMaxValue }

Procedure TLogitechInterface.LoadConfiguration(F: PINIFile);
Begin
  Inherited LoadConfiguration(F);
  PacketLen[1] := F^.ReadInteger(Name,'PACKETLEN1',0);
  PacketLen[2] := F^.ReadInteger(Name,'PACKETLEN2',0);
End; { TLogitechInterface.LoadConfiguration }

Procedure TLogitechInterface.SaveConfiguration(F: PINIFile);
Begin
  Inherited SaveConfiguration(F);
  F^.WriteInteger(Name,'PACKETLEN1',PacketLen[1]);
  F^.WriteInteger(Name,'PACKETLEN2',PacketLen[2]);
End; { TLogitechInterface.SaveConfiguration }

Var F: File;

Procedure TLogitechInterface.Activate;
Var
  Channel1 : TDigitalPacket;
  ChBase   : Array[1..2] Of Word;

Begin

  Assign(F,'SW.LOG');
  ReWrite(F,1);

  Inherited Activate;
  Port[JoyPort] := $FF;    { Analog delay sequence }
  Delay(2);
  Port[JoyPort] := $FF;
  Delay(3);
  Port[JoyPort] := $FF;
  Delay(10);

  Port[JoyPort] := $FF;    { Digital delay sequence }
  Delay(6);
  Port[JoyPort] := $FF;
  Delay(11);
  Port[JoyPort] := $FF;
  Delay(10);
  Port[JoyPort] := $FF;
  Delay(9);
  Port[JoyPort] := $FF;
  Delay(10);
  ReadPacket(Channel1,ChBase[1],ChBase[2]);
  Delay(10);

  Close(F);

End; { TLogitechInterface.Activate }

Procedure TLogitechInterface.ReadPacket(Var Packet: TDigitalPacket; Var ChBase1,ChBase2: Word);
Var
  Channel1 : TDigitalPacket;
  Channel2 : TDigitalPacket;
  Count    : LongInt;
  ChLen    : Array[1..2] Of Word;
  I,J      : Integer;

Begin
  Count := MaxJoyCount;
  FillChar(Channel1,SizeOf(Channel1),#0);{ Initialize with zeroes }
  FillChar(Channel2,SizeOf(Channel2),#0);
  Asm
    MOV   DX,JoyPort                     { Reset the joystick port }
    MOV   AL,0FFh
    OUT   DX,AL
    IN    AL,DX                          { Read the initial value }
    MOV   BL,AL                          { Save the initial value }
    DB    _32BIT_OPERAND                 { Set the time counter }
    MOV   CX,WORD PTR Count
    SUB   SI,SI                          { Packet 0 pointer }
    SUB   DI,DI                          { Packet 1 pointer }
@PacketLoop:
    DB    _32BIT_OPERAND                 { Decrement the counter }
    DEC   CX
    JS    @GetOut                        { Exit if timeout }
    IN    AL,DX                          { Read a byte }
    MOV   BH,AL                          { Save it }
    XOR   AL,BL                          { See if anything has changed }
    JZ    @PacketLoop
{
    TEST  AL,03h
    JNZ   @Channel1IsZero
    TEST  AL,0Ch
    JNZ   @Channel2IsZero
}
    TEST  AL,30h                         { Check the first channel }
    JZ    @CheckChannel2
    TEST  AL,20h                         { If a 1 is transmitted, save it }
    JZ    @Channel1IsZero
    TEST  AL,10h                         { Exit if at the end of the packet }
    JNZ   @GetOut
    MOV   BYTE PTR Channel1[SI],1
@Channel1IsZero:
    INC   SI
    CMP   SI,MaxChannelLength
    JAE   @GetOut
@CheckChannel2:
    TEST  AL,0C0h                        { Check the second channel }
    JZ    @NextByte
    TEST  AL,80h                         { If a 1 is transmitted, save it }
    JZ    @Channel2IsZero
    TEST  AL,40h                         { Exit if at the end of the packet }
    JNZ   @GetOut
    MOV   BYTE PTR Channel2[DI],1
@Channel2IsZero:
    INC   DI
    CMP   DI,MaxChannelLength
    JAE   @GetOut
@NextByte:
    MOV   BL,BH                          { Save the byte that was read }
    JMP   @PacketLoop
@GetOut:
    DB    _32BIT_OPERAND                 { Save the final counter }
    MOV   WORD PTR Count,CX
    MOV   WORD PTR ChLen[0],SI
    MOV   WORD PTR ChLen[2],DI
  End; { Asm }

  BlockWrite(F,Channel1,SizeOf(Channel1));

{
  Screen.FastWrite(1,1,7,'ChLen[1]: ' + IntToStr(ChLen[1]) + ' ' +
                         'ChLen[1]: ' + IntToStr(ChLen[2]) + ' ' +
                         'Count: ' + IntToStr(Count) + ' ');
}
{
  Popup('ChLen[1]:' + IntToStr(ChLen[1]) + '  ' +
        'ChLen[2]:' + IntToStr(ChLen[2]) + '  ' +
        'Count:' + IntToStr(Count));
}
  { Evaluate the packet }

  If (Count >= 0)                               And
     ((ChLen[1] + ChLen[2]) < MaxChannelLength) Then
  Begin

    { Concatenate the channels }

    For I := 0 To ChLen[2] - 1 Do Channel1[ChLen[1] + I] := Channel2[I];
    ChBase1 := 0;
    ChBase2 := ChLen[1];
    FillChar(ConInfo,SizeOf(ConInfo),#0);
    Case ChLen[1] Of
      21,42: PacketLen[1] := 42;
      32,64: PacketLen[1] := 64;
      10,20: PacketLen[1] := 20;
    End; { Case }
    If ChLen[1] = PacketLen[1]
     Then PacketLen[2] := ChLen[2]
     Else PacketLen[2] := 0;
  End;
End; { TLogitechInterface.ReadPacket }

Procedure TLogitechInterface.RefreshControllers;
Const
  Hat_To_Axis: Array[0..8] Of TXYPoint =
   ((X: 0; Y: 0),
    (X: 0; Y:-1),
    (X: 1; Y:-1),
    (X: 1; Y: 0),
    (X: 1; Y: 1),
    (X: 0; Y: 1),
    (X:-1; Y: 1),
    (X:-1; Y: 0),
    (X:-1; Y:-1));

Var
  Channel1 : TDigitalPacket;
  ChBase   : Array[1..2] Of Word;
  I,J      : Integer;
  Hat      : Byte;

Begin
  ReadPacket(Channel1,ChBase[1],ChBase[2]);
  If (PacketLen[1] > 0) Or (PacketLen[2] > 0) Then
  Begin
    Hat     := 0;
    For I := 1 To 2 Do
    Begin
      Case PacketLen[I] Of
        20: Begin
              For J := 11 DownTo 8 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Buttons := ConInfo.Buttons Or (1 Shl (11 - J));
              For J := 3 DownTo 0 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Buttons := ConInfo.Buttons Or (1 Shl (7 - J));
               ConInfo.Axis[1] := 1;  { Center position is the default }
               ConInfo.Axis[2] := 1;
                   If Channel1[4 + ChBase[I]] <> 0 Then ConInfo.Axis[1] := 0
              Else If Channel1[6 + ChBase[I]] <> 0 Then ConInfo.Axis[1] := 2;
                   If Channel1[7 + ChBase[I]] <> 0 Then ConInfo.Axis[2] := 0
              Else If Channel1[5 + ChBase[I]] <> 0 Then ConInfo.Axis[2] := 2;
            End;
        42: Begin
              For J := 4 To 9 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Buttons := ConInfo.Buttons Or (1 Shl (J - 4));
              For J := 33 DownTo 26 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[1] := ConInfo.Analog[1] Or (1 Shl (J - 26));
              For J := 25 DownTo 18 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[2] := ConInfo.Analog[2] Or (1 Shl (J - 18));
              For J := 17 DownTo 10 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[3] := ConInfo.Analog[3] Or (1 Shl (J - 10));
              For J := 3 DownTo 0 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                Hat := Hat Or (1 Shl (J - 3));
              Case Hat Of
              0..8: Begin
                      ConInfo.Hat[1] := Hat_To_Axis[Hat].X + 1;
                      ConInfo.Hat[2] := Hat_To_Axis[Hat].Y + 1;
                    End;
              End; { Case }
            End;
        64: Begin
              For J := 0 To 7 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Buttons := ConInfo.Buttons Or (1 Shl (J - 0));
              For J := 15 DownTo 8 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[6] := ConInfo.Analog[6] Or (1 Shl (J - 8));
              For J := 23 DownTo 16 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[5] := ConInfo.Analog[5] Or (1 Shl (J - 16));
              For J := 31 DownTo 24 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[4] := ConInfo.Analog[4] Or (1 Shl (J - 24));
              For J := 39 DownTo 32 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[3] := ConInfo.Analog[3] Or (1 Shl (J - 32));
              For J := 47 DownTo 40 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[2] := ConInfo.Analog[2] Or (1 Shl (J - 40));
              For J := 55 DownTo 48 Do
               If Channel1[J + ChBase[I]] <> 0 Then
                ConInfo.Analog[1] := ConInfo.Analog[1] Or (1 Shl (J - 48));
            End;
      End; { Case }
    End; { For I }
  End;
End; { TLogitechInterface.RefreshControllers }

{ ---------------------- }
{ TExternalInterface     }
{ ---------------------- }

Constructor TExternalInterface.Init;
Begin
  Inherited Init('External');
  Wrote := 0;
  FillChar(LPTCap,SizeOf(LPTCap),#0);
  FillChar(JoyCap,SizeOf(JoyCap),#0);
  Deactivate;
End; { TExternalInterface.Init }

Destructor TExternalInterface.Done;
Begin
  Deactivate;
  Inherited Done;
End; { TExternalInterface.Done }

Procedure TExternalInterface.Deactivate;
Var
  LPTPort : Word;
  LPT     : Integer;
  OldPort : Byte;

Begin

  { Set all ports to output }

  For LPT := 0 To 2 Do
  Begin
    LPTPort := MemW[0:$408 + LPT * 2];
    If LPTPort <> 0 Then
    Begin
      OldPort := Port[LPTPort + 2];
      Port[LPTPort + 2] := OldPort And $DF;
    End;
  End; { For LPT }
End; { TExternalInterface.Deactivate }

Procedure TExternalInterface.LoadConfiguration(F: PINIFile);
Var LPT: Integer;
Begin
  Inherited LoadConfiguration(F);
  For LPT := 0 To 2 Do
   ReadCapability(F,Name,'L' + IntToStr(LPT),LPTCap[LPT]);
  ReadCapability(F,Name,'J',JoyCap.Cap);
  JoyCap.Min   := F^.ReadInteger(Name,'JMIN',0);
  JoyCap.Mid   := F^.ReadInteger(Name,'JMID',0);
  JoyCap.Max   := F^.ReadInteger(Name,'JMAX',0);
End; { TExternalInterface.LoadConfiguration }

Procedure TExternalInterface.SaveConfiguration(F: PINIFile);
Var LPT: Integer;
Begin
  Inherited SaveConfiguration(F);
  Inherited LoadConfiguration(F);
  For LPT := 0 To 2 Do
   WriteCapability(F,Name,'L' + IntToStr(LPT),LPTCap[LPT]);
  WriteCapability(F,Name,'J',JoyCap.Cap);
  F^.WriteInteger(Name,'JMIN',JoyCap.Min);
  F^.WriteInteger(Name,'JMID',JoyCap.Mid);
  F^.WriteInteger(Name,'JMAX',JoyCap.Max);
End; { TExternalInterface.SaveConfiguration }

Procedure TExternalInterface.Configure;
Var
  Menu : PMenu;
  I    : Integer;
  JoyB : Byte;
  JoyX : LongInt;
  JoyY : LongInt;
  C    : Char;
  MaxJ : Integer;
  OldX : Integer;
  NewX : Integer;
  St1  : String[1];
  St2  : String[1];

Begin
  Inherited Configure;
  Menu := New(PMenu,InitWH(46,6,
              Black,LightGray,Black,LightGray,Blue,LightGray,
              Red,LightGray,Black,Green,Red,Green,
              DarkGray,LightGray,DarkGray,Green,
              SingleBorder,' External port configuration ',
              ' <Enter> selects, <Esc> exits ',True));
  Menu^.AddSelection(1, 1,22,3,False,((JoyCap.Cap.A And imPaddleAxis) <> 0),'  Calibrate paddles');
  Menu^.AddSelection(1, 4,22,3,False,((JoyCap.Cap.A And imPaddleAxis) =  0),'  None');
  For I := 0 To 2 Do
  Begin
    If MemW[0:$408 + I * 2] <> 0 Then
     Menu^.AddSelection(23,I + 1,22,6,False,UsedCapability(LPTCap[I]),'  LPT' + IntToStr(I + 1));
  End; { For I }
  Menu^.AddSelection(23, 4,22,3,False,Not (UsedCapability(LPTCap[0]) Or
                                           UsedCapability(LPTCap[1]) Or
                                           UsedCapability(LPTCap[2])),'  None');
  Repeat
    Menu^.Execute;

    { If a port is enabled, set the capabliity, otherwise clear it }

    Case Menu^.CurSel Of
      1: Begin
           JoyCap.Cap.A := imPaddleAxis + imCBS + imJoyBtn + imDrivingBtn;
           StayPopup4('Rotate paddle 1 to its extremes several times and press any key,',
                      '                    or hit <Esc> to exit:',
                      '',
                      '  [                                                          ]');
           MaxJ := 0;
           OldX := (_Win^.X2 - _Win^.X1) Div 2;
           St1  := ' ';
           St2  := '*';
           Repeat
             JoyStatus(1,JoyB,JoyX,JoyY);

             If JoyY >= 0 Then
             Begin
               If (JoyY > MaxJ) And (JoyY <= MaxJoyCount) Then MaxJ := JoyY;
               If JoyY <= MaxJ Then
               Begin
                 Screen.FastWrite(Lo(Screen.WindMin) + OldX + 6,Hi(Screen.WindMin) + 4,Screen.TextAttr,St1);
                 NewX := Trunc((1 - (JoyY / MaxJ)) * ((_Win^.X2 - _Win^.X1) - 10));
                 Screen.FastWrite(Lo(Screen.WindMin) + NewX + 6,Hi(Screen.WindMin) + 4,Screen.TextAttr,St2);
                 OldX := NewX;
               End;
             End;
           Until KeyPressed;
           C := ReadKey;
           Dispose(_Win,Done);
           If C <> #27 Then
           Begin
             JoyCap.Max := MaxJ;
             JoyCap.Min := 0;
             JoyCap.Mid := MaxJ Div 2;
           End;
         End;
      2: JoyCap.Cap.A := imCBS + imJoyBtn + imDrivingBtn;
      3: Begin
           LPTCap[0].A := imPaddleBtn +
                          imJoy1X + imJoy1Y + imJoy2X + imJoy2Y +
                          imDriving;
           LPTCap[1].A := 0;
           LPTCap[2].A := 0;
           LPTCap[0].B := imKeyboard;
           LPTCap[1].B := 0;
           LPTCap[2].B := 0;
         End;
      4: Begin
           LPTCap[0].A := 0;
           LPTCap[1].A := imPaddleBtn +
                          imJoy1X + imJoy1Y + imJoy2X + imJoy2Y +
                          imDriving;
           LPTCap[2].A := 0;
           LPTCap[0].B := 0;
           LPTCap[1].B := imKeyboard;
           LPTCap[2].B := 0;
         End;
      5: Begin
           LPTCap[0].A := 0;
           LPTCap[1].A := 0;
           LPTCap[2].A := imPaddleBtn +
                          imJoy1X + imJoy1Y + imJoy2X + imJoy2Y +
                          imDriving;
           LPTCap[0].B := 0;
           LPTCap[1].B := 0;
           LPTCap[2].B := imKeyboard;
         End;
      6: Begin
           LPTCap[0].A := 0;
           LPTCap[1].A := 0;
           LPTCap[2].A := 0;
           LPTCap[0].B := 0;
           LPTCap[1].B := 0;
           LPTCap[2].B := 0;
         End;
    End; { Case }
  Until Menu^.CurSel = 0;
  Dispose(Menu,Done);
End; { TExternalInterface.Configure }

Procedure TExternalInterface.GetControllerInfo(Var Controllers: TCapability;
                                           Var Info: TAtariControls);
Var
  CapMask : TCapability;
  Pad1X   : LongInt;
  Pad2X   : LongInt;
  Pad3X   : LongInt;
  Pad4X   : LongInt;
  Pad1Cap : TCapability;
  Pad2Cap : TCapability;
  Pad3Cap : TCapability;
  Pad4Cap : TCapability;
  Joy1Cap : TCapability;
  Joy2Cap : TCapability;
  JoyB    : Byte;
  LPT     : Integer;
  LPTPort : Word;
  OldPort : Byte;
  B       : Byte;
  OldCont : TCapability;

Begin

  { Copy the initial controller list }

  OldCont := Controllers;

  { Initialize the capability mask to include all capabliities }

  SetAllCapability(CapMask);

  { Poll the joystick port }

  If ((Controllers.A And imPaddleAxis) <> 0) Or
     ((Controllers.B And imKeyboard)   <> 0) Then
  Begin
    JoyStatus(1,JoyB,Pad2X,Pad1X);
    JoyStatus(2,JoyB,Pad4X,Pad3X);
  End
  Else
  Begin
    JoyStatusButtons(JoyB);
    Pad1X := 0;
    Pad2X := 0;
    Pad3X := 0;
    Pad4X := 0;
  End;

  { Process analog portion of joystick port (requires calibration) }

  If (JoyCap.Cap.A And imPaddleAxis) <> 0 Then
  Begin
    Pad1Cap.A := JoyCap.Cap.A And imPaddle1Axis;
    Pad2Cap.A := JoyCap.Cap.A And imPaddle2Axis;
    Pad3Cap.A := JoyCap.Cap.A And imPaddle3Axis;
    Pad4Cap.A := JoyCap.Cap.A And imPaddle4Axis;
    Pad1Cap.B := JoyCap.Cap.B;
    Pad2Cap.B := JoyCap.Cap.B;
    Pad3Cap.B := JoyCap.Cap.B;
    Pad4Cap.B := JoyCap.Cap.B;

    If Pad1X <= JoyCap.Max Then
     GetAnalog(JoyCap.Min,JoyCap.Mid,JoyCap.Max,JoyCap.Max - Pad1X,0,Pad1Cap,CapMask,Controllers,Info);
    If Pad2X <= JoyCap.Max Then
     GetAnalog(JoyCap.Min,JoyCap.Mid,JoyCap.Max,JoyCap.Max - Pad2X,0,Pad2Cap,CapMask,Controllers,Info);
    If Pad3X <= JoyCap.Max Then
     GetAnalog(JoyCap.Min,JoyCap.Mid,JoyCap.Max,JoyCap.Max - Pad3X,0,Pad3Cap,CapMask,Controllers,Info);
    If Pad4X <= JoyCap.Max Then
     GetAnalog(JoyCap.Min,JoyCap.Mid,JoyCap.Max,JoyCap.Max - Pad4X,0,Pad4Cap,CapMask,Controllers,Info);
  End;

  { Process digital portion of joystick port }

  Joy1Cap.A := JoyCap.Cap.A And (ifJoy1Btn Or ifDriving1Btn);
  Joy2Cap.A := JoyCap.Cap.A And (ifJoy2Btn Or ifDriving2Btn);
  Joy1Cap.B := JoyCap.Cap.B;
  Joy2Cap.B := JoyCap.Cap.B;
  GetDigitalAny((JoyB And 1) <> 0,Joy1Cap,CapMask,Controllers,Info);
  GetDigitalAny((JoyB And 2) <> 0,Joy2Cap,CapMask,Controllers,Info);

  Joy1Cap.A := JoyCap.Cap.A And ifCBSBtn1;
  Joy2Cap.A := JoyCap.Cap.A And ifCBSBtn2;
  Joy1Cap.B := JoyCap.Cap.B;
  Joy2Cap.B := JoyCap.Cap.B;

  GetDigitalAny(Pad1X < Round(MaxJoyCount * 0.02),Joy1Cap,CapMask,Controllers,Info);
  GetDigitalAny(Pad2X < Round(MaxJoyCount * 0.02),Joy2Cap,CapMask,Controllers,Info);

  { Process parallel port }

  For LPT := 0 To 2 Do
  Begin
    If UsedCapability(LPTCap[LPT]) Then
    Begin
      LPTPort := MemW[0:$408 + LPT * 2];
      If LPTPort <> 0 Then
      Begin
        If ReadMask <> 0 Then
        Begin

          { Set to input }

          OldPort := Port[LPTPort + 2];

          If (OldPort And $20) = 0 Then Port[LPTPort + 2] := OldPort Or $20;

          { Read the data }

          B := Port[LPTPort];
          Info.PortA := B;

          { Set the port back to whatever it was }

          Port[LPTPort + 2] := OldPort;

          { Write any data that had been written }

          If (OldPort And $20) = 0 Then Port[LPTPort] := Wrote;

          { Kill all remaining capabilities }

          FillChar(CapMask,SizeOf(CapMask),#0);
        End;
      End;
    End;
  End; { For LPT }

  { Special processing for Indy 500 controllers }

  If (OldCont.A And imDriving1Axis) <> 0 Then
  Begin
    For B := 0 To 3 Do
     If Indy500Trans1[B] = (Info.PortA Or $F) Then Info.Driv[1] := B * 4;
  End;
  If (OldCont.A And imDriving2Axis) <> 0 Then
  Begin
    For B := 0 To 3 Do
     If Indy500Trans2[B] = (Info.PortA Or $F0) Then Info.Driv[2] := B * 4;
  End;

  If ((OldCont.B And imKB1) <> 0) And (ReadMask <> $FF) Then
  Begin
    If (Wrote And $10) = 0 Then
    Begin
      If Pad1X > MaxJoyCount Then Info.KB := Info.KB Or $00000010;
      If Pad2X > MaxJoyCount Then Info.KB := Info.KB Or $00001000;
      If (JoyB And 1) <> 0   Then Info.KB := Info.KB Or $00100000;
    End;
    If (Wrote And $20) = 0 Then
    Begin
      If Pad1X > MaxJoyCount Then Info.KB := Info.KB Or $00000020;
      If Pad2X > MaxJoyCount Then Info.KB := Info.KB Or $00002000;
      If (JoyB And 1) <> 0   Then Info.KB := Info.KB Or $00200000;
    End;
    If (Wrote And $40) = 0 Then
    Begin
      If Pad1X > MaxJoyCount Then Info.KB := Info.KB Or $00000040;
      If Pad2X > MaxJoyCount Then Info.KB := Info.KB Or $00004000;
      If (JoyB And 1) <> 0   Then Info.KB := Info.KB Or $00400000;
    End;
    If (Wrote And $80) = 0 Then
    Begin
      If Pad1X > MaxJoyCount Then Info.KB := Info.KB Or $00000080;
      If Pad2X > MaxJoyCount Then Info.KB := Info.KB Or $00008000;
      If (JoyB And 1) <> 0   Then Info.KB := Info.KB Or $00800000;
    End;
    CapMask.B := CapMask.B And imNoKB1;
  End;

  If ((OldCont.B And imKB2) <> 0) And (ReadMask <> $FF) Then
  Begin
    If (Wrote And $1) = 0 Then
    Begin
      If Pad3X > MaxJoyCount Then Info.KB := Info.KB Or $00000001;
      If Pad4X > MaxJoyCount Then Info.KB := Info.KB Or $00000100;
      If (JoyB And 2) <> 0   Then Info.KB := Info.KB Or $00010000;
    End;
    If (Wrote And $2) = 0 Then
    Begin
      If Pad3X > MaxJoyCount Then Info.KB := Info.KB Or $00000002;
      If Pad4X > MaxJoyCount Then Info.KB := Info.KB Or $00000200;
      If (JoyB And 2) <> 0   Then Info.KB := Info.KB Or $00020000;
    End;
    If (Wrote And $4) = 0 Then
    Begin
      If Pad3X > MaxJoyCount Then Info.KB := Info.KB Or $00000004;
      If Pad4X > MaxJoyCount Then Info.KB := Info.KB Or $00000400;
      If (JoyB And 2) <> 0   Then Info.KB := Info.KB Or $00040000;
    End;
    If (Wrote And $8) = 0 Then
    Begin
      If Pad3X > MaxJoyCount Then Info.KB := Info.KB Or $00000008;
      If Pad4X > MaxJoyCount Then Info.KB := Info.KB Or $00000800;
      If (JoyB And 2) <> 0   Then Info.KB := Info.KB Or $00080000;
    End;
    CapMask.B := CapMask.B And imNoKB2;
  End;

  { Remove capabilities that were used }

  AndCapabilities(CapMask,Controllers);
End; { TExternalInterface.GetControllerInfo }

Procedure TExternalInterface.WriteToPort(B: Byte);
Var
  LPTPort : Word;
  LPT     : Integer;
  OldPort : Byte;

Begin
  For LPT := 0 To 2 Do
  Begin
    If UsedCapability(LPTCap[LPT]) Then
    Begin
      LPTPort := MemW[0:$408 + LPT * 2];
      If LPTPort <> 0 Then
      Begin
        If ReadMask <> $FF Then
        Begin

          { Set to output }

          OldPort := Port[LPTPort + 2];
          Port[LPTPort + 2] := OldPort And $DF;

          { Write the data }

          Port[LPTPort] := B And (ReadMask Xor $FF);
          Wrote         := B And (ReadMask Xor $FF);
        End;
      End;
    End;
  End; { For LPT }
End; { TExternalInterface.WriteToPort }

{ ---------- }
{ Other code }
{ ---------- }

{$F+}
Procedure NewExitProc;
Begin
  Dispose(InterfaceHandler,Done);
  ExitProc := OldExitProc;
End; { NewExitProc }
{$F-}

Procedure GetMaxJoyCount;
Const
  WaitTime = 300;  { 300 ms }
  ReadTime = 6;    { 6 ms   }

Var
  T1,T2     : LongInt; { Millisecond timers }
  Count     : LongInt; { Iteration count    }
  Both      : LongInt; { Iteration count    }
  ClockOnly : LongInt; { Time in ms         }
  JoyTime   : LongInt; { Time in ms         }

  Function RoundUp(E: Extended): LongInt;
  Begin
    If E < 0 Then
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) - 1 Else RoundUp := Trunc(E);
    End
    Else
    Begin
      If Frac(E) <> 0 Then RoundUp := Trunc(E) + 1 Else RoundUp := Trunc(E);
    End;
  End; { RoundUp }

Label TimerLoop;
Begin
  MaxJoyCount := 0;

  { Find out how long it takes to read both the clock and the joystick }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;

    { Reset the joystick port }

    Port[JoyPort] := 0;

    { Perform the loop }

    Asm
      DB     _32BIT_OPERAND  { Reset the counter }
      SUB    BX,BX
TimerLoop:
      IN     AL,DX           { Read and dummy test }
      TEST   AL,1            { Player 1 X coordinate }
      JZ     @L4
      DB     _32BIT_OPERAND  { Dummy increment }
      INC    AX
    @L4:
      DB     _32BIT_OPERAND  { The real increment }
      INC    BX

      DB     _32BIT_OPERAND  { Save registers }
      PUSH   BX
      PUSH   DX
    End; { Asm }
    T2 := Clock;
    Asm
      POP    DX              { Restore registers }
      DB     _32BIT_OPERAND
      POP    BX

      DB     _32BIT_OPERAND  { Check elapsed time }
      MOV    AX,WORD PTR T2
      DB     _32BIT_OPERAND
      SUB    AX,WORD PTR T1
      DB     _32BIT_OPERAND
      CMP    AX,WaitTime
      DW     0
      JB     TimerLoop
      DB     _32BIT_OPERAND
      MOV    WORD PTR Count,BX
    End; { Asm }
  Until T2 >= T1 + WaitTime;
  Both := Count;

  { Now find out how long it takes to do everything we did above except  }
  { read the joystick port                                               }

  { The repeat loop is needed because Windows 98 sometimes makes time go }
  { backwards!  We need a good reading.                                  }

  Repeat
    T1 := Clock;
    While Count > 0 Do
    Begin

      { Include what we did above }

      Asm
        DB     _32BIT_OPERAND  { Save registers }
        PUSH   BX
        PUSH   DX
      End; { Asm }

      T2 := Clock;

      Asm
        POP    DX              { Restore registers }
        DB     _32BIT_OPERAND
        POP    BX
        DB     _32BIT_OPERAND  { Check elapsed time }
        MOV    AX,WORD PTR T2
        DB     _32BIT_OPERAND
        SUB    AX,WORD PTR T1
        DB     _32BIT_OPERAND
        CMP    AX,WaitTime
        DW     0
        JB     @L1
        DB     _32BIT_OPERAND  { Do anythng here (likely won't be executed) }
        MOV    AX,WORD PTR T2
@L1:
      End; { Asm }

      Dec(Count);
    End; { While }
  Until T2 >= T1;
  ClockOnly := T2 - T1;

  { The time we spent actually reading the port is WaitTime - ClockOnly. }
  { Calculate the number of joystick read iterations that we can perform }
  { in 3 ms. If WaitTime - ClockOnly is zero, force it to one, but this  }
  { really should never happen.                                          }

  JoyTime := WaitTime - ClockOnly;
  If JoyTime <= 0 Then JoyTime := 1;

  MaxJoyCount := RoundUp(ReadTime * (Both / JoyTime));
End; { GetMaxJoyCount }

Begin
  GetMaxJoyCount;
  OldExitProc      := ExitProc;
  ExitProc         := @NewExitProc;
  InterfaceHandler := New(PInterfaceHandler,Init);
End.

// ----------------------------------------------------------------------
// PCAE - PC Atari Emulator - Atari 2600 Emulator for MS-DOS
// Copyright (C) 2000 John Dullea
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// ----------------------------------------------------------------------

